unit FrmStore;

{

   COPYRIGHT 2013 .. 2016 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.
}

interface

uses

  WinApi.Windows, WinApi.Messages, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Buttons, Vcl.Imaging.jpeg, Vcl.ImgList, Vcl.Samples.Spin,
  Vcl.Imaging.pngimage, Vcl.Menus, System.Generics.Collections,

  KnobsUtils, knobs2013, KnobsWorms, Led;

type

  TOnDesignerLog        = procedure( const aSender: TObject; const aMsg: string)                           of object;
  TOnGetForthDetailInfo = procedure( const aSender: TObject; aModuleId: Integer; const aList: TStringList) of object;

  TFormStore = class(TForm)
    ImageListEnvOutputType: TImageList;
    ImageListGateTypes: TImageList;
    ImageListLfoOutputType: TImageList;
    ImageListLogLinExpSTypeAttack: TImageList;
    ImageListLogLinExpSTypeRelease: TImageList;
    ImageListMuteTypes: TImageList;
    ImageListSoloTypes: TImageList;
    ImageListStandardLFOWaveShapes: TImageList;
    ImageListStandardWaveShapes: TImageList;
    adc: TKnobsModule;
    adc_editlabel: TKnobsEditLabel;
    adc_in: TKnobsInput;
    adc_indicator_out0: TKnobsIndicator;
    adc_indicator_out10: TKnobsIndicator;
    adc_indicator_out11: TKnobsIndicator;
    adc_indicator_out12: TKnobsIndicator;
    adc_indicator_out13: TKnobsIndicator;
    adc_indicator_out14: TKnobsIndicator;
    adc_indicator_out15: TKnobsIndicator;
    adc_indicator_out1: TKnobsIndicator;
    adc_indicator_out2: TKnobsIndicator;
    adc_indicator_out3: TKnobsIndicator;
    adc_indicator_out4: TKnobsIndicator;
    adc_indicator_out5: TKnobsIndicator;
    adc_indicator_out6: TKnobsIndicator;
    adc_indicator_out7: TKnobsIndicator;
    adc_indicator_out8: TKnobsIndicator;
    adc_indicator_out9: TKnobsIndicator;
    adc_out0: TKnobsOutput;
    adc_out10: TKnobsOutput;
    adc_out11: TKnobsOutput;
    adc_out12: TKnobsOutput;
    adc_out13: TKnobsOutput;
    adc_out14: TKnobsOutput;
    adc_out15: TKnobsOutput;
    adc_out1: TKnobsOutput;
    adc_out2: TKnobsOutput;
    adc_out3: TKnobsOutput;
    adc_out4: TKnobsOutput;
    adc_out5: TKnobsOutput;
    adc_out6: TKnobsOutput;
    adc_out7: TKnobsOutput;
    adc_out8: TKnobsOutput;
    adc_out9: TKnobsOutput;
    adc_textlabel_0: TKnobsTextLabel;
    adc_textlabel_10: TKnobsTextLabel;
    adc_textlabel_11: TKnobsTextLabel;
    adc_textlabel_12: TKnobsTextLabel;
    adc_textlabel_13: TKnobsTextLabel;
    adc_textlabel_14: TKnobsTextLabel;
    adc_textlabel_15: TKnobsTextLabel;
    adc_textlabel_1: TKnobsTextLabel;
    adc_textlabel_2: TKnobsTextLabel;
    adc_textlabel_3: TKnobsTextLabel;
    adc_textlabel_4: TKnobsTextLabel;
    adc_textlabel_5: TKnobsTextLabel;
    adc_textlabel_6: TKnobsTextLabel;
    adc_textlabel_7: TKnobsTextLabel;
    adc_textlabel_8: TKnobsTextLabel;
    adc_textlabel_9: TKnobsTextLabel;
    adc_textlabel_in: TKnobsTextLabel;
    amplifier: TKnobsModule;
    amplifier_display_gain: TKnobsDisplay;
    amplifier_editlabel: TKnobsEditLabel;
    amplifier_gain: TKnobsSmallKnob;
    amplifier_in1: TKnobsInput;
    amplifier_in2: TKnobsInput;
    amplifier_in3: TKnobsInput;
    amplifier_in4: TKnobsInput;
    amplifier_mode: TKnobsSelector;
    amplifier_mute: TKnobsSelector;
    amplifier_out1: TKnobsOutput;
    amplifier_out2: TKnobsOutput;
    amplifier_out3: TKnobsOutput;
    amplifier_out4: TKnobsOutput;
    attractor: TKnobsModule;
    attractor_display_frequency: TKnobsDisplay;
    attractor_editlabel: TKnobsEditLabel;
    attractor_fm: TKnobsInput;
    attractor_fmlevel: TKnobsSmallKnob;
    attractor_freq: TKnobsInput;
    attractor_frequency: TKnobsSmallKnob;
    attractor_mode: TKnobsSelector;
    attractor_mute: TKnobsSelector;
    attractor_outx: TKnobsOutput;
    attractor_outy: TKnobsOutput;
    attractor_outz: TKnobsOutput;
    attractor_textlabel_fm: TKnobsTextLabel;
    attractor_textlabel_freq: TKnobsTextLabel;
    attractor_textlabel_x: TKnobsTextLabel;
    attractor_textlabel_y: TKnobsTextLabel;
    attractor_textlabel_z: TKnobsTextLabel;
    attractorlfo: TKnobsModule;
    attractorlfo_display_frequency: TKnobsDisplay;
    attractorlfo_editlabel: TKnobsEditLabel;
    attractorlfo_fm: TKnobsInput;
    attractorlfo_fmlevel: TKnobsSmallKnob;
    attractorlfo_frequency: TKnobsSmallKnob;
    attractorlfo_indicator_outx: TKnobsIndicator;
    attractorlfo_indicator_outy: TKnobsIndicator;
    attractorlfo_indicator_outz: TKnobsIndicator;
    attractorlfo_mode: TKnobsSelector;
    attractorlfo_mute: TKnobsSelector;
    attractorlfo_outputtype: TKnobsSelector;
    attractorlfo_outx: TKnobsOutput;
    attractorlfo_outy: TKnobsOutput;
    attractorlfo_outz: TKnobsOutput;
    attractorlfo_range: TKnobsSelector;
    attractorlfo_textlabel_fm: TKnobsTextLabel;
    attractorlfo_textlabel_outx: TKnobsTextLabel;
    attractorlfo_textlabel_outy: TKnobsTextLabel;
    attractorlfo_textlabel_outz: TKnobsTextLabel;
    audioin: TKnobsModule;
    audioin_editlabel: TKnobsEditLabel;
    audioin_out1: TKnobsOutput;
    audioin_out2: TKnobsOutput;
    audioin_out3: TKnobsOutput;
    audioin_out4: TKnobsOutput;
    audioin_out5: TKnobsOutput;
    audioin_out6: TKnobsOutput;
    audioin_out7: TKnobsOutput;
    audioin_out8: TKnobsOutput;
    audioin_textlabel: TKnobsTextLabel;
    audiomix: TKnobsModule;
    audiomix_mute1: TKnobsSelector;
    audiomix_mute2: TKnobsSelector;
    audiomix_mute3: TKnobsSelector;
    audiomix_mute4: TKnobsSelector;
    audiomix_mute5: TKnobsSelector;
    audiomix_mute6: TKnobsSelector;
    audiomix_mute7: TKnobsSelector;
    audiomix_mute8: TKnobsSelector;
    audiomix_solo1: TKnobsSelector;
    audiomix_solo2: TKnobsSelector;
    audiomix_solo3: TKnobsSelector;
    audiomix_solo4: TKnobsSelector;
    audiomix_solo5: TKnobsSelector;
    audiomix_solo6: TKnobsSelector;
    audiomix_solo7: TKnobsSelector;
    audiomix_solo8: TKnobsSelector;
    audioout: TKnobsModule;
    audioout_editlabel: TKnobsEditLabel;
    audioout_in1: TKnobsInput;
    audioout_in2: TKnobsInput;
    audioout_in3: TKnobsInput;
    audioout_in4: TKnobsInput;
    audioout_in5: TKnobsInput;
    audioout_in6: TKnobsInput;
    audioout_in7: TKnobsInput;
    audioout_in8: TKnobsInput;
    audioout_textlabel: TKnobsTextLabel;
    avg: TKnobsModule;
    avg_alpha: TKnobsSmallKnob;
    avg_alphamod: TKnobsInput;
    avg_alphamodamt: TKnobsSmallKnob;
    avg_editlabel: TKnobsEditLabel;
    avg_hp: TKnobsOutput;
    avg_in: TKnobsInput;
    avg_lp: TKnobsOutput;
    avg_textlabel_in: TKnobsTextLabel;
    avg_textlabel_invout: TKnobsTextLabel;
    avg_textlabel_out: TKnobsTextLabel;
    chebgen: TKnobsModule;
    chebgen_editlabel: TKnobsEditLabel;
    chebgen_in: TKnobsInput;
    chebgen_out10: TKnobsOutput;
    chebgen_out11: TKnobsOutput;
    chebgen_out12: TKnobsOutput;
    chebgen_out13: TKnobsOutput;
    chebgen_out2: TKnobsOutput;
    chebgen_out3: TKnobsOutput;
    chebgen_out4: TKnobsOutput;
    chebgen_out5: TKnobsOutput;
    chebgen_out6: TKnobsOutput;
    chebgen_out7: TKnobsOutput;
    chebgen_out8: TKnobsOutput;
    chebgen_out9: TKnobsOutput;
    chebgen_textlabel_10: TKnobsTextLabel;
    chebgen_textlabel_11: TKnobsTextLabel;
    chebgen_textlabel_12: TKnobsTextLabel;
    chebgen_textlabel_13: TKnobsTextLabel;
    chebgen_textlabel_2: TKnobsTextLabel;
    chebgen_textlabel_3: TKnobsTextLabel;
    chebgen_textlabel_4: TKnobsTextLabel;
    chebgen_textlabel_5: TKnobsTextLabel;
    chebgen_textlabel_6: TKnobsTextLabel;
    chebgen_textlabel_7: TKnobsTextLabel;
    chebgen_textlabel_8: TKnobsTextLabel;
    chebgen_textlabel_9: TKnobsTextLabel;
    chebgen_textlabel_in: TKnobsTextLabel;
    chebgen_wmode: TKnobsSelector;
    clockeddelay16: TKnobsModule;
    clockeddelay16_clock: TKnobsInput;
    clockeddelay16_editlabel: TKnobsEditLabel;
    clockeddelay16_in: TKnobsInput;
    clockeddelay16_indicator_clock: TKnobsIndicator;
    clockeddelay16_out0: TKnobsOutput;
    clockeddelay16_out10: TKnobsOutput;
    clockeddelay16_out11: TKnobsOutput;
    clockeddelay16_out12: TKnobsOutput;
    clockeddelay16_out13: TKnobsOutput;
    clockeddelay16_out14: TKnobsOutput;
    clockeddelay16_out15: TKnobsOutput;
    clockeddelay16_out1: TKnobsOutput;
    clockeddelay16_out2: TKnobsOutput;
    clockeddelay16_out3: TKnobsOutput;
    clockeddelay16_out4: TKnobsOutput;
    clockeddelay16_out5: TKnobsOutput;
    clockeddelay16_out6: TKnobsOutput;
    clockeddelay16_out7: TKnobsOutput;
    clockeddelay16_out8: TKnobsOutput;
    clockeddelay16_out9: TKnobsOutput;
    clockeddelay16_rate: TKnobsSelector;
    clockeddelay16_symbol_trig: TImage;
    clockeddelay16_textlabel_0: TKnobsTextLabel;
    clockeddelay16_textlabel_10: TKnobsTextLabel;
    clockeddelay16_textlabel_11: TKnobsTextLabel;
    clockeddelay16_textlabel_12: TKnobsTextLabel;
    clockeddelay16_textlabel_13: TKnobsTextLabel;
    clockeddelay16_textlabel_14: TKnobsTextLabel;
    clockeddelay16_textlabel_15: TKnobsTextLabel;
    clockeddelay16_textlabel_1: TKnobsTextLabel;
    clockeddelay16_textlabel_2: TKnobsTextLabel;
    clockeddelay16_textlabel_3: TKnobsTextLabel;
    clockeddelay16_textlabel_4: TKnobsTextLabel;
    clockeddelay16_textlabel_5: TKnobsTextLabel;
    clockeddelay16_textlabel_6: TKnobsTextLabel;
    clockeddelay16_textlabel_7: TKnobsTextLabel;
    clockeddelay16_textlabel_8: TKnobsTextLabel;
    clockeddelay16_textlabel_9: TKnobsTextLabel;
    clockeddelay16_textlabel_clock: TKnobsTextLabel;
    clockeddelay16_textlabel_in: TKnobsTextLabel;
    clockeddelay: TKnobsModule;
    clockeddelay_clock: TKnobsInput;
    clockeddelay_display_length: TKnobsDisplay;
    clockeddelay_editlabel: TKnobsEditLabel;
    clockeddelay_in: TKnobsInput;
    clockeddelay_indicator_clock: TKnobsIndicator;
    clockeddelay_length: TKnobsSmallKnob;
    clockeddelay_out: TKnobsOutput;
    clockeddelay_symbol_clock: TImage;
    clockeddelay_textlabel_clock: TKnobsTextLabel;
    clockeddelay_textlabel_in: TKnobsTextLabel;
    clockeddelay_textlabel_length: TKnobsTextLabel;
    compare: TKnobsModule;
    compare_display_range: TKnobsDisplay;
    compare_editlabel: TKnobsEditLabel;
    compare_in1: TKnobsInput;
    compare_in2: TKnobsInput;
    compare_indicator_equal: TKnobsIndicator;
    compare_indicator_less: TKnobsIndicator;
    compare_indicator_more: TKnobsIndicator;
    compare_outequal: TKnobsOutput;
    compare_outless: TKnobsOutput;
    compare_outmore: TKnobsOutput;
    compare_range: TKnobsSmallKnob;
    compare_textlabel_equal: TKnobsTextLabel;
    compare_textlabel_ins: TKnobsTextLabel;
    compare_textlabel_less: TKnobsTextLabel;
    compare_textlabel_more: TKnobsTextLabel;
    compare_textlabel_range: TKnobsTextLabel;
    compressor: TKnobsModule;
    compressor_attack: TKnobsSmallKnob;
    compressor_bypass: TKnobsSelector;
    compressor_display_attack: TKnobsDisplay;
    compressor_display_decay: TKnobsDisplay;
    compressor_display_gain: TKnobsDisplay;
    compressor_display_preamp: TKnobsDisplay;
    compressor_display_reflevel: TKnobsDisplay;
    compressor_editlabel: TKnobsEditLabel;
    compressor_env: TKnobsOutput;
    compressor_gain: TKnobsSmallKnob;
    compressor_inl: TKnobsInput;
    compressor_inr: TKnobsInput;
    compressor_level: TKnobsIndicatorBar;
    compressor_outl: TKnobsOutput;
    compressor_outr: TKnobsOutput;
    compressor_preamp: TKnobsSmallKnob;
    compressor_reflevel: TKnobsSmallKnob;
    compressor_release: TKnobsSmallKnob;
    compressor_textlabel_appliedgain: TKnobsTextLabel;
    compressor_textlabel_attack: TKnobsTextLabel;
    compressor_textlabel_decay: TKnobsTextLabel;
    compressor_textlabel_env: TKnobsTextLabel;
    compressor_textlabel_gain: TKnobsTextLabel;
    compressor_textlabel_preamp: TKnobsTextLabel;
    compressor_textlabel_reflevel: TKnobsTextLabel;
    constant: TKnobsModule;
    constant_display_value: TKnobsDisplay;
    constant_editlabel: TKnobsEditLabel;
    constant_mode: TKnobsSelector;
    constant_mute: TKnobsSelector;
    constant_out: TKnobsOutput;
    constant_value: TKnobsSmallKnob;
    control_tabsheet: TTabSheet;
    convoder: TKnobsModule;
    convoder_carrier: TKnobsInput;
    convoder_carrierlev: TKnobsSmallKnob;
    convoder_editlabel: TKnobsEditLabel;
    convoder_modulator: TKnobsInput;
    convoder_modulatorlev: TKnobsSmallKnob;
    convoder_mute: TKnobsSelector;
    convoder_out: TKnobsOutput;
    convoder_size: TKnobsSelector;
    convoder_textlabel_carrier: TKnobsTextLabel;
    convoder_textlabel_fftsize: TKnobsTextLabel;
    convoder_textlabel_modulator: TKnobsTextLabel;
    counter: TKnobsModule;
    counter_dir: TKnobsInput;
    counter_editlabel: TKnobsEditLabel;
    counter_indicator_dir: TKnobsIndicator;
    counter_indicator_out0: TKnobsIndicator;
    counter_indicator_out10: TKnobsIndicator;
    counter_indicator_out11: TKnobsIndicator;
    counter_indicator_out12: TKnobsIndicator;
    counter_indicator_out13: TKnobsIndicator;
    counter_indicator_out14: TKnobsIndicator;
    counter_indicator_out15: TKnobsIndicator;
    counter_indicator_out1: TKnobsIndicator;
    counter_indicator_out2: TKnobsIndicator;
    counter_indicator_out3: TKnobsIndicator;
    counter_indicator_out4: TKnobsIndicator;
    counter_indicator_out5: TKnobsIndicator;
    counter_indicator_out6: TKnobsIndicator;
    counter_indicator_out7: TKnobsIndicator;
    counter_indicator_out8: TKnobsIndicator;
    counter_indicator_out9: TKnobsIndicator;
    counter_indicator_reset: TKnobsIndicator;
    counter_indicator_trig: TKnobsIndicator;
    counter_mode: TKnobsSelector;
    counter_out0: TKnobsOutput;
    counter_out10: TKnobsOutput;
    counter_out11: TKnobsOutput;
    counter_out12: TKnobsOutput;
    counter_out13: TKnobsOutput;
    counter_out14: TKnobsOutput;
    counter_out15: TKnobsOutput;
    counter_out1: TKnobsOutput;
    counter_out2: TKnobsOutput;
    counter_out3: TKnobsOutput;
    counter_out4: TKnobsOutput;
    counter_out5: TKnobsOutput;
    counter_out6: TKnobsOutput;
    counter_out7: TKnobsOutput;
    counter_out8: TKnobsOutput;
    counter_out9: TKnobsOutput;
    counter_reset: TKnobsInput;
    counter_symbol_reset: TImage;
    counter_symbol_trig: TImage;
    counter_textlabel_10: TKnobsTextLabel;
    counter_textlabel_11: TKnobsTextLabel;
    counter_textlabel_12: TKnobsTextLabel;
    counter_textlabel_13: TKnobsTextLabel;
    counter_textlabel_14: TKnobsTextLabel;
    counter_textlabel_15: TKnobsTextLabel;
    counter_textlabel_16: TKnobsTextLabel;
    counter_textlabel_1: TKnobsTextLabel;
    counter_textlabel_2: TKnobsTextLabel;
    counter_textlabel_3: TKnobsTextLabel;
    counter_textlabel_4: TKnobsTextLabel;
    counter_textlabel_5: TKnobsTextLabel;
    counter_textlabel_6: TKnobsTextLabel;
    counter_textlabel_7: TKnobsTextLabel;
    counter_textlabel_8: TKnobsTextLabel;
    counter_textlabel_9: TKnobsTextLabel;
    counter_textlabel_dir: TKnobsTextLabel;
    counter_textlabel_reset: TKnobsTextLabel;
    counter_textlabel_trig: TKnobsTextLabel;
    counter_trig: TKnobsInput;
    csvdata: TKnobsModule;
    csvdata_dir: TKnobsInput;
    csvdata_display_comment: TKnobsDisplay;
    csvdata_editlabel: TKnobsEditLabel;
    csvdata_fileselector_filename: TKnobsFileSelector;
    csvdata_indicator_channels: TKnobsIndicatorText;
    csvdata_indicator_dir: TKnobsIndicator;
    csvdata_indicator_reset: TKnobsIndicator;
    csvdata_indicator_step: TKnobsIndicatorText;
    csvdata_indicator_steps: TKnobsIndicatorText;
    csvdata_indicator_trig: TKnobsIndicator;
    csvdata_label_slash: TLabel;
    csvdata_mode: TKnobsSelector;
    csvdata_out10: TKnobsOutput;
    csvdata_out11: TKnobsOutput;
    csvdata_out12: TKnobsOutput;
    csvdata_out13: TKnobsOutput;
    csvdata_out14: TKnobsOutput;
    csvdata_out15: TKnobsOutput;
    csvdata_out16: TKnobsOutput;
    csvdata_out1: TKnobsOutput;
    csvdata_out2: TKnobsOutput;
    csvdata_out3: TKnobsOutput;
    csvdata_out4: TKnobsOutput;
    csvdata_out5: TKnobsOutput;
    csvdata_out6: TKnobsOutput;
    csvdata_out7: TKnobsOutput;
    csvdata_out8: TKnobsOutput;
    csvdata_out9: TKnobsOutput;
    csvdata_reset: TKnobsInput;
    csvdata_symbol_back1: TImage;
    csvdata_symbol_back2: TImage;
    csvdata_symbol_trig: TImage;
    csvdata_textlabel_10: TKnobsTextLabel;
    csvdata_textlabel_11: TKnobsTextLabel;
    csvdata_textlabel_12: TKnobsTextLabel;
    csvdata_textlabel_13: TKnobsTextLabel;
    csvdata_textlabel_14: TKnobsTextLabel;
    csvdata_textlabel_15: TKnobsTextLabel;
    csvdata_textlabel_16: TKnobsTextLabel;
    csvdata_textlabel_1: TKnobsTextLabel;
    csvdata_textlabel_2: TKnobsTextLabel;
    csvdata_textlabel_3: TKnobsTextLabel;
    csvdata_textlabel_4: TKnobsTextLabel;
    csvdata_textlabel_5: TKnobsTextLabel;
    csvdata_textlabel_6: TKnobsTextLabel;
    csvdata_textlabel_7: TKnobsTextLabel;
    csvdata_textlabel_8: TKnobsTextLabel;
    csvdata_textlabel_9: TKnobsTextLabel;
    csvdata_textlabel_channels: TKnobsTextLabel;
    csvdata_textlabel_dir: TKnobsTextLabel;
    csvdata_textlabel_mode: TKnobsTextLabel;
    csvdata_textlabel_res: TKnobsTextLabel;
    csvdata_textlabel_trig: TKnobsTextLabel;
    csvdata_trig: TKnobsInput;
    dac: TKnobsModule;
    dac_editlabel: TKnobsEditLabel;
    dac_in0: TKnobsInput;
    dac_in10: TKnobsInput;
    dac_in11: TKnobsInput;
    dac_in12: TKnobsInput;
    dac_in13: TKnobsInput;
    dac_in14: TKnobsInput;
    dac_in15: TKnobsInput;
    dac_in1: TKnobsInput;
    dac_in2: TKnobsInput;
    dac_in3: TKnobsInput;
    dac_in4: TKnobsInput;
    dac_in5: TKnobsInput;
    dac_in6: TKnobsInput;
    dac_in7: TKnobsInput;
    dac_in8: TKnobsInput;
    dac_in9: TKnobsInput;
    dac_indicator_in0: TKnobsIndicator;
    dac_indicator_in10: TKnobsIndicator;
    dac_indicator_in11: TKnobsIndicator;
    dac_indicator_in12: TKnobsIndicator;
    dac_indicator_in13: TKnobsIndicator;
    dac_indicator_in14: TKnobsIndicator;
    dac_indicator_in15: TKnobsIndicator;
    dac_indicator_in1: TKnobsIndicator;
    dac_indicator_in2: TKnobsIndicator;
    dac_indicator_in3: TKnobsIndicator;
    dac_indicator_in4: TKnobsIndicator;
    dac_indicator_in5: TKnobsIndicator;
    dac_indicator_in6: TKnobsIndicator;
    dac_indicator_in7: TKnobsIndicator;
    dac_indicator_in8: TKnobsIndicator;
    dac_indicator_in9: TKnobsIndicator;
    dac_out: TKnobsOutput;
    dac_textlabel_0: TKnobsTextLabel;
    dac_textlabel_10: TKnobsTextLabel;
    dac_textlabel_11: TKnobsTextLabel;
    dac_textlabel_12: TKnobsTextLabel;
    dac_textlabel_13: TKnobsTextLabel;
    dac_textlabel_14: TKnobsTextLabel;
    dac_textlabel_15: TKnobsTextLabel;
    dac_textlabel_1: TKnobsTextLabel;
    dac_textlabel_2: TKnobsTextLabel;
    dac_textlabel_3: TKnobsTextLabel;
    dac_textlabel_4: TKnobsTextLabel;
    dac_textlabel_5: TKnobsTextLabel;
    dac_textlabel_6: TKnobsTextLabel;
    dac_textlabel_7: TKnobsTextLabel;
    dac_textlabel_8: TKnobsTextLabel;
    dac_textlabel_9: TKnobsTextLabel;
    dac_textlabel_out: TKnobsTextLabel;
    delay8: TKnobsModule;
    delay8_delay1: TKnobsInput;
    delay8_delay2: TKnobsInput;
    delay8_delay3: TKnobsInput;
    delay8_delay4: TKnobsInput;
    delay8_delay5: TKnobsInput;
    delay8_delay6: TKnobsInput;
    delay8_delay7: TKnobsInput;
    delay8_delay8: TKnobsInput;
    delay8_display_length: TKnobsDisplay;
    delay8_editlabel: TKnobsEditLabel;
    delay8_in: TKnobsInput;
    delay8_length: TKnobsSmallKnob;
    delay8_out1: TKnobsOutput;
    delay8_out2: TKnobsOutput;
    delay8_out3: TKnobsOutput;
    delay8_out4: TKnobsOutput;
    delay8_out5: TKnobsOutput;
    delay8_out6: TKnobsOutput;
    delay8_out7: TKnobsOutput;
    delay8_out8: TKnobsOutput;
    delay8_outfixed: TKnobsOutput;
    delay8_range: TKnobsSelector;
    delay8_textlabel_dly: TKnobsTextLabel;
    delay8_textlabel_fixed: TKnobsTextLabel;
    delay8_textlabel_in: TKnobsTextLabel;
    delay8_textlabel_maxdelay: TKnobsTextLabel;
    delay8_textlabel_out: TKnobsTextLabel;
    delay: TKnobsModule;
    delay_delay: TKnobsInput;
    delay_display_length: TKnobsDisplay;
    delay_editlabel: TKnobsEditLabel;
    delay_in: TKnobsInput;
    delay_length: TKnobsSmallKnob;
    delay_out: TKnobsOutput;
    delay_outfixed: TKnobsOutput;
    delay_range: TKnobsSelector;
    delay_tabseet: TTabSheet;
    delay_textlabel_delay: TKnobsTextLabel;
    delay_textlabel_fixed: TKnobsTextLabel;
    delay_textlabel_in: TKnobsTextLabel;
    delay_textlabel_maxdelay: TKnobsTextLabel;
    demux: TKnobsModule;
    demux_control: TKnobsInput;
    demux_editlabel: TKnobsEditLabel;
    demux_in: TKnobsInput;
    demux_indicator_0: TKnobsIndicator;
    demux_indicator_10: TKnobsIndicator;
    demux_indicator_11: TKnobsIndicator;
    demux_indicator_1: TKnobsIndicator;
    demux_indicator_2: TKnobsIndicator;
    demux_indicator_3: TKnobsIndicator;
    demux_indicator_4: TKnobsIndicator;
    demux_indicator_5: TKnobsIndicator;
    demux_indicator_6: TKnobsIndicator;
    demux_indicator_7: TKnobsIndicator;
    demux_indicator_8: TKnobsIndicator;
    demux_indicator_9: TKnobsIndicator;
    demux_out0: TKnobsOutput;
    demux_out10: TKnobsOutput;
    demux_out11: TKnobsOutput;
    demux_out1: TKnobsOutput;
    demux_out2: TKnobsOutput;
    demux_out3: TKnobsOutput;
    demux_out4: TKnobsOutput;
    demux_out5: TKnobsOutput;
    demux_out6: TKnobsOutput;
    demux_out7: TKnobsOutput;
    demux_out8: TKnobsOutput;
    demux_out9: TKnobsOutput;
    demux_textlabel_control: TKnobsTextLabel;
    demux_textlabel_xfade: TKnobsTextLabel;
    demux_xfade: TKnobsSmallKnob;
    dflipflop: TKnobsModule;
    dflipflop_clk: TKnobsInput;
    dflipflop_d: TKnobsInput;
    dflipflop_editlabel: TKnobsEditLabel;
    dflipflop_image: TImage;
    dflipflop_indicator_notq: TKnobsIndicator;
    dflipflop_indicator_q: TKnobsIndicator;
    dflipflop_notq: TKnobsOutput;
    dflipflop_q: TKnobsOutput;
    dflipflop_symbol_clk: TImage;
    digidemux: TKnobsModule;
    digidemux_editlabel: TKnobsEditLabel;
    digidemux_hold: TKnobsSelector;
    digidemux_in: TKnobsInput;
    digidemux_indicator_0: TKnobsIndicator;
    digidemux_indicator_1: TKnobsIndicator;
    digidemux_indicator_2: TKnobsIndicator;
    digidemux_indicator_3: TKnobsIndicator;
    digidemux_indicator_4: TKnobsIndicator;
    digidemux_indicator_5: TKnobsIndicator;
    digidemux_indicator_6: TKnobsIndicator;
    digidemux_indicator_7: TKnobsIndicator;
    digidemux_out0: TKnobsOutput;
    digidemux_out1: TKnobsOutput;
    digidemux_out2: TKnobsOutput;
    digidemux_out3: TKnobsOutput;
    digidemux_out4: TKnobsOutput;
    digidemux_out5: TKnobsOutput;
    digidemux_out6: TKnobsOutput;
    digidemux_out7: TKnobsOutput;
    digidemux_sel0: TKnobsInput;
    digidemux_sel1: TKnobsInput;
    digidemux_sel2: TKnobsInput;
    digimux: TKnobsModule;
    digimux_editlabel: TKnobsEditLabel;
    digimux_in0: TKnobsInput;
    digimux_in1: TKnobsInput;
    digimux_in2: TKnobsInput;
    digimux_in3: TKnobsInput;
    digimux_in4: TKnobsInput;
    digimux_in5: TKnobsInput;
    digimux_in6: TKnobsInput;
    digimux_in7: TKnobsInput;
    digimux_indicator_0: TKnobsIndicator;
    digimux_indicator_1: TKnobsIndicator;
    digimux_indicator_2: TKnobsIndicator;
    digimux_indicator_3: TKnobsIndicator;
    digimux_indicator_4: TKnobsIndicator;
    digimux_indicator_5: TKnobsIndicator;
    digimux_indicator_6: TKnobsIndicator;
    digimux_indicator_7: TKnobsIndicator;
    digimux_out: TKnobsOutput;
    digimux_sel0: TKnobsInput;
    digimux_sel1: TKnobsInput;
    digimux_sel2: TKnobsInput;
    display: TKnobsModule;
    display_editlabel: TKnobsEditLabel;
    display_in1: TKnobsInput;
    display_in2: TKnobsInput;
    display_level1: TKnobsIndicatorBar;
    display_level2: TKnobsIndicatorBar;
    display_mode: TKnobsSelector;
    display_speed: TKnobsSelector;
    display_textlabel_db: TKnobsTextLabel;
    divider: TKnobsModule;
    divider_count: TKnobsSmallKnob;
    divider_display_count: TKnobsDisplay;
    divider_editlabel: TKnobsEditLabel;
    divider_indicator_out: TKnobsIndicator;
    divider_out: TKnobsOutput;
    divider_reset: TKnobsInput;
    divider_symbol_reset: TImage;
    divider_symbol_trig: TImage;
    divider_textable_reset: TKnobsTextLabel;
    divider_textlabel_trig: TKnobsTextLabel;
    divider_trig: TKnobsInput;
    envadsr: TKnobsModule;
    envadsr_amod: TKnobsInput;
    envadsr_amodlevel: TKnobsSmallKnob;
    envadsr_amodneg: TKnobsInput;
    envadsr_arange: TKnobsSelector;
    envadsr_ashape: TKnobsSelector;
    envadsr_attack: TKnobsSmallKnob;
    envadsr_decay: TKnobsSmallKnob;
    envadsr_display_attack: TKnobsDisplay;
    envadsr_display_decay: TKnobsDisplay;
    envadsr_display_release: TKnobsDisplay;
    envadsr_display_sustain: TKnobsDisplay;
    envadsr_dmod: TKnobsInput;
    envadsr_dmodlevel: TKnobsSmallKnob;
    envadsr_dmodneg: TKnobsInput;
    envadsr_drange: TKnobsSelector;
    envadsr_dshape: TKnobsSelector;
    envadsr_editlabel: TKnobsEditLabel;
    envadsr_gain: TKnobsInput;
    envadsr_indicator_trig: TKnobsIndicator;
    envadsr_indicator_trigin: TKnobsIndicator;
    envadsr_mode: TKnobsSelector;
    envadsr_mute: TKnobsSelector;
    envadsr_out: TKnobsOutput;
    envadsr_outputtype: TKnobsSelector;
    envadsr_release: TKnobsSmallKnob;
    envadsr_rmod: TKnobsInput;
    envadsr_rmodlevel: TKnobsSmallKnob;
    envadsr_rmodneg: TKnobsInput;
    envadsr_rrange: TKnobsSelector;
    envadsr_rshape: TKnobsSelector;
    envadsr_sigin: TKnobsInput;
    envadsr_sigout: TKnobsOutput;
    envadsr_smod: TKnobsInput;
    envadsr_smodlevel: TKnobsSmallKnob;
    envadsr_smodneg: TKnobsInput;
    envadsr_sustain: TKnobsSmallKnob;
    envadsr_symbol_connect: TImage;
    envadsr_symbol_trig: TImage;
    envadsr_textkabel_minus: TKnobsTextLabel;
    envadsr_textkabel_plus: TKnobsTextLabel;
    envadsr_textlabel_attack: TKnobsTextLabel;
    envadsr_textlabel_decay: TKnobsTextLabel;
    envadsr_textlabel_env: TKnobsTextLabel;
    envadsr_textlabel_gain: TKnobsTextLabel;
    envadsr_textlabel_release: TKnobsTextLabel;
    envadsr_textlabel_sustain: TKnobsTextLabel;
    envadsr_trig: TKnobsInput;
    envadsr_viewer: TKnobsDataViewer;
    envahd: TKnobsModule;
    envahd_amod: TKnobsInput;
    envahd_amodlevel: TKnobsSmallKnob;
    envahd_amodneg: TKnobsInput;
    envahd_arange: TKnobsSelector;
    envahd_ashape: TKnobsSelector;
    envahd_attack: TKnobsSmallKnob;
    envahd_decay: TKnobsSmallKnob;
    envahd_display_attack: TKnobsDisplay;
    envahd_display_decay: TKnobsDisplay;
    envahd_display_hold: TKnobsDisplay;
    envahd_dmod: TKnobsInput;
    envahd_dmodlevel: TKnobsSmallKnob;
    envahd_dmodneg: TKnobsInput;
    envahd_drange: TKnobsSelector;
    envahd_dshape: TKnobsSelector;
    envahd_editlabel: TKnobsEditLabel;
    envahd_gain: TKnobsInput;
    envahd_hmod: TKnobsInput;
    envahd_hmodlevel: TKnobsSmallKnob;
    envahd_hmodneg: TKnobsInput;
    envahd_hold: TKnobsSmallKnob;
    envahd_hrange: TKnobsSelector;
    envahd_indicator_trig: TKnobsIndicator;
    envahd_indicator_trigin: TKnobsIndicator;
    envahd_mode: TKnobsSelector;
    envahd_mute: TKnobsSelector;
    envahd_out: TKnobsOutput;
    envahd_outputtype: TKnobsSelector;
    envahd_sigin: TKnobsInput;
    envahd_sigout: TKnobsOutput;
    envahd_symbol_connect: TImage;
    envahd_symbol_trig: TImage;
    envahd_textlabel_attack: TKnobsTextLabel;
    envahd_textlabel_decay: TKnobsTextLabel;
    envahd_textlabel_env: TKnobsTextLabel;
    envahd_textlabel_gain: TKnobsTextLabel;
    envahd_textlabel_hold: TKnobsTextLabel;
    envahd_textlabel_minus: TKnobsTextLabel;
    envahd_textlabel_plus: TKnobsTextLabel;
    envahd_trig: TKnobsInput;
    envahd_viewer: TKnobsDataViewer;
    envar: TKnobsModule;
    envar_attack: TKnobsSmallKnob;
    envar_display_attack: TKnobsDisplay;
    envar_display_release: TKnobsDisplay;
    envar_editlabel: TKnobsEditLabel;
    envar_gain: TKnobsInput;
    envar_indicator_trig: TKnobsIndicator;
    envar_mute: TKnobsSelector;
    envar_out: TKnobsOutput;
    envar_release: TKnobsSmallKnob;
    envar_sigin: TKnobsInput;
    envar_sigout: TKnobsOutput;
    envar_textlabel_attack: TKnobsTextLabel;
    envar_textlabel_env: TKnobsTextLabel;
    envar_textlabel_gain: TKnobsTextLabel;
    envar_textlabel_release: TKnobsTextLabel;
    envar_textlabel_trig: TKnobsTextLabel;
    envar_trig: TKnobsInput;
    envarretrig: TKnobsModule;
    envarretrig_attack: TKnobsSmallKnob;
    envarretrig_display_attack: TKnobsDisplay;
    envarretrig_display_release: TKnobsDisplay;
    envarretrig_editlabel: TKnobsEditLabel;
    envarretrig_gain: TKnobsInput;
    envarretrig_indicator_trig: TKnobsIndicator;
    envarretrig_mute: TKnobsSelector;
    envarretrig_out: TKnobsOutput;
    envarretrig_release: TKnobsSmallKnob;
    envarretrig_sigin: TKnobsInput;
    envarretrig_sigout: TKnobsOutput;
    envarretrig_symbol_connect: TImage;
    envarretrig_symbol_trig: TImage;
    envarretrig_textlabel_attack: TKnobsTextLabel;
    envarretrig_textlabel_env: TKnobsTextLabel;
    envarretrig_textlabel_gain: TKnobsTextLabel;
    envarretrig_textlabel_release: TKnobsTextLabel;
    envarretrig_textlabel_trig: TKnobsTextLabel;
    envarretrig_trig: TKnobsInput;
    envelope: TKnobsModule;
    envelope_attack: TKnobsSmallKnob;
    envelope_display_attack: TKnobsDisplay;
    envelope_display_release: TKnobsDisplay;
    envelope_editlabel: TKnobsEditLabel;
    envelope_in: TKnobsInput;
    envelope_invout: TKnobsOutput;
    envelope_out: TKnobsOutput;
    envelope_peakdecay: TKnobsSmallKnob;
    envelope_peakdecayon: TKnobsSelector;
    envelope_release: TKnobsSmallKnob;
    envelope_tabsheet: TTabSheet;
    envelope_textlabel_a: TKnobsTextLabel;
    envelope_textlabel_env: TKnobsTextLabel;
    envelope_textlabel_inv: TKnobsTextLabel;
    envelope_textlabel_peakdecay: TKnobsTextLabel;
    envelope_textlabel_r: TKnobsTextLabel;
    euclids: TKnobsModule;
    euclids_display_steps: TKnobsDisplay;
    euclids_editlabel: TKnobsEditLabel;
    euclids_indicator_out: TKnobsIndicator;
    euclids_indicator_trig: TKnobsIndicator;
    euclids_out: TKnobsOutput;
    euclids_pattern: TKnobsInput;
    euclids_patternmod: TKnobsSmallKnob;
    euclids_pulses: TKnobsSmallKnob;
    euclids_steps: TKnobsSmallKnob;
    euclids_symbol_trig: TImage;
    euclids_textlabel_mod: TKnobsTextLabel;
    euclids_textlabel_out: TKnobsTextLabel;
    euclids_textlabel_pattern: TKnobsTextLabel;
    euclids_textlabel_steps: TKnobsTextLabel;
    euclids_textlabel_trig: TKnobsTextLabel;
    euclids_trig: TKnobsInput;
    euscale: TKnobsModule;
    euscale_display_steps: TKnobsDisplay;
    euscale_editlabel: TKnobsEditLabel;
    euscale_in: TKnobsInput;
    euscale_out: TKnobsOutput;
    euscale_pattern: TKnobsSmallKnob;
    euscale_patternmod: TKnobsInput;
    euscale_patternmodamt: TKnobsSmallKnob;
    euscale_steps: TKnobsSmallKnob;
    euscale_textlabel_: TKnobsTextLabel;
    euscale_textlabel_in: TKnobsTextLabel;
    euscale_textlabel_out: TKnobsTextLabel;
    euscale_textlabel_pattern: TKnobsTextLabel;
    euscale_textlabel_steps: TKnobsTextLabel;
    filter_tabsheet: TTabSheet;
    flangechorus: TKnobsModule;
    flangechorus_delay: TKnobsSmallKnob;
    flangechorus_dry: TKnobsSmallKnob;
    flangechorus_editlabel: TKnobsEditLabel;
    flangechorus_feedback: TKnobsSmallKnob;
    flangechorus_freeze: TKnobsSelector;
    flangechorus_freezein: TKnobsInput;
    flangechorus_in: TKnobsInput;
    flangechorus_mute: TKnobsSelector;
    flangechorus_out: TKnobsOutput;
    flangechorus_rate: TKnobsSmallKnob;
    flangechorus_sweep: TKnobsSmallKnob;
    flangechorus_textlabel_delay: TKnobsTextLabel;
    flangechorus_textlabel_dry: TKnobsTextLabel;
    flangechorus_textlabel_feedback: TKnobsTextLabel;
    flangechorus_textlabel_rate: TKnobsTextLabel;
    flangechorus_textlabel_sweep: TKnobsTextLabel;
    flangechorus_textlabel_wet: TKnobsTextLabel;
    flangechorus_wet: TKnobsSmallKnob;
    formant: TKnobsModule;
    formant_controlmod: TKnobsSmallKnob;
    formant_editlabel: TKnobsEditLabel;
    formant_in: TKnobsInput;
    formant_out: TKnobsOutput;
    formant_textlabel_control: TKnobsTextLabel;
    formant_textlabel_in: TKnobsTextLabel;
    formant_textlabel_vowel: TKnobsTextLabel;
    formant_vowel: TKnobsSmallKnob;
    formant_vowelin: TKnobsInput;
    freqshifter: TKnobsModule;
    freqshifter_display_shift: TKnobsDisplay;
    freqshifter_down: TKnobsOutput;
    freqshifter_editlabel: TKnobsEditLabel;
    freqshifter_in: TKnobsInput;
    freqshifter_shift: TKnobsSmallKnob;
    freqshifter_shiftdepth: TKnobsSmallKnob;
    freqshifter_shiftmod: TKnobsInput;
    freqshifter_textlabel_dn: TKnobsTextLabel;
    freqshifter_textlabel_in: TKnobsTextLabel;
    freqshifter_textlabel_mod: TKnobsTextLabel;
    freqshifter_textlabel_shift: TKnobsTextLabel;
    freqshifter_textlabel_up: TKnobsTextLabel;
    freqshifter_up: TKnobsOutput;
    friemels: TKnobsModule;
    friemels_editlabel: TKnobsEditLabel;
    friemels_wormpanel: TKnobsWormPanel;
    fx_tabsheet: TTabSheet;
    gate: TKnobsModule;
    gate_editlabel: TKnobsEditLabel;
    gate_function: TKnobsSelector;
    gate_in1: TKnobsInput;
    gate_in2: TKnobsInput;
    gate_in3: TKnobsInput;
    gate_in4: TKnobsInput;
    gate_indicator_out: TKnobsIndicator;
    gate_out: TKnobsOutput;
    gate_width: TKnobsSelector;
    gateseq: TKnobsModule;
    gateseq_active: TKnobsInput;
    gateseq_chain: TKnobsInput;
    gateseq_dir: TKnobsInput;
    gateseq_display_steps: TKnobsDisplay;
    gateseq_editlabel: TKnobsEditLabel;
    gateseq_indicator_active: TKnobsIndicator;
    gateseq_indicator_dir: TKnobsIndicator;
    gateseq_indicator_out: TKnobsIndicator;
    gateseq_indicator_reset: TKnobsIndicator;
    gateseq_indicator_step10: TKnobsIndicator;
    gateseq_indicator_step11: TKnobsIndicator;
    gateseq_indicator_step12: TKnobsIndicator;
    gateseq_indicator_step13: TKnobsIndicator;
    gateseq_indicator_step14: TKnobsIndicator;
    gateseq_indicator_step15: TKnobsIndicator;
    gateseq_indicator_step16: TKnobsIndicator;
    gateseq_indicator_step1: TKnobsIndicator;
    gateseq_indicator_step2: TKnobsIndicator;
    gateseq_indicator_step3: TKnobsIndicator;
    gateseq_indicator_step4: TKnobsIndicator;
    gateseq_indicator_step5: TKnobsIndicator;
    gateseq_indicator_step6: TKnobsIndicator;
    gateseq_indicator_step7: TKnobsIndicator;
    gateseq_indicator_step8: TKnobsIndicator;
    gateseq_indicator_step9: TKnobsIndicator;
    gateseq_indicator_trig: TKnobsIndicator;
    gateseq_out: TKnobsOutput;
    gateseq_outdir: TKnobsOutput;
    gateseq_outres: TKnobsOutput;
    gateseq_outtrig: TKnobsOutput;
    gateseq_res: TKnobsInput;
    gateseq_step10: TKnobsSelector;
    gateseq_step11: TKnobsSelector;
    gateseq_step12: TKnobsSelector;
    gateseq_step13: TKnobsSelector;
    gateseq_step14: TKnobsSelector;
    gateseq_step15: TKnobsSelector;
    gateseq_step16: TKnobsSelector;
    gateseq_step1: TKnobsSelector;
    gateseq_step2: TKnobsSelector;
    gateseq_step3: TKnobsSelector;
    gateseq_step4: TKnobsSelector;
    gateseq_step5: TKnobsSelector;
    gateseq_step6: TKnobsSelector;
    gateseq_step7: TKnobsSelector;
    gateseq_step8: TKnobsSelector;
    gateseq_step9: TKnobsSelector;
    gateseq_steps: TKnobsNoKnob;
    gateseq_symbol_reset: TImage;
    gateseq_symbol_trig: TImage;
    gateseq_textlabel_active: TKnobsTextLabel;
    gateseq_textlabel_chain: TKnobsTextLabel;
    gateseq_textlabel_dir: TKnobsTextLabel;
    gateseq_textlabel_out: TKnobsTextLabel;
    gateseq_textlabel_reset: TKnobsTextLabel;
    gateseq_textlabel_steps: TKnobsTextLabel;
    gateseq_textlabel_trig: TKnobsTextLabel;
    gateseq_trig: TKnobsInput;
    granulator: TKnobsModule;
    granulator_delay: TKnobsInput;
    granulator_delaytime: TKnobsSmallKnob;
    granulator_display_delaytime: TKnobsDisplay;
    granulator_display_grainduration: TKnobsDisplay;
    granulator_display_grains: TKnobsDisplay;
    granulator_display_interonset: TKnobsDisplay;
    granulator_editlabel: TKnobsEditLabel;
    granulator_envtype: TKnobsSelector;
    granulator_graincount: TKnobsSmallKnob;
    granulator_grainduration: TKnobsSmallKnob;
    granulator_graindurationmod: TKnobsInput;
    granulator_graindurationmodamt: TKnobsSmallKnob;
    granulator_grainoffset: TKnobsInput;
    granulator_in: TKnobsInput;
    granulator_interonset: TKnobsSmallKnob;
    granulator_interonsetmod: TKnobsInput;
    granulator_interonsetmodamt: TKnobsSmallKnob;
    granulator_mute: TKnobsSelector;
    granulator_outl: TKnobsOutput;
    granulator_outr: TKnobsOutput;
    granulator_pan: TKnobsSmallKnob;
    granulator_panmod: TKnobsInput;
    granulator_panmodamt: TKnobsSmallKnob;
    granulator_range: TKnobsSelector;
    granulator_rec: TKnobsInput;
    granulator_record: TKnobsSelector;
    granulator_textlabel_dlymod: TKnobsTextLabel;
    granulator_textlabel_duration: TKnobsTextLabel;
    granulator_textlabel_envtype: TKnobsTextLabel;
    granulator_textlabel_grainoffset: TKnobsTextLabel;
    granulator_textlabel_grains: TKnobsTextLabel;
    granulator_textlabel_in: TKnobsTextLabel;
    granulator_textlabel_interonset: TKnobsTextLabel;
    granulator_textlabel_maxdelay: TKnobsTextLabel;
    granulator_textlabel_out: TKnobsTextLabel;
    granulator_textlabel_pan: TKnobsTextLabel;
    granulator_textlabel_vol: TKnobsTextLabel;
    granulator_volume: TKnobsSmallKnob;
    granulator_volumemod: TKnobsInput;
    granulator_volumemodamt: TKnobsSmallKnob;
    gverb: TKnobsModule;
    gverb_damping: TKnobsSmallKnob;
    gverb_dampingmod: TKnobsInput;
    gverb_display_maxroomsize: TKnobsDisplay;
    gverb_display_roomsize: TKnobsDisplay;
    gverb_drylevel: TKnobsSmallKnob;
    gverb_drylevelmod: TKnobsInput;
    gverb_earlylevel: TKnobsSmallKnob;
    gverb_earlylevelmod: TKnobsInput;
    gverb_editlabel: TKnobsEditLabel;
    gverb_inl: TKnobsInput;
    gverb_inputbw: TKnobsSmallKnob;
    gverb_inputbwmod: TKnobsInput;
    gverb_inputlevel: TKnobsSmallKnob;
    gverb_inr: TKnobsInput;
    gverb_knobbox: TKnobsBox;
    gverb_maxroomsize: TKnobsSmallKnob;
    gverb_mode: TKnobsSelector;
    gverb_mute: TKnobsSelector;
    gverb_outl: TKnobsOutput;
    gverb_outr: TKnobsOutput;
    gverb_revtime: TKnobsSmallKnob;
    gverb_revtimemod: TKnobsInput;
    gverb_roomsize: TKnobsSmallKnob;
    gverb_roomsizemod: TKnobsInput;
    gverb_roomsizemodlev: TKnobsSmallKnob;
    gverb_spread: TKnobsSmallKnob;
    gverb_taillevel: TKnobsSmallKnob;
    gverb_taillevelmod: TKnobsInput;
    gverb_textlabel_damping: TKnobsTextLabel;
    gverb_textlabel_drylevel: TKnobsTextLabel;
    gverb_textlabel_earlylevel: TKnobsTextLabel;
    gverb_textlabel_inlevel: TKnobsTextLabel;
    gverb_textlabel_inputbw: TKnobsTextLabel;
    gverb_textlabel_maxroomsize: TKnobsTextLabel;
    gverb_textlabel_mod: TKnobsTextLabel;
    gverb_textlabel_mode: TKnobsTextLabel;
    gverb_textlabel_revtime: TKnobsTextLabel;
    gverb_textlabel_roomsize: TKnobsTextLabel;
    gverb_textlabel_spread: TKnobsTextLabel;
    gverb_textlabel_taillevel: TKnobsTextLabel;
    hardclip: TKnobsModule;
    hardclip_display_highlevel: TKnobsDisplay;
    hardclip_display_lowlevel: TKnobsDisplay;
    hardclip_display_outamp: TKnobsDisplay;
    hardclip_editlabel: TKnobsEditLabel;
    hardclip_highlevel: TKnobsSmallKnob;
    hardclip_in: TKnobsInput;
    hardclip_lock: TKnobsSelector;
    hardclip_lowlevel: TKnobsSmallKnob;
    hardclip_mute: TKnobsSelector;
    hardclip_out: TKnobsOutput;
    hardclip_outamp: TKnobsSmallKnob;
    hardclip_textlabel_highlevel: TKnobsTextLabel;
    hardclip_textlabel_in: TKnobsTextLabel;
    hardclip_textlabel_lock: TKnobsTextLabel;
    hardclip_textlabel_lowlevel: TKnobsTextLabel;
    hardclip_textlabel_outamp: TKnobsTextLabel;
    hrastosc: TKnobsModule;
    hrastosc_bandlimit: TKnobsSmallKnob;
    hrastosc_cents: TKnobsSmallKnob;
    hrastosc_display_cents: TKnobsDisplay;
    hrastosc_display_freq: TKnobsDisplay;
    hrastosc_editlabel: TKnobsEditLabel;
    hrastosc_fmlevel: TKnobsSmallKnob;
    hrastosc_fm: TKnobsInput;
    hrastosc_frequency: TKnobsSmallKnob;
    hrastosc_level: TKnobsSmallKnob;
    hrastosc_morph: TKnobsSmallKnob;
    hrastosc_mute: TKnobsSelector;
    hrastosc_out: TKnobsOutput;
    hrastosc_pmlevel: TKnobsSmallKnob;
    hrastosc_phase: TKnobsInput;
    hrastosc_pw: TKnobsSmallKnob;
    hrastosc_pwmlevel: TKnobsSmallKnob;
    hrastosc_pwm: TKnobsInput;
    hrastosc_shape: TKnobsSmallKnob;
    hrastosc_symbol_sync: TImage;
    hrastosc_sync: TKnobsInput;
    hrastosc_textlabel_bandlimit: TKnobsTextLabel;
    hrastosc_textlabel_fm: TKnobsTextLabel;
    hrastosc_textlabel_level: TKnobsTextLabel;
    hrastosc_textlabel_morph: TKnobsTextLabel;
    hrastosc_textlabel_pm: TKnobsTextLabel;
    hrastosc_textlabel_pwm: TKnobsTextLabel;
    hrastosc_textlabel_shape: TKnobsTextLabel;
    hrastosc_textlabel_sync: TKnobsTextLabel;
    hrastosc_vintage: TKnobsSelector;
    hrastsvf: TKnobsModule;
    hrastsvf_bandpass: TKnobsSmallKnob;
    hrastsvf_frequency: TKnobsSmallKnob;
    hrastsvf_fm: TKnobsInput;
    hrastsvf_fmlevel: TKnobsSmallKnob;
    hrastsvf_display_cutoff: TKnobsDisplay;
    hrastsvf_distortion: TKnobsSmallKnob;
    hrastsvf_editlabel: TKnobsEditLabel;
    hrastsvf_freq: TKnobsInput;
    hrastsvf_inlevel: TKnobsSmallKnob;
    hrastsvf_highpass: TKnobsSmallKnob;
    hrastsvf_in: TKnobsInput;
    hrastsvf_level12: TKnobsSmallKnob;
    hrastsvf_level24: TKnobsSmallKnob;
    hrastsvf_lowpass: TKnobsSmallKnob;
    hrastsvf_12: TKnobsOutput;
    hrastsvf_24: TKnobsOutput;
    hrastsvf_bp: TKnobsOutput;
    hrastsvf_br: TKnobsOutput;
    hrastsvf_hp: TKnobsOutput;
    hrastsvf_lp: TKnobsOutput;
    hrastsvf_q: TKnobsSmallKnob;
    hrastsvf_qm: TKnobsInput;
    hrastsvf_qmlevel: TKnobsSmallKnob;
    hrastsvf_textlabel_12db: TKnobsTextLabel;
    hrastsvf_textlabel_24db: TKnobsTextLabel;
    hrastsvf_textlabel_bp: TKnobsTextLabel;
    hrastsvf_textlabel_drive: TKnobsTextLabel;
    hrastsvf_textlabel_fm: TKnobsTextLabel;
    hrastsvf_textlabel_freq: TKnobsTextLabel;
    hrastsvf_textlabel_hp: TKnobsTextLabel;
    hrastsvf_textlabel_in: TKnobsTextLabel;
    hrastsvf_textlabel_lp: TKnobsTextLabel;
    hrastsvf_textlabel_out12db: TKnobsTextLabel;
    hrastsvf_textlabel_out24db: TKnobsTextLabel;
    hrastsvf_textlabel_outbp: TKnobsTextLabel;
    hrastsvf_textlabel_outbr: TKnobsTextLabel;
    hrastsvf_textlabel_outhp: TKnobsTextLabel;
    hrastsvf_textlabel_outlp: TKnobsTextLabel;
    hrastsvf_textlabel_q: TKnobsTextLabel;
    hrastsvf_textlabel_qm: TKnobsTextLabel;
    inout_tabsheet: TTabSheet;
    intdif: TKnobsModule;
    intdif_dif: TKnobsOutput;
    intdif_editlabel: TKnobsEditLabel;
    intdif_in: TKnobsInput;
    intdif_int: TKnobsOutput;
    intdif_mode: TKnobsSelector;
    intdif_textlabel_dif: TKnobsTextLabel;
    intdif_textlabel_in: TKnobsTextLabel;
    intdif_textlabel_int: TKnobsTextLabel;
    interpreter: TKnobsModule;
    interpreter_editlabel: TKnobsEditLabel;
    interpreter_in1: TKnobsInput;
    interpreter_in2: TKnobsInput;
    interpreter_in3: TKnobsInput;
    interpreter_in4: TKnobsInput;
    interpreter_in5: TKnobsInput;
    interpreter_in6: TKnobsInput;
    interpreter_in7: TKnobsInput;
    interpreter_in8: TKnobsInput;
    interpreter_out1: TKnobsOutput;
    interpreter_out2: TKnobsOutput;
    interpreter_out3: TKnobsOutput;
    interpreter_out4: TKnobsOutput;
    interpreter_out5: TKnobsOutput;
    interpreter_out6: TKnobsOutput;
    interpreter_out7: TKnobsOutput;
    interpreter_out8: TKnobsOutput;
    kleebit: TKnobsModule;
    kleebit_box_analog: TKnobsBox;
    kleebit_box_bus1: TKnobsBox;
    kleebit_box_bus2: TKnobsBox;
    kleebit_box_bus3: TKnobsBox;
    kleebit_box_pre: TKnobsBox;
    kleebit_bussel1: TKnobsSelector;
    kleebit_bussel2: TKnobsSelector;
    kleebit_bussel3: TKnobsSelector;
    kleebit_bussel4: TKnobsSelector;
    kleebit_bussel5: TKnobsSelector;
    kleebit_bussel6: TKnobsSelector;
    kleebit_bussel7: TKnobsSelector;
    kleebit_bussel8: TKnobsSelector;
    kleebit_editlabel: TKnobsEditLabel;
    kleebit_inanalog: TKnobsInput;
    kleebit_inbit: TKnobsInput;
    kleebit_inbus1: TKnobsInput;
    kleebit_inbus2: TKnobsInput;
    kleebit_inbus3: TKnobsInput;
    kleebit_indicator_bus1: TKnobsIndicator;
    kleebit_indicator_bus2: TKnobsIndicator;
    kleebit_indicator_bus3: TKnobsIndicator;
    kleebit_indicator_inbit: TKnobsIndicator;
    kleebit_indicator_invert: TKnobsIndicator;
    kleebit_indicator_load: TKnobsIndicator;
    kleebit_indicator_loop: TKnobsIndicator;
    kleebit_indicator_outbit: TKnobsIndicator;
    kleebit_indicator_step1: TKnobsIndicator;
    kleebit_indicator_step2: TKnobsIndicator;
    kleebit_indicator_step3: TKnobsIndicator;
    kleebit_indicator_step4: TKnobsIndicator;
    kleebit_indicator_step5: TKnobsIndicator;
    kleebit_indicator_step6: TKnobsIndicator;
    kleebit_indicator_step7: TKnobsIndicator;
    kleebit_indicator_step8: TKnobsIndicator;
    kleebit_indicator_step: TKnobsIndicator;
    kleebit_inload: TKnobsInput;
    kleebit_instep: TKnobsInput;
    kleebit_invertinvert: TKnobsInput;
    kleebit_invertmode: TKnobsSelector;
    kleebit_level1: TKnobsSmallKnob;
    kleebit_level2: TKnobsSmallKnob;
    kleebit_level3: TKnobsSmallKnob;
    kleebit_level4: TKnobsSmallKnob;
    kleebit_level5: TKnobsSmallKnob;
    kleebit_level6: TKnobsSmallKnob;
    kleebit_level7: TKnobsSmallKnob;
    kleebit_level8: TKnobsSmallKnob;
    kleebit_loopinvert: TKnobsInput;
    kleebit_loopmode: TKnobsSelector;
    kleebit_mainlevel: TKnobsSmallKnob;
    kleebit_mainlevelmod: TKnobsInput;
    kleebit_outanalog: TKnobsOutput;
    kleebit_outbit: TKnobsOutput;
    kleebit_outbus1: TKnobsOutput;
    kleebit_outbus2: TKnobsOutput;
    kleebit_outbus3: TKnobsOutput;
    kleebit_outinvert: TKnobsOutput;
    kleebit_outloop: TKnobsOutput;
    kleebit_pre1: TKnobsSelector;
    kleebit_pre2: TKnobsSelector;
    kleebit_pre3: TKnobsSelector;
    kleebit_pre4: TKnobsSelector;
    kleebit_pre5: TKnobsSelector;
    kleebit_pre6: TKnobsSelector;
    kleebit_pre7: TKnobsSelector;
    kleebit_pre8: TKnobsSelector;
    kleebit_textlabel_1: TKnobsTextLabel;
    kleebit_textlabel_2: TKnobsTextLabel;
    kleebit_textlabel_3: TKnobsTextLabel;
    kleebit_textlabel_4: TKnobsTextLabel;
    kleebit_textlabel_5: TKnobsTextLabel;
    kleebit_textlabel_6: TKnobsTextLabel;
    kleebit_textlabel_7: TKnobsTextLabel;
    kleebit_textlabel_8: TKnobsTextLabel;
    kleebit_textlabel_a: TKnobsTextLabel;
    kleebit_textlabel_bus1: TKnobsTextLabel;
    kleebit_textlabel_bus2: TKnobsTextLabel;
    kleebit_textlabel_bus3: TKnobsTextLabel;
    kleebit_textlabel_inbit: TKnobsTextLabel;
    kleebit_textlabel_load: TKnobsTextLabel;
    kleebit_textlabel_mainlev: TKnobsTextLabel;
    kleebit_textlabel_outbit: TKnobsTextLabel;
    kleebit_textlabel_outinvert: TKnobsTextLabel;
    kleebit_textlabel_pre: TKnobsTextLabel;
    kleebit_textlabel_step: TKnobsTextLabel;
    lfo: TKnobsModule;
    lfo_display_frequency: TKnobsDisplay;
    lfo_editlabel: TKnobsEditLabel;
    lfo_fm: TKnobsInput;
    lfo_fmlevel: TKnobsSmallKnob;
    lfo_frequency: TKnobsSmallKnob;
    lfo_indicator_out: TKnobsIndicator;
    lfo_indicator_res: TKnobsIndicator;
    lfo_mute: TKnobsSelector;
    lfo_out: TKnobsOutput;
    lfo_outputtype: TKnobsSelector;
    lfo_phase: TKnobsInput;
    lfo_pmlevel: TKnobsSmallKnob;
    lfo_range: TKnobsSelector;
    lfo_res: TKnobsInput;
    lfo_shape: TKnobsSelector;
    lfo_symbol_res: TImage;
    lfo_sync: TKnobsOutput;
    lfo_tabsheet: TTabSheet;
    lfo_textlabel_fm: TKnobsTextLabel;
    lfo_textlabel_phase: TKnobsTextLabel;
    lfo_textlabel_res: TKnobsTextLabel;
    lfo_textlabel_sync: TKnobsTextLabel;
    lfotrig: TKnobsModule;
    lfotrig_count: TKnobsNoKnob;
    lfotrig_display_count: TKnobsDisplay;
    lfotrig_display_frequency: TKnobsDisplay;
    lfotrig_editlabel: TKnobsEditLabel;
    lfotrig_fm: TKnobsInput;
    lfotrig_fmlevel: TKnobsSmallKnob;
    lfotrig_frequency: TKnobsSmallKnob;
    lfotrig_indicator_out: TKnobsIndicator;
    lfotrig_indicator_ready: TKnobsIndicator;
    lfotrig_indicator_trig: TKnobsIndicator;
    lfotrig_mute: TKnobsSelector;
    lfotrig_out: TKnobsOutput;
    lfotrig_outputtype: TKnobsSelector;
    lfotrig_range: TKnobsSelector;
    lfotrig_ready: TKnobsOutput;
    lfotrig_shape: TKnobsSelector;
    lfotrig_symbol_trig: TImage;
    lfotrig_textlabel_count: TKnobsTextLabel;
    lfotrig_textlabel_fm: TKnobsTextLabel;
    lfotrig_textlabel_out: TKnobsTextLabel;
    lfotrig_textlabel_ready: TKnobsTextLabel;
    lfotrig_textlabel_shape: TKnobsTextLabel;
    lfotrig_textlabel_trig: TKnobsTextLabel;
    lfotrig_trig: TKnobsInput;
    logic_tabsheet: TTabSheet;
    logicnot: TKnobsModule;
    logicnot_editlabel: TKnobsEditLabel;
    logicnot_in1: TKnobsInput;
    logicnot_in2: TKnobsInput;
    logicnot_in3: TKnobsInput;
    logicnot_in4: TKnobsInput;
    logicnot_indicator_out1: TKnobsIndicator;
    logicnot_indicator_out2: TKnobsIndicator;
    logicnot_indicator_out3: TKnobsIndicator;
    logicnot_indicator_out4: TKnobsIndicator;
    logicnot_out1: TKnobsOutput;
    logicnot_out2: TKnobsOutput;
    logicnot_out3: TKnobsOutput;
    logicnot_out4: TKnobsOutput;
    logicselector: TKnobsModule;
    logicselector_editlabel: TKnobsEditLabel;
    logicselector_ina: TKnobsInput;
    logicselector_inb: TKnobsInput;
    logicselector_indicator_outa: TKnobsIndicator;
    logicselector_indicator_outb: TKnobsIndicator;
    logicselector_outa: TKnobsOutput;
    logicselector_outb: TKnobsOutput;
    logicselector_sel: TKnobsInput;
    logicselector_textlabel_ina: TKnobsTextLabel;
    logicselector_textlabel_inb: TKnobsTextLabel;
    logicselector_textlabel_outa: TKnobsTextLabel;
    logicselector_textlabel_outb: TKnobsTextLabel;
    logicselector_textlabel_sel: TKnobsTextLabel;
    logisticmap: TKnobsModule;
    logisticmap_clock: TKnobsInput;
    logisticmap_display_highr: TKnobsDisplay;
    logisticmap_display_lowr: TKnobsDisplay;
    logisticmap_editlabel: TKnobsEditLabel;
    logisticmap_highr: TKnobsSmallKnob;
    logisticmap_lowr: TKnobsSmallKnob;
    logisticmap_mute: TKnobsSelector;
    logisticmap_out: TKnobsOutput;
    logisticmap_outtype: TKnobsSelector;
    logisticmap_rmod: TKnobsInput;
    logisticmap_rmodamt: TKnobsSmallKnob;
    logisticmap_smod: TKnobsInput;
    logisticmap_smodamt: TKnobsSmallKnob;
    logisticmap_start: TKnobsInput;
    logisticmap_svalue: TKnobsSmallKnob;
    logisticmap_symbol_clock: TImage;
    logisticmap_symbol_start: TImage;
    logisticmap_textlabel_clock: TKnobsTextLabel;
    logisticmap_textlabel_highr: TKnobsTextLabel;
    logisticmap_textlabel_lowr: TKnobsTextLabel;
    logisticmap_textlabel_rmod: TKnobsTextLabel;
    logisticmap_textlabel_smod: TKnobsTextLabel;
    logisticmap_textlabel_start: TKnobsTextLabel;
    logisticmap_textlabel_svalue: TKnobsTextLabel;
    logisticmap_textlabel_xfade: TKnobsTextLabel;
    logisticmap_xfade: TKnobsSmallKnob;
    lut: TKnobsModule;
    lut_chain: TKnobsInput;
    lut_editlabel: TKnobsEditLabel;
    lut_indicator_step10: TKnobsIndicator;
    lut_indicator_step11: TKnobsIndicator;
    lut_indicator_step12: TKnobsIndicator;
    lut_indicator_step13: TKnobsIndicator;
    lut_indicator_step14: TKnobsIndicator;
    lut_indicator_step15: TKnobsIndicator;
    lut_indicator_step16: TKnobsIndicator;
    lut_indicator_step1: TKnobsIndicator;
    lut_indicator_step2: TKnobsIndicator;
    lut_indicator_step3: TKnobsIndicator;
    lut_indicator_step4: TKnobsIndicator;
    lut_indicator_step5: TKnobsIndicator;
    lut_indicator_step6: TKnobsIndicator;
    lut_indicator_step7: TKnobsIndicator;
    lut_indicator_step8: TKnobsIndicator;
    lut_indicator_step9: TKnobsIndicator;
    lut_mode: TKnobsSelector;
    lut_out: TKnobsOutput;
    lut_select: TKnobsInput;
    lut_step10: TKnobsSlider;
    lut_step11: TKnobsSlider;
    lut_step12: TKnobsSlider;
    lut_step13: TKnobsSlider;
    lut_step14: TKnobsSlider;
    lut_step15: TKnobsSlider;
    lut_step16: TKnobsSlider;
    lut_step1: TKnobsSlider;
    lut_step2: TKnobsSlider;
    lut_step3: TKnobsSlider;
    lut_step4: TKnobsSlider;
    lut_step5: TKnobsSlider;
    lut_step6: TKnobsSlider;
    lut_step7: TKnobsSlider;
    lut_step8: TKnobsSlider;
    lut_step9: TKnobsSlider;
    lut_textlabel_chain: TKnobsTextLabel;
    lut_textlabel_mode: TKnobsTextLabel;
    lut_textlabel_out: TKnobsTextLabel;
    lut_textlabel_select: TKnobsTextLabel;
    lut_textlabel_xfade: TKnobsTextLabel;
    lut_xfade: TKnobsSmallKnob;
    midiccin: TKnobsModule;
    midiccin_cc: TKnobsNoKnob;
    midiccin_ch: TKnobsNoKnob;
    midiccin_display_cc: TKnobsDisplay;
    midiccin_display_ch: TKnobsDisplay;
    midiccin_editlabel: TKnobsEditLabel;
    midiccin_gate: TKnobsOutput;
    midiccin_indicator_gate: TKnobsIndicator;
    midiccin_textlabel_cc: TKnobsTextLabel;
    midiccin_textlabel_gate: TKnobsTextLabel;
    midiccin_textlabel_value: TKnobsTextLabel;
    midiccin_value: TKnobsOutput;
    midiccout: TKnobsModule;
    midiccout_cc: TKnobsNoKnob;
    midiccout_ch: TKnobsNoKnob;
    midiccout_display_cc: TKnobsDisplay;
    midiccout_display_ch: TKnobsDisplay;
    midiccout_editlabel: TKnobsEditLabel;
    midiccout_gate: TKnobsInput;
    midiccout_indicator_gate: TKnobsIndicator;
    midiccout_textlabel_cc: TKnobsTextLabel;
    midiccout_textlabel_gate: TKnobsTextLabel;
    midiccout_textlabel_value: TKnobsTextLabel;
    midiccout_value: TKnobsInput;
    midinotein: TKnobsModule;
    midinotein_ch: TKnobsNoKnob;
    midinotein_display_ch: TKnobsDisplay;
    midinotein_editlabel: TKnobsEditLabel;
    midinotein_gate: TKnobsOutput;
    midinotein_indicator_gate: TKnobsIndicator;
    midinotein_note: TKnobsOutput;
    midinotein_textlabel_gate: TKnobsTextLabel;
    midinotein_textlabel_note: TKnobsTextLabel;
    midinotein_textlabel_velocity: TKnobsTextLabel;
    midinotein_textlabel_veloff: TKnobsTextLabel;
    midinotein_textlabel_velon: TKnobsTextLabel;
    midinotein_veloff: TKnobsOutput;
    midinotein_velon: TKnobsOutput;
    midinoteout: TKnobsModule;
    midinoteout_ch: TKnobsNoKnob;
    midinoteout_display_ch: TKnobsDisplay;
    midinoteout_editlabel: TKnobsEditLabel;
    midinoteout_gate: TKnobsInput;
    midinoteout_indicator_gate: TKnobsIndicator;
    midinoteout_note: TKnobsInput;
    midinoteout_textlabel_gate: TKnobsTextLabel;
    midinoteout_textlabel_note: TKnobsTextLabel;
    midinoteout_textlabel_velocity: TKnobsTextLabel;
    midinoteout_textlabel_veloff: TKnobsTextLabel;
    midinoteout_textlabel_velon: TKnobsTextLabel;
    midinoteout_veloff: TKnobsInput;
    midinoteout_velon: TKnobsInput;
    midiplayer: TKnobsModule;
    midiplayer_ch: TKnobsNoKnob;
    midiplayer_display_ch: TKnobsDisplay;
    midiplayer_done: TKnobsOutput;
    midiplayer_editlabel: TKnobsEditLabel;
    midiplayer_fileselector_filename: TKnobsFileSelector;
    midiplayer_gate: TKnobsOutput;
    midiplayer_indicator_done: TKnobsIndicator;
    midiplayer_indicator_gate: TKnobsIndicator;
    midiplayer_indicator_reset: TKnobsIndicator;
    midiplayer_mode: TKnobsSelector;
    midiplayer_note: TKnobsOutput;
    midiplayer_reset: TKnobsInput;
    midiplayer_symbol_reset: TImage;
    midiplayer_symbol_trig: TImage;
    midiplayer_textlabel_done: TKnobsTextLabel;
    midiplayer_textlabel_gate: TKnobsTextLabel;
    midiplayer_textlabel_indicator_trig: TKnobsIndicator;
    midiplayer_textlabel_note: TKnobsTextLabel;
    midiplayer_textlabel_off: TKnobsTextLabel;
    midiplayer_textlabel_on: TKnobsTextLabel;
    midiplayer_textlabel_reset: TKnobsTextLabel;
    midiplayer_textlabel_trig: TKnobsTextLabel;
    midiplayer_textlabel_velocity: TKnobsTextLabel;
    midiplayer_trig: TKnobsInput;
    midiplayer_veloff: TKnobsOutput;
    midiplayer_velon: TKnobsOutput;
    mixaudio_editlabel: TKnobsEditLabel;
    mixaudio_in1: TKnobsInput;
    mixaudio_in2: TKnobsInput;
    mixaudio_in3: TKnobsInput;
    mixaudio_in4: TKnobsInput;
    mixaudio_in5: TKnobsInput;
    mixaudio_in6: TKnobsInput;
    mixaudio_in7: TKnobsInput;
    mixaudio_in8: TKnobsInput;
    mixaudio_inchain1l: TKnobsInput;
    mixaudio_inchain1r: TKnobsInput;
    mixaudio_inchain2l: TKnobsInput;
    mixaudio_inchain2r: TKnobsInput;
    mixaudio_indicator_solo: TKnobsIndicator;
    mixaudio_insolo: TKnobsInput;
    mixaudio_out1l: TKnobsOutput;
    mixaudio_out1r: TKnobsOutput;
    mixaudio_out2l: TKnobsOutput;
    mixaudio_out2r: TKnobsOutput;
    mixaudio_outsolo: TKnobsOutput;
    mixaudio_pan1: TKnobsSmallKnob;
    mixaudio_pan2: TKnobsSmallKnob;
    mixaudio_pan3: TKnobsSmallKnob;
    mixaudio_pan4: TKnobsSmallKnob;
    mixaudio_pan5: TKnobsSmallKnob;
    mixaudio_pan6: TKnobsSmallKnob;
    mixaudio_pan7: TKnobsSmallKnob;
    mixaudio_pan8: TKnobsSmallKnob;
    mixaudio_textlabel_chain1: TKnobsTextLabel;
    mixaudio_textlabel_chain2: TKnobsTextLabel;
    mixaudio_textlabel_in1: TKnobsTextLabel;
    mixaudio_textlabel_in2: TKnobsTextLabel;
    mixaudio_textlabel_in3: TKnobsTextLabel;
    mixaudio_textlabel_in4: TKnobsTextLabel;
    mixaudio_textlabel_in5: TKnobsTextLabel;
    mixaudio_textlabel_in6: TKnobsTextLabel;
    mixaudio_textlabel_in7: TKnobsTextLabel;
    mixaudio_textlabel_in8: TKnobsTextLabel;
    mixaudio_textlabel_out1: TKnobsTextLabel;
    mixaudio_textlabel_out2: TKnobsTextLabel;
    mixaudio_textlabel_pan: TKnobsTextLabel;
    mixaudio_textlabel_soloin: TKnobsTextLabel;
    mixaudio_textlabel_soloout: TKnobsTextLabel;
    mixaudio_textlabel_vol1: TKnobsTextLabel;
    mixaudio_textlabel_vol2: TKnobsTextLabel;
    mixaudio_vol11: TKnobsSmallKnob;
    mixaudio_vol12: TKnobsSmallKnob;
    mixaudio_vol13: TKnobsSmallKnob;
    mixaudio_vol14: TKnobsSmallKnob;
    mixaudio_vol15: TKnobsSmallKnob;
    mixaudio_vol16: TKnobsSmallKnob;
    mixaudio_vol17: TKnobsSmallKnob;
    mixaudio_vol18: TKnobsSmallKnob;
    mixaudio_vol21: TKnobsSmallKnob;
    mixaudio_vol22: TKnobsSmallKnob;
    mixaudio_vol23: TKnobsSmallKnob;
    mixaudio_vol24: TKnobsSmallKnob;
    mixaudio_vol25: TKnobsSmallKnob;
    mixaudio_vol26: TKnobsSmallKnob;
    mixaudio_vol27: TKnobsSmallKnob;
    mixaudio_vol28: TKnobsSmallKnob;
    mixer_tabsheet: TTabSheet;
    mixm16to1: TKnobsModule;
    mixm16to1_editlabel: TKnobsEditLabel;
    mixm16to1_in10: TKnobsInput;
    mixm16to1_in11: TKnobsInput;
    mixm16to1_in12: TKnobsInput;
    mixm16to1_in13: TKnobsInput;
    mixm16to1_in14: TKnobsInput;
    mixm16to1_in15: TKnobsInput;
    mixm16to1_in16: TKnobsInput;
    mixm16to1_in1: TKnobsInput;
    mixm16to1_in2: TKnobsInput;
    mixm16to1_in3: TKnobsInput;
    mixm16to1_in4: TKnobsInput;
    mixm16to1_in5: TKnobsInput;
    mixm16to1_in6: TKnobsInput;
    mixm16to1_in7: TKnobsInput;
    mixm16to1_in8: TKnobsInput;
    mixm16to1_in9: TKnobsInput;
    mixm16to1_in: TKnobsInput;
    mixm16to1_lev10: TKnobsSlider;
    mixm16to1_lev11: TKnobsSlider;
    mixm16to1_lev12: TKnobsSlider;
    mixm16to1_lev13: TKnobsSlider;
    mixm16to1_lev14: TKnobsSlider;
    mixm16to1_lev15: TKnobsSlider;
    mixm16to1_lev16: TKnobsSlider;
    mixm16to1_lev1: TKnobsSlider;
    mixm16to1_lev2: TKnobsSlider;
    mixm16to1_lev3: TKnobsSlider;
    mixm16to1_lev4: TKnobsSlider;
    mixm16to1_lev5: TKnobsSlider;
    mixm16to1_lev6: TKnobsSlider;
    mixm16to1_lev7: TKnobsSlider;
    mixm16to1_lev8: TKnobsSlider;
    mixm16to1_lev9: TKnobsSlider;
    mixm16to1_mode: TKnobsSelector;
    mixm16to1_mute: TKnobsSelector;
    mixm16to1_out: TKnobsOutput;
    mixm16to1_textlabel_out: TKnobsTextLabel;
    mixm4to1: TKnobsModule;
    mixm4to1_editlabel: TKnobsEditLabel;
    mixm4to1_in1: TKnobsInput;
    mixm4to1_in2: TKnobsInput;
    mixm4to1_in3: TKnobsInput;
    mixm4to1_in4: TKnobsInput;
    mixm4to1_in: TKnobsInput;
    mixm4to1_level1: TKnobsSmallKnob;
    mixm4to1_level2: TKnobsSmallKnob;
    mixm4to1_level3: TKnobsSmallKnob;
    mixm4to1_level4: TKnobsSmallKnob;
    mixm4to1_levmod1: TKnobsInput;
    mixm4to1_levmod2: TKnobsInput;
    mixm4to1_levmod3: TKnobsInput;
    mixm4to1_levmod4: TKnobsInput;
    mixm4to1_mode: TKnobsSelector;
    mixm4to1_mute1: TKnobsSelector;
    mixm4to1_mute2: TKnobsSelector;
    mixm4to1_mute3: TKnobsSelector;
    mixm4to1_mute4: TKnobsSelector;
    mixm4to1_out: TKnobsOutput;
    mixm6to6: TKnobsModule;
    mixm6to6_box_inchains: TKnobsBox;
    mixm6to6_box_ins: TKnobsBox;
    mixm6to6_box_outchains: TKnobsBox;
    mixm6to6_box_outs: TKnobsBox;
    mixm6to6_editlabel: TKnobsEditLabel;
    mixm6to6_in1: TKnobsInput;
    mixm6to6_in2: TKnobsInput;
    mixm6to6_in3: TKnobsInput;
    mixm6to6_in4: TKnobsInput;
    mixm6to6_in5: TKnobsInput;
    mixm6to6_in6: TKnobsInput;
    mixm6to6_inchcol1: TKnobsInput;
    mixm6to6_inchcol2: TKnobsInput;
    mixm6to6_inchcol3: TKnobsInput;
    mixm6to6_inchcol4: TKnobsInput;
    mixm6to6_inchcol5: TKnobsInput;
    mixm6to6_inchcol6: TKnobsInput;
    mixm6to6_inr1c1: TKnobsInput;
    mixm6to6_inr1c2: TKnobsInput;
    mixm6to6_inr1c3: TKnobsInput;
    mixm6to6_inr1c4: TKnobsInput;
    mixm6to6_inr1c5: TKnobsInput;
    mixm6to6_inr1c6: TKnobsInput;
    mixm6to6_inr2c1: TKnobsInput;
    mixm6to6_inr2c2: TKnobsInput;
    mixm6to6_inr2c3: TKnobsInput;
    mixm6to6_inr2c4: TKnobsInput;
    mixm6to6_inr2c5: TKnobsInput;
    mixm6to6_inr2c6: TKnobsInput;
    mixm6to6_inr3c1: TKnobsInput;
    mixm6to6_inr3c2: TKnobsInput;
    mixm6to6_inr3c3: TKnobsInput;
    mixm6to6_inr3c4: TKnobsInput;
    mixm6to6_inr3c5: TKnobsInput;
    mixm6to6_inr3c6: TKnobsInput;
    mixm6to6_inr4c1: TKnobsInput;
    mixm6to6_inr4c2: TKnobsInput;
    mixm6to6_inr4c3: TKnobsInput;
    mixm6to6_inr4c4: TKnobsInput;
    mixm6to6_inr4c5: TKnobsInput;
    mixm6to6_inr4c6: TKnobsInput;
    mixm6to6_inr5c1: TKnobsInput;
    mixm6to6_inr5c2: TKnobsInput;
    mixm6to6_inr5c3: TKnobsInput;
    mixm6to6_inr5c4: TKnobsInput;
    mixm6to6_inr5c5: TKnobsInput;
    mixm6to6_inr5c6: TKnobsInput;
    mixm6to6_inr6c1: TKnobsInput;
    mixm6to6_inr6c2: TKnobsInput;
    mixm6to6_inr6c3: TKnobsInput;
    mixm6to6_inr6c4: TKnobsInput;
    mixm6to6_inr6c5: TKnobsInput;
    mixm6to6_inr6c6: TKnobsInput;
    mixm6to6_levelr1c1: TKnobsSmallKnob;
    mixm6to6_levelr1c2: TKnobsSmallKnob;
    mixm6to6_levelr1c3: TKnobsSmallKnob;
    mixm6to6_levelr1c4: TKnobsSmallKnob;
    mixm6to6_levelr1c5: TKnobsSmallKnob;
    mixm6to6_levelr1c6: TKnobsSmallKnob;
    mixm6to6_levelr2c1: TKnobsSmallKnob;
    mixm6to6_levelr2c2: TKnobsSmallKnob;
    mixm6to6_levelr2c3: TKnobsSmallKnob;
    mixm6to6_levelr2c4: TKnobsSmallKnob;
    mixm6to6_levelr2c5: TKnobsSmallKnob;
    mixm6to6_levelr2c6: TKnobsSmallKnob;
    mixm6to6_levelr3c1: TKnobsSmallKnob;
    mixm6to6_levelr3c2: TKnobsSmallKnob;
    mixm6to6_levelr3c3: TKnobsSmallKnob;
    mixm6to6_levelr3c4: TKnobsSmallKnob;
    mixm6to6_levelr3c5: TKnobsSmallKnob;
    mixm6to6_levelr3c6: TKnobsSmallKnob;
    mixm6to6_levelr4c1: TKnobsSmallKnob;
    mixm6to6_levelr4c2: TKnobsSmallKnob;
    mixm6to6_levelr4c3: TKnobsSmallKnob;
    mixm6to6_levelr4c4: TKnobsSmallKnob;
    mixm6to6_levelr4c5: TKnobsSmallKnob;
    mixm6to6_levelr4c6: TKnobsSmallKnob;
    mixm6to6_levelr5c1: TKnobsSmallKnob;
    mixm6to6_levelr5c2: TKnobsSmallKnob;
    mixm6to6_levelr5c3: TKnobsSmallKnob;
    mixm6to6_levelr5c4: TKnobsSmallKnob;
    mixm6to6_levelr5c5: TKnobsSmallKnob;
    mixm6to6_levelr5c6: TKnobsSmallKnob;
    mixm6to6_levelr6c1: TKnobsSmallKnob;
    mixm6to6_levelr6c2: TKnobsSmallKnob;
    mixm6to6_levelr6c3: TKnobsSmallKnob;
    mixm6to6_levelr6c4: TKnobsSmallKnob;
    mixm6to6_levelr6c5: TKnobsSmallKnob;
    mixm6to6_levelr6c6: TKnobsSmallKnob;
    mixm6to6_mode: TKnobsSelector;
    mixm6to6_mute1: TKnobsSelector;
    mixm6to6_mute2: TKnobsSelector;
    mixm6to6_mute3: TKnobsSelector;
    mixm6to6_mute4: TKnobsSelector;
    mixm6to6_mute5: TKnobsSelector;
    mixm6to6_mute6: TKnobsSelector;
    mixm6to6_out1: TKnobsOutput;
    mixm6to6_out2: TKnobsOutput;
    mixm6to6_out3: TKnobsOutput;
    mixm6to6_out4: TKnobsOutput;
    mixm6to6_out5: TKnobsOutput;
    mixm6to6_out6: TKnobsOutput;
    mixm6to6_outchrow1: TKnobsOutput;
    mixm6to6_outchrow2: TKnobsOutput;
    mixm6to6_outchrow3: TKnobsOutput;
    mixm6to6_outchrow4: TKnobsOutput;
    mixm6to6_outchrow5: TKnobsOutput;
    mixm6to6_outchrow6: TKnobsOutput;
    mixm6to6_textlabel_chains: TKnobsTextLabel;
    mixm6to6_textlabel_in: TKnobsTextLabel;
    mixm6to6_textlabel_out: TKnobsTextLabel;
    mixq1to1: TKnobsModule;
    mixq1to1_editlabel: TKnobsEditLabel;
    mixq1to1_inll1: TKnobsInput;
    mixq1to1_inll: TKnobsInput;
    mixq1to1_inlr1: TKnobsInput;
    mixq1to1_inlr: TKnobsInput;
    mixq1to1_inrl1: TKnobsInput;
    mixq1to1_inrl: TKnobsInput;
    mixq1to1_inrr1: TKnobsInput;
    mixq1to1_inrr: TKnobsInput;
    mixq1to1_level1: TKnobsSmallKnob;
    mixq1to1_levmod1: TKnobsInput;
    mixq1to1_mode: TKnobsSelector;
    mixq1to1_mute1: TKnobsSelector;
    mixq1to1_outll: TKnobsOutput;
    mixq1to1_outlr: TKnobsOutput;
    mixq1to1_outrl: TKnobsOutput;
    mixq1to1_outrr: TKnobsOutput;
    mixs2to1: TKnobsModule;
    mixs2to1_editlabel: TKnobsEditLabel;
    mixs2to1_inl1: TKnobsInput;
    mixs2to1_inl2: TKnobsInput;
    mixs2to1_inl: TKnobsInput;
    mixs2to1_inr1: TKnobsInput;
    mixs2to1_inr2: TKnobsInput;
    mixs2to1_inr: TKnobsInput;
    mixs2to1_level1: TKnobsSmallKnob;
    mixs2to1_level2: TKnobsSmallKnob;
    mixs2to1_levmod1: TKnobsInput;
    mixs2to1_levmod2: TKnobsInput;
    mixs2to1_mode: TKnobsSelector;
    mixs2to1_mute1: TKnobsSelector;
    mixs2to1_mute2: TKnobsSelector;
    mixs2to1_outl: TKnobsOutput;
    mixs2to1_outr: TKnobsOutput;
    mixt1to1: TKnobsModule;
    mixt1to1_editlabel: TKnobsEditLabel;
    mixt1to1_inl1: TKnobsInput;
    mixt1to1_inl: TKnobsInput;
    mixt1to1_inm1: TKnobsInput;
    mixt1to1_inm: TKnobsInput;
    mixt1to1_inr1: TKnobsInput;
    mixt1to1_inr: TKnobsInput;
    mixt1to1_level1: TKnobsSmallKnob;
    mixt1to1_levmod1: TKnobsInput;
    mixt1to1_mode: TKnobsSelector;
    mixt1to1_mute1: TKnobsSelector;
    mixt1to1_outl: TKnobsOutput;
    mixt1to1_outm: TKnobsOutput;
    mixt1to1_outr: TKnobsOutput;
    modal: TKnobsModule;
    modal_editlabel: TKnobsEditLabel;
    modal_fm: TKnobsInput;
    modal_fmamt: TKnobsSmallKnob;
    modal_freq10: TKnobsSmallKnob;
    modal_freq11: TKnobsSmallKnob;
    modal_freq1: TKnobsSmallKnob;
    modal_freq2: TKnobsSmallKnob;
    modal_freq3: TKnobsSmallKnob;
    modal_freq4: TKnobsSmallKnob;
    modal_freq5: TKnobsSmallKnob;
    modal_freq6: TKnobsSmallKnob;
    modal_freq7: TKnobsSmallKnob;
    modal_freq8: TKnobsSmallKnob;
    modal_freq9: TKnobsSmallKnob;
    modal_in: TKnobsInput;
    modal_level10: TKnobsSmallKnob;
    modal_level11: TKnobsSmallKnob;
    modal_level1: TKnobsSmallKnob;
    modal_level2: TKnobsSmallKnob;
    modal_level3: TKnobsSmallKnob;
    modal_level4: TKnobsSmallKnob;
    modal_level5: TKnobsSmallKnob;
    modal_level6: TKnobsSmallKnob;
    modal_level7: TKnobsSmallKnob;
    modal_level8: TKnobsSmallKnob;
    modal_level9: TKnobsSmallKnob;
    modal_level: TKnobsSmallKnob;
    modal_out: TKnobsOutput;
    modal_q10: TKnobsSmallKnob;
    modal_q11: TKnobsSmallKnob;
    modal_q1: TKnobsSmallKnob;
    modal_q2: TKnobsSmallKnob;
    modal_q3: TKnobsSmallKnob;
    modal_q4: TKnobsSmallKnob;
    modal_q5: TKnobsSmallKnob;
    modal_q6: TKnobsSmallKnob;
    modal_q7: TKnobsSmallKnob;
    modal_q8: TKnobsSmallKnob;
    modal_q9: TKnobsSmallKnob;
    modal_textlable_fm: TKnobsTextLabel;
    modal_textlable_fma: TKnobsTextLabel;
    modal_textlable_fmf: TKnobsTextLabel;
    modal_textlable_fmq: TKnobsTextLabel;
    modal_textlable_in: TKnobsTextLabel;
    modal_textlable_lev: TKnobsTextLabel;
    modal_textlable_out: TKnobsTextLabel;
    modal_textlable_rnd: TKnobsTextLabel;
    morse: TKnobsModule;
    morse_clock: TKnobsInput;
    morse_display_text: TKnobsDisplay;
    morse_editlabel: TKnobsEditLabel;
    morse_indicator_clock: TKnobsIndicator;
    morse_indicator_out: TKnobsIndicator;
    morse_indicator_reset: TKnobsIndicator;
    morse_out: TKnobsOutput;
    morse_reset: TKnobsInput;
    morse_textlabel_clock: TKnobsTextLabel;
    morse_textlabel_res: TKnobsTextLabel;
    multisandh: TKnobsModule;
    multisandh_editlabel: TKnobsEditLabel;
    multisandh_in10: TKnobsInput;
    multisandh_in11: TKnobsInput;
    multisandh_in12: TKnobsInput;
    multisandh_in1: TKnobsInput;
    multisandh_in2: TKnobsInput;
    multisandh_in3: TKnobsInput;
    multisandh_in4: TKnobsInput;
    multisandh_in5: TKnobsInput;
    multisandh_in6: TKnobsInput;
    multisandh_in7: TKnobsInput;
    multisandh_in8: TKnobsInput;
    multisandh_in9: TKnobsInput;
    multisandh_indicator_trig: TKnobsIndicator;
    multisandh_out10: TKnobsOutput;
    multisandh_out11: TKnobsOutput;
    multisandh_out12: TKnobsOutput;
    multisandh_out1: TKnobsOutput;
    multisandh_out2: TKnobsOutput;
    multisandh_out3: TKnobsOutput;
    multisandh_out4: TKnobsOutput;
    multisandh_out5: TKnobsOutput;
    multisandh_out6: TKnobsOutput;
    multisandh_out7: TKnobsOutput;
    multisandh_out8: TKnobsOutput;
    multisandh_out9: TKnobsOutput;
    multisandh_symbol_trig: TImage;
    multisandh_textlabel_in: TKnobsTextLabel;
    multisandh_textlabel_out: TKnobsTextLabel;
    multisandh_textlabel_trig: TKnobsTextLabel;
    multisandh_trig: TKnobsInput;
    mux: TKnobsModule;
    mux_control: TKnobsInput;
    mux_editlabel: TKnobsEditLabel;
    mux_in0: TKnobsInput;
    mux_in10: TKnobsInput;
    mux_in11: TKnobsInput;
    mux_in1: TKnobsInput;
    mux_in2: TKnobsInput;
    mux_in3: TKnobsInput;
    mux_in4: TKnobsInput;
    mux_in5: TKnobsInput;
    mux_in6: TKnobsInput;
    mux_in7: TKnobsInput;
    mux_in8: TKnobsInput;
    mux_in9: TKnobsInput;
    mux_indicator_0: TKnobsIndicator;
    mux_indicator_10: TKnobsIndicator;
    mux_indicator_11: TKnobsIndicator;
    mux_indicator_1: TKnobsIndicator;
    mux_indicator_2: TKnobsIndicator;
    mux_indicator_3: TKnobsIndicator;
    mux_indicator_4: TKnobsIndicator;
    mux_indicator_5: TKnobsIndicator;
    mux_indicator_6: TKnobsIndicator;
    mux_indicator_7: TKnobsIndicator;
    mux_indicator_8: TKnobsIndicator;
    mux_indicator_9: TKnobsIndicator;
    mux_out: TKnobsOutput;
    mux_texxtlabel_control: TKnobsTextLabel;
    mux_texxtlabel_crossfade: TKnobsTextLabel;
    mux_xfade: TKnobsSmallKnob;
    neural: TKnobsModule;
    neural_editlabel: TKnobsEditLabel;
    neural_fileselector_filename: TKnobsFileSelector;
    neural_in10: TKnobsInput;
    neural_in11: TKnobsInput;
    neural_in12: TKnobsInput;
    neural_in1: TKnobsInput;
    neural_in2: TKnobsInput;
    neural_in3: TKnobsInput;
    neural_in4: TKnobsInput;
    neural_in5: TKnobsInput;
    neural_in6: TKnobsInput;
    neural_in7: TKnobsInput;
    neural_in8: TKnobsInput;
    neural_in9: TKnobsInput;
    neural_inlevel: TKnobsSmallKnob;
    neural_out10: TKnobsOutput;
    neural_out11: TKnobsOutput;
    neural_out12: TKnobsOutput;
    neural_out1: TKnobsOutput;
    neural_out2: TKnobsOutput;
    neural_out3: TKnobsOutput;
    neural_out4: TKnobsOutput;
    neural_out5: TKnobsOutput;
    neural_out6: TKnobsOutput;
    neural_out7: TKnobsOutput;
    neural_out8: TKnobsOutput;
    neural_out9: TKnobsOutput;
    neural_outlevel: TKnobsSmallKnob;
    neural_textlabel_inlevel: TKnobsTextLabel;
    neural_textlabel_outlevel: TKnobsTextLabel;
    noise: TKnobsModule;
    noise_color: TKnobsSmallKnob;
    noise_colormod: TKnobsInput;
    noise_colormodamt: TKnobsSmallKnob;
    noise_display_color: TKnobsDisplay;
    noise_editlabel: TKnobsEditLabel;
    noise_mute: TKnobsSelector;
    noise_out: TKnobsOutput;
    noise_textlabel_color: TKnobsTextLabel;
    noise_textlabel_colormod: TKnobsTextLabel;
    noiselfo: TKnobsModule;
    noiselfo_color: TKnobsSmallKnob;
    noiselfo_colormod: TKnobsInput;
    noiselfo_colormodamt: TKnobsSmallKnob;
    noiselfo_display_color: TKnobsDisplay;
    noiselfo_editlabel: TKnobsEditLabel;
    noiselfo_indicator_out: TKnobsIndicator;
    noiselfo_mute: TKnobsSelector;
    noiselfo_out: TKnobsOutput;
    noiselfo_outputtype: TKnobsSelector;
    noiselfo_textlabel_color: TKnobsTextLabel;
    noiselfo_textlabel_colormod: TKnobsTextLabel;
    noiselfo_textlabel_out: TKnobsTextLabel;
    noiselfotrig: TKnobsModule;
    noiselfotrig_color: TKnobsSmallKnob;
    noiselfotrig_colormod: TKnobsInput;
    noiselfotrig_colormodamt: TKnobsSmallKnob;
    noiselfotrig_display_color: TKnobsDisplay;
    noiselfotrig_editlabel: TKnobsEditLabel;
    noiselfotrig_indicator_out: TKnobsIndicator;
    noiselfotrig_indicator_trig: TKnobsIndicator;
    noiselfotrig_mute: TKnobsSelector;
    noiselfotrig_out: TKnobsOutput;
    noiselfotrig_outputtype: TKnobsSelector;
    noiselfotrig_symbol_trig: TImage;
    noiselfotrig_textlabel_out: TKnobsTextLabel;
    noiselfotrig_textlabel_trig: TKnobsTextLabel;
    noiselfotrig_trig: TKnobsInput;
    noiselfotrix_textlabel_color: TKnobsTextLabel;
    noisetrig: TKnobsModule;
    noisetrig_color: TKnobsSmallKnob;
    noisetrig_colormod: TKnobsInput;
    noisetrig_colormodamt: TKnobsSmallKnob;
    noisetrig_display_color: TKnobsDisplay;
    noisetrig_editlabel: TKnobsEditLabel;
    noisetrig_mute: TKnobsSelector;
    noisetrig_out: TKnobsOutput;
    noisetrig_symbol_trig: TImage;
    noisetrig_textlabel_color: TKnobsTextLabel;
    noisetrig_textlabel_colormod: TKnobsTextLabel;
    noisetrig_textlabel_trig: TKnobsTextLabel;
    noisetrig_trig: TKnobsInput;
    note_tabsheet: TTabSheet;
    notequantizer: TKnobsModule;
    notequantizer_editlabel: TKnobsEditLabel;
    notequantizer_in: TKnobsInput;
    notequantizer_level: TKnobsSmallKnob;
    notequantizer_note0: TKnobsSelector;
    notequantizer_note10: TKnobsSelector;
    notequantizer_note11: TKnobsSelector;
    notequantizer_note1: TKnobsSelector;
    notequantizer_note2: TKnobsSelector;
    notequantizer_note3: TKnobsSelector;
    notequantizer_note4: TKnobsSelector;
    notequantizer_note5: TKnobsSelector;
    notequantizer_note6: TKnobsSelector;
    notequantizer_note7: TKnobsSelector;
    notequantizer_note8: TKnobsSelector;
    notequantizer_note9: TKnobsSelector;
    notequantizer_out: TKnobsOutput;
    notequantizer_textlabel_level: TKnobsTextLabel;
    notes: TKnobsModule;
    notes_display: TKnobsDisplay;
    notes_editlabel: TKnobsEditLabel;
    notetodelay: TKnobsModule;
    notetodelay_editlabel: TKnobsEditLabel;
    notetodelay_in: TKnobsInput;
    notetodelay_out: TKnobsOutput;
    notetodelay_textlabel_in: TKnobsTextLabel;
    notetodelay_textlabel_out: TKnobsTextLabel;
    osc: TKnobsModule;
    osc_bandlimit: TKnobsSmallKnob;
    osc_cents: TKnobsSmallKnob;
    osc_display_cents: TKnobsDisplay;
    osc_display_frequency: TKnobsDisplay;
    osc_editlabel: TKnobsEditLabel;
    osc_fm: TKnobsInput;
    osc_fmlevel: TKnobsSmallKnob;
    osc_freq: TKnobsInput;
    osc_frequency: TKnobsSmallKnob;
    osc_mute: TKnobsSelector;
    osc_out: TKnobsOutput;
    osc_phase: TKnobsInput;
    osc_pmlevel: TKnobsSmallKnob;
    osc_shape: TKnobsSelector;
    osc_symbol_sync: TImage;
    osc_sync: TKnobsInput;
    osc_tabsheet: TTabSheet;
    osc_textlabel_blimit: TKnobsTextLabel;
    osc_textlabel_fm: TKnobsTextLabel;
    osc_textlabel_freq: TKnobsTextLabel;
    osc_textlabel_phase: TKnobsTextLabel;
    osc_textlabel_sync: TKnobsTextLabel;
    oscmessage: TKnobsModule;
    oscmessage_display_address: TKnobsDisplay;
    oscmessage_editlabel: TKnobsEditLabel;
    oscmessage_indicator_syncout: TKnobsIndicator;
    oscmessage_indicator_trigger: TKnobsIndicator;
    oscmessage_input: TKnobsInput;
    oscmessage_out: TKnobsOutput;
    oscmessage_symbol_trigger: TImage;
    oscmessage_textlabel_address: TKnobsTextLabel;
    oscmessage_textlabel_out: TKnobsTextLabel;
    oscmessage_textlabel_send: TKnobsTextLabel;
    oscmessage_trigger: TKnobsInput;
    osctrig: TKnobsModule;
    osctrig_bandlimit: TKnobsSmallKnob;
    osctrig_cents: TKnobsSmallKnob;
    osctrig_count: TKnobsNoKnob;
    osctrig_display_cents: TKnobsDisplay;
    osctrig_display_count: TKnobsDisplay;
    osctrig_display_frequency: TKnobsDisplay;
    osctrig_editlabel: TKnobsEditLabel;
    osctrig_fm: TKnobsInput;
    osctrig_fmlevel: TKnobsSmallKnob;
    osctrig_freq: TKnobsInput;
    osctrig_frequency: TKnobsSmallKnob;
    osctrig_mute: TKnobsSelector;
    osctrig_out: TKnobsOutput;
    osctrig_shape: TKnobsSelector;
    osctrig_symbol_trig: TImage;
    osctrig_textlabel_bandlimit: TKnobsTextLabel;
    osctrig_textlabel_count: TKnobsTextLabel;
    osctrig_textlabel_fm: TKnobsTextLabel;
    osctrig_textlabel_freq: TKnobsTextLabel;
    osctrig_textlabel_shape: TKnobsTextLabel;
    osctrig_textlabel_trig: TKnobsTextLabel;
    osctrig_trig: TKnobsInput;
    pan: TKnobsModule;
    pan_control: TKnobsInput;
    pan_editlabel: TKnobsEditLabel;
    pan_in: TKnobsInput;
    pan_intype: TKnobsSelector;
    pan_out1: TKnobsOutput;
    pan_out2: TKnobsOutput;
    pan_position: TKnobsSmallKnob;
    pan_posmod: TKnobsSmallKnob;
    pan_textlabel_control: TKnobsTextLabel;
    pan_textlabel_in: TKnobsTextLabel;
    pan_textlabel_out1: TKnobsTextLabel;
    pan_textlabel_out2: TKnobsTextLabel;
    panel1: TKnobsModule;
    panel2: TKnobsModule;
    panel2_editlabel: TKnobsEditLabel;
    panel3: TKnobsModule;
    panel3_editlabel: TKnobsEditLabel;
    panel4: TKnobsModule;
    panel4_editlabel: TKnobsEditLabel;
    panel5: TKnobsModule;
    panel5_editlabel: TKnobsEditLabel;
    pattern: TKnobsModule;
    pattern_display_step1: TKnobsDisplay;
    pattern_display_step2: TKnobsDisplay;
    pattern_display_step3: TKnobsDisplay;
    pattern_display_step4: TKnobsDisplay;
    pattern_display_step5: TKnobsDisplay;
    pattern_display_step6: TKnobsDisplay;
    pattern_display_step7: TKnobsDisplay;
    pattern_display_step8: TKnobsDisplay;
    pattern_editlabel: TKnobsEditLabel;
    pattern_indicator_out: TKnobsIndicator;
    pattern_indicator_res: TKnobsIndicator;
    pattern_indicator_trig: TKnobsIndicator;
    pattern_out: TKnobsOutput;
    pattern_res: TKnobsInput;
    pattern_step1: TKnobsSmallKnob;
    pattern_step2: TKnobsSmallKnob;
    pattern_step3: TKnobsSmallKnob;
    pattern_step4: TKnobsSmallKnob;
    pattern_step5: TKnobsSmallKnob;
    pattern_step6: TKnobsSmallKnob;
    pattern_step7: TKnobsSmallKnob;
    pattern_step8: TKnobsSmallKnob;
    pattern_symbol_res: TImage;
    pattern_symbol_trig: TImage;
    pattern_textlabel_durations: TKnobsTextLabel;
    pattern_textlabel_res: TKnobsTextLabel;
    pattern_textlabel_trig: TKnobsTextLabel;
    pattern_trig: TKnobsInput;
    phasedetect: TKnobsModule;
    phasedetect_alpha: TKnobsSmallKnob;
    phasedetect_alphamod: TKnobsInput;
    phasedetect_alphamodamt: TKnobsSmallKnob;
    phasedetect_editlabel: TKnobsEditLabel;
    phasedetect_in1: TKnobsInput;
    phasedetect_in2: TKnobsInput;
    phasedetect_indicator_down: TKnobsIndicator;
    phasedetect_indicator_lock: TKnobsIndicator;
    phasedetect_indicator_up: TKnobsIndicator;
    phasedetect_lock: TKnobsOutput;
    phasedetect_out: TKnobsOutput;
    phasedetect_textlabel_cmpin: TKnobsTextLabel;
    phasedetect_textlabel_filter: TKnobsTextLabel;
    phasedetect_textlabel_filterout: TKnobsTextLabel;
    phasedetect_textlabel_lock: TKnobsTextLabel;
    phasedetect_textlabel_sigin: TKnobsTextLabel;
    phasedetect_type: TKnobsSelector;
    phasedetect_typesel: TKnobsInput;
    pichchange_freezein: TKnobsInput;
    pinkfilter: TKnobsModule;
    pinkfilter_editlabel: TKnobsEditLabel;
    pinkfilter_gain: TKnobsSmallKnob;
    pinkfilter_in: TKnobsInput;
    pinkfilter_mode: TKnobsSelector;
    pinkfilter_out: TKnobsOutput;
    pinkfilter_textlabel_gain: TKnobsTextLabel;
    pinkfilter_texxtlabel_in: TKnobsTextLabel;
    pitchchange: TKnobsModule;
    pitchchange_delay: TKnobsSmallKnob;
    pitchchange_depth: TKnobsSmallKnob;
    pitchchange_dry: TKnobsSmallKnob;
    pitchchange_editlabel: TKnobsEditLabel;
    pitchchange_feedback: TKnobsSmallKnob;
    pitchchange_freeze: TKnobsSelector;
    pitchchange_in: TKnobsInput;
    pitchchange_mute: TKnobsSelector;
    pitchchange_out: TKnobsOutput;
    pitchchange_rate: TKnobsSmallKnob;
    pitchchange_textlabel_delay: TKnobsTextLabel;
    pitchchange_textlabel_depth: TKnobsTextLabel;
    pitchchange_textlabel_dry: TKnobsTextLabel;
    pitchchange_textlabel_feedback: TKnobsTextLabel;
    pitchchange_textlabel_rate: TKnobsTextLabel;
    pitchchange_textlabel_wet: TKnobsTextLabel;
    pitchchange_wet: TKnobsSmallKnob;
    pitchshift: TKnobsModule;
    pitchshift_delay: TKnobsSmallKnob;
    pitchshift_display_delay: TKnobsDisplay;
    pitchshift_display_shift: TKnobsDisplay;
    pitchshift_display_shiftfine: TKnobsDisplay;
    pitchshift_editlabel: TKnobsEditLabel;
    pitchshift_in: TKnobsInput;
    pitchshift_mute: TKnobsSelector;
    pitchshift_out: TKnobsOutput;
    pitchshift_shift: TKnobsSmallKnob;
    pitchshift_shiftfine: TKnobsSmallKnob;
    pitchshift_shiftmod: TKnobsInput;
    pitchshift_shiftmodamt: TKnobsSmallKnob;
    pitchshift_textlabel_delay: TKnobsTextLabel;
    pitchshift_textlabel_shift: TKnobsTextLabel;
    pluck: TKnobsModule;
    pluck_bclevel: TKnobsSmallKnob;
    pluck_brighctrl: TKnobsInput;
    pluck_brightness: TKnobsSmallKnob;
    pluck_cents: TKnobsSmallKnob;
    pluck_display_cents: TKnobsDisplay;
    pluck_display_frequency: TKnobsDisplay;
    pluck_editlabel: TKnobsEditLabel;
    pluck_feedback: TKnobsSmallKnob;
    pluck_fm: TKnobsInput;
    pluck_fmlevel: TKnobsSmallKnob;
    pluck_freq: TKnobsInput;
    pluck_frequency: TKnobsSmallKnob;
    pluck_mute: TKnobsSelector;
    pluck_noise: TKnobsSmallKnob;
    pluck_noisedepth: TKnobsSmallKnob;
    pluck_noisemod: TKnobsInput;
    pluck_out: TKnobsOutput;
    pluck_pluck: TKnobsInput;
    pluck_plucklevel: TKnobsSmallKnob;
    pluck_textlabel_brightnesss: TKnobsTextLabel;
    pluck_textlabel_feedback: TKnobsTextLabel;
    pluck_textlabel_fm: TKnobsTextLabel;
    pluck_textlabel_freq: TKnobsTextLabel;
    pluck_textlabel_noise: TKnobsTextLabel;
    pluck_textlabel_pluck: TKnobsTextLabel;
    poetry: TKnobsModule;
    poetry_display_history: TKnobsDisplay;
    poetry_display_seedlen: TKnobsDisplay;
    poetry_editlabel: TKnobsEditLabel;
    poetry_history: TKnobsSmallKnob;
    poetry_in: TKnobsInput;
    poetry_indicator_newinput: TKnobsIndicator;
    poetry_indicator_newoutput: TKnobsIndicator;
    poetry_newinput: TKnobsInput;
    poetry_newoutput: TKnobsInput;
    poetry_out: TKnobsOutput;
    poetry_seedlen: TKnobsSmallKnob;
    poetry_symbol_newinput: TImage;
    poetry_textlabel_history: TKnobsTextLabel;
    poetry_textlabel_in: TKnobsTextLabel;
    poetry_textlabel_newinput: TKnobsTextLabel;
    poetry_textlabel_newoutput: TKnobsTextLabel;
    poetry_textlabel_seedlen: TKnobsTextLabel;
    poety_symbol_newoutput: TImage;
    progdivider: TKnobsModule;
    progdivider_display_highcount: TKnobsDisplay;
    progdivider_display_lowcount: TKnobsDisplay;
    progdivider_display_steps: TKnobsDisplay;
    progdivider_editlabel: TKnobsEditLabel;
    progdivider_highcount: TKnobsSmallKnob;
    progdivider_indicator_out: TKnobsIndicator;
    progdivider_lowcount: TKnobsSmallKnob;
    progdivider_out: TKnobsOutput;
    progdivider_reset: TKnobsInput;
    progdivider_select: TKnobsInput;
    progdivider_selectlev: TKnobsSmallKnob;
    progdivider_steps: TKnobsSmallKnob;
    progdivider_symbol_reset: TImage;
    progdivider_symbol_trig: TImage;
    progdivider_textlabel_highcount: TKnobsTextLabel;
    progdivider_textlabel_lowcount: TKnobsTextLabel;
    progdivider_textlabel_reset: TKnobsTextLabel;
    progdivider_textlabel_select: TKnobsTextLabel;
    progdivider_textlabel_steps: TKnobsTextLabel;
    progdivider_textlabel_trig: TKnobsTextLabel;
    progdivider_trig: TKnobsInput;
    pulses: TKnobsModule;
    pulses_display_frequency: TKnobsDisplay;
    pulses_dist: TKnobsSmallKnob;
    pulses_distmod: TKnobsInput;
    pulses_distmodamt: TKnobsSmallKnob;
    pulses_editlabel: TKnobsEditLabel;
    pulses_frequency: TKnobsSmallKnob;
    pulses_indicator_out: TKnobsIndicator;
    pulses_lambda: TKnobsSmallKnob;
    pulses_out: TKnobsOutput;
    pulses_outputtype: TKnobsSelector;
    pulses_range: TKnobsSelector;
    pulses_rndmode: TKnobsSelector;
    pulses_syncmode: TKnobsSelector;
    pulses_textlabel_distribution: TKnobsTextLabel;
    pulses_textlabel_lambda: TKnobsTextLabel;
    pulses_textlabel_out: TKnobsTextLabel;
    quantizer: TKnobsModule;
    quantizer_display_qsteps: TKnobsDisplay;
    quantizer_editlabel: TKnobsEditLabel;
    quantizer_in: TKnobsInput;
    quantizer_level: TKnobsSmallKnob;
    quantizer_mute: TKnobsSelector;
    quantizer_out: TKnobsOutput;
    quantizer_qsteps: TKnobsSmallKnob;
    quantizer_textlabel_in: TKnobsTextLabel;
    quantizer_textlabel_level: TKnobsTextLabel;
    quantizer_textlabel_notes: TKnobsTextLabel;
    randomwalklfo: TKnobsModule;
    randomwalklfo_color: TKnobsSmallKnob;
    randomwalklfo_colormod: TKnobsInput;
    randomwalklfo_colormodamt: TKnobsSmallKnob;
    randomwalklfo_display_distance: TKnobsDisplay;
    randomwalklfo_display_frequency: TKnobsDisplay;
    randomwalklfo_distance: TKnobsSmallKnob;
    randomwalklfo_editlabel: TKnobsEditLabel;
    randomwalklfo_fm: TKnobsInput;
    randomwalklfo_fmlevel: TKnobsSmallKnob;
    randomwalklfo_frequency: TKnobsSmallKnob;
    randomwalklfo_indicator_outx: TKnobsIndicator;
    randomwalklfo_indicator_outy: TKnobsIndicator;
    randomwalklfo_indicator_outz: TKnobsIndicator;
    randomwalklfo_lambda: TKnobsSmallKnob;
    randomwalklfo_mode: TKnobsSelector;
    randomwalklfo_mute: TKnobsSelector;
    randomwalklfo_outputtype: TKnobsSelector;
    randomwalklfo_outx: TKnobsOutput;
    randomwalklfo_outy: TKnobsOutput;
    randomwalklfo_outz: TKnobsOutput;
    randomwalklfo_range: TKnobsSelector;
    randomwalklfo_textlabel_color: TKnobsTextLabel;
    randomwalklfo_textlabel_distance: TKnobsTextLabel;
    randomwalklfo_textlabel_fm: TKnobsTextLabel;
    randomwalklfo_textlabel_frequency: TKnobsTextLabel;
    randomwalklfo_textlabel_lambda: TKnobsTextLabel;
    randomwalklfo_textlabel_x: TKnobsTextLabel;
    randomwalklfo_textlabel_y: TKnobsTextLabel;
    randomwalklfo_textlabel_z: TKnobsTextLabel;
    randsig: TKnobsModule;
    randsig_display_frequency: TKnobsDisplay;
    randsig_dist: TKnobsSmallKnob;
    randsig_distmod: TKnobsInput;
    randsig_distmodamt: TKnobsSmallKnob;
    randsig_editlabel: TKnobsEditLabel;
    randsig_fm: TKnobsInput;
    randsig_fmlevel: TKnobsSmallKnob;
    randsig_frequency: TKnobsSmallKnob;
    randsig_indicator_active: TKnobsIndicator;
    randsig_lambda: TKnobsSmallKnob;
    randsig_mode: TKnobsSelector;
    randsig_mute: TKnobsSelector;
    randsig_out: TKnobsOutput;
    randsig_outputtype: TKnobsSelector;
    randsig_range: TKnobsSelector;
    randsig_textlabel_distribution: TKnobsTextLabel;
    randsig_textlabel_fm: TKnobsTextLabel;
    randsig_textlabel_lambda: TKnobsTextLabel;
    randsig_textlabel_out: TKnobsTextLabel;
    rangeconverter: TKnobsModule;
    rangeconverter_display_highvalue: TKnobsDisplay;
    rangeconverter_display_lowvalue: TKnobsDisplay;
    rangeconverter_editlabel: TKnobsEditLabel;
    rangeconverter_highvalue: TKnobsSmallKnob;
    rangeconverter_in1: TKnobsInput;
    rangeconverter_in2: TKnobsInput;
    rangeconverter_in3: TKnobsInput;
    rangeconverter_in4: TKnobsInput;
    rangeconverter_lowvalue: TKnobsSmallKnob;
    rangeconverter_mode: TKnobsSelector;
    rangeconverter_out1: TKnobsOutput;
    rangeconverter_out2: TKnobsOutput;
    rangeconverter_out3: TKnobsOutput;
    rangeconverter_out4: TKnobsOutput;
    rangeconverter_textlabel_highvalue: TKnobsTextLabel;
    rangeconverter_textlabel_lowvalue: TKnobsTextLabel;
    rangeconverter_textlabel_sigtype: TKnobsTextLabel;
    ratio: TKnobsModule;
    ratio_display_divider: TKnobsDisplay;
    ratio_display_multiplier: TKnobsDisplay;
    ratio_divider: TKnobsSmallKnob;
    ratio_editlabel: TKnobsEditLabel;
    ratio_in1: TKnobsInput;
    ratio_in2: TKnobsInput;
    ratio_in3: TKnobsInput;
    ratio_in4: TKnobsInput;
    ratio_multiplier: TKnobsSmallKnob;
    ratio_mute: TKnobsSelector;
    ratio_out1: TKnobsOutput;
    ratio_out2: TKnobsOutput;
    ratio_out3: TKnobsOutput;
    ratio_out4: TKnobsOutput;
    ratio_textlabel_divider: TKnobsTextLabel;
    ratio_textlabel_multiplier: TKnobsTextLabel;
    rectifier: TKnobsModule;
    rectifier_editlabel: TKnobsEditLabel;
    rectifier_in: TKnobsInput;
    rectifier_mode: TKnobsSelector;
    rectifier_out: TKnobsOutput;
    rectifier_outinv: TKnobsOutput;
    rectifier_textlabel_inv: TKnobsTextLabel;
    resonator: TKnobsModule;
    resonator_cents: TKnobsSmallKnob;
    resonator_click: TKnobsSmallKnob;
    resonator_decay: TKnobsSmallKnob;
    resonator_display_cents: TKnobsDisplay;
    resonator_display_damp: TKnobsDisplay;
    resonator_display_frequency: TKnobsDisplay;
    resonator_display_inlevel: TKnobsDisplay;
    resonator_dm: TKnobsInput;
    resonator_dmlevel: TKnobsSmallKnob;
    resonator_editlabel: TKnobsEditLabel;
    resonator_fm: TKnobsInput;
    resonator_fmlevel: TKnobsSmallKnob;
    resonator_freq: TKnobsInput;
    resonator_frequency: TKnobsSmallKnob;
    resonator_in: TKnobsInput;
    resonator_inlevel: TKnobsNoKnob;
    resonator_out: TKnobsOutput;
    resonator_pm: TKnobsInput;
    resonator_pmlevel: TKnobsSmallKnob;
    resonator_textlabel_click: TKnobsTextLabel;
    resonator_textlabel_decay: TKnobsTextLabel;
    resonator_textlabel_dm: TKnobsTextLabel;
    resonator_textlabel_fm: TKnobsTextLabel;
    resonator_textlabel_freq: TKnobsTextLabel;
    resonator_textlabel_in: TKnobsTextLabel;
    resonator_textlabel_out: TKnobsTextLabel;
    resonator_textlabel_pm: TKnobsTextLabel;
    reverb: TKnobsModule;
    reverb_damp: TKnobsSmallKnob;
    reverb_dry: TKnobsSmallKnob;
    reverb_editlabel: TKnobsEditLabel;
    reverb_freezein: TKnobsInput;
    reverb_inl: TKnobsInput;
    reverb_inr: TKnobsInput;
    reverb_mode: TKnobsSelector;
    reverb_mute: TKnobsSelector;
    reverb_outl: TKnobsOutput;
    reverb_outr: TKnobsOutput;
    reverb_roomsize: TKnobsSmallKnob;
    reverb_textlabel_damp: TKnobsTextLabel;
    reverb_textlabel_dry: TKnobsTextLabel;
    reverb_textlabel_l: TKnobsTextLabel;
    reverb_textlabel_r: TKnobsTextLabel;
    reverb_textlabel_size: TKnobsTextLabel;
    reverb_textlabel_wet: TKnobsTextLabel;
    reverb_textlabel_width: TKnobsTextLabel;
    reverb_wet: TKnobsSmallKnob;
    reverb_width: TKnobsSmallKnob;
    rndgranulator: TKnobsModule;
    rndgranulator_delay: TKnobsInput;
    rndgranulator_delaytime: TKnobsSmallKnob;
    rndgranulator_display_delaytime: TKnobsDisplay;
    rndgranulator_display_duration: TKnobsDisplay;
    rndgranulator_display_grains: TKnobsDisplay;
    rndgranulator_display_interonset: TKnobsDisplay;
    rndgranulator_editlabel: TKnobsEditLabel;
    rndgranulator_envtype: TKnobsSelector;
    rndgranulator_graincount: TKnobsSmallKnob;
    rndgranulator_grainduration: TKnobsSmallKnob;
    rndgranulator_graindurationmod: TKnobsInput;
    rndgranulator_graindurationmodamt: TKnobsSmallKnob;
    rndgranulator_grainoffset: TKnobsInput;
    rndgranulator_in: TKnobsInput;
    rndgranulator_interonset: TKnobsSmallKnob;
    rndgranulator_interonsetmod: TKnobsInput;
    rndgranulator_interonsetmodamt: TKnobsSmallKnob;
    rndgranulator_mute: TKnobsSelector;
    rndgranulator_outl: TKnobsOutput;
    rndgranulator_outr: TKnobsOutput;
    rndgranulator_pan: TKnobsSmallKnob;
    rndgranulator_panmod: TKnobsInput;
    rndgranulator_panmodamt: TKnobsSmallKnob;
    rndgranulator_range: TKnobsSelector;
    rndgranulator_rec: TKnobsInput;
    rndgranulator_record: TKnobsSelector;
    rndgranulator_textlabel_dlymod: TKnobsTextLabel;
    rndgranulator_textlabel_duration: TKnobsTextLabel;
    rndgranulator_textlabel_envtype: TKnobsTextLabel;
    rndgranulator_textlabel_grainoffset: TKnobsTextLabel;
    rndgranulator_textlabel_grains: TKnobsTextLabel;
    rndgranulator_textlabel_in: TKnobsTextLabel;
    rndgranulator_textlabel_interonset: TKnobsTextLabel;
    rndgranulator_textlabel_maxdelay: TKnobsTextLabel;
    rndgranulator_textlabel_out: TKnobsTextLabel;
    rndgranulator_textlabel_vol: TKnobsTextLabel;
    rndgranulator_texxtlabel_pan: TKnobsTextLabel;
    rndgranulator_volume: TKnobsSmallKnob;
    rndgranulator_volumemod: TKnobsInput;
    rndgranulator_volumemodamt: TKnobsSmallKnob;
    rotator: TKnobsModule;
    rotator_angle: TKnobsInput;
    rotator_editlabel: TKnobsEditLabel;
    rotator_in1: TKnobsInput;
    rotator_in2: TKnobsInput;
    rotator_out1: TKnobsOutput;
    rotator_out2: TKnobsOutput;
    rotator_textlabel_angle: TKnobsTextLabel;
    rotator_textlabel_ins: TKnobsTextLabel;
    rotator_textlabel_outs: TKnobsTextLabel;
    rsflipflop: TKnobsModule;
    rsflipflop_editlabel: TKnobsEditLabel;
    rsflipflop_image: TImage;
    rsflipflop_indicator_notq: TKnobsIndicator;
    rsflipflop_indicator_q: TKnobsIndicator;
    rsflipflop_notq: TKnobsOutput;
    rsflipflop_q: TKnobsOutput;
    rsflipflop_r: TKnobsInput;
    rsflipflop_s: TKnobsInput;
    rsflipflop_textlabel_trigmode: TKnobsTextLabel;
    rsflipflop_trigmode: TKnobsSelector;
    sampleandhold: TKnobsModule;
    sampleandhold_editlabel: TKnobsEditLabel;
    sampleandhold_in: TKnobsInput;
    sampleandhold_indicator_trig: TKnobsIndicator;
    sampleandhold_label_in: TKnobsTextLabel;
    sampleandhold_label_trig: TKnobsTextLabel;
    sampleandhold_out: TKnobsOutput;
    sampleandhold_symbol_trig: TImage;
    sampleandhold_trig: TKnobsInput;
    savedstuff_pagecontrol: TPageControl;
    scala: TKnobsModule;
    scala_editlabel: TKnobsEditLabel;
    scala_fileselector_mapping: TKnobsFileSelector;
    scala_fileselector_scale: TKnobsFileSelector;
    scala_in: TKnobsInput;
    scala_out: TKnobsOutput;
    scala_textlabel_in: TKnobsTextLabel;
    scaler: TKnobsModule;
    scaler_display_gain: TKnobsDisplay;
    scaler_display_offset: TKnobsDisplay;
    scaler_editlabel: TKnobsEditLabel;
    scaler_gain: TKnobsSmallKnob;
    scaler_in1: TKnobsInput;
    scaler_in2: TKnobsInput;
    scaler_in3: TKnobsInput;
    scaler_in4: TKnobsInput;
    scaler_mode: TKnobsSelector;
    scaler_mute: TKnobsSelector;
    scaler_offset: TKnobsSmallKnob;
    scaler_out1: TKnobsOutput;
    scaler_out2: TKnobsOutput;
    scaler_out3: TKnobsOutput;
    scaler_out4: TKnobsOutput;
    scaler_sum: TKnobsOutput;
    scaler_textlabel_gain: TKnobsTextLabel;
    scaler_textlabel_lock: TKnobsTextLabel;
    scaler_textlabel_offset: TKnobsTextLabel;
    scaler_textlabel_sum: TKnobsTextLabel;
    separator_filter1: TKnobsModule;
    separator_io1: TKnobsModule;
    separator_io3: TKnobsModule;
    separator_lfo1: TKnobsModule;
    separator_osc1: TKnobsModule;
    separator_osc2: TKnobsModule;
    seq16: TKnobsModule;
    seq16_active: TKnobsInput;
    seq16_chain: TKnobsInput;
    seq16_curvedown: TKnobsSelector;
    seq16_curveup: TKnobsSelector;
    seq16_dir: TKnobsInput;
    seq16_display_steps: TKnobsDisplay;
    seq16_editlabel: TKnobsEditLabel;
    seq16_indicator_active: TKnobsIndicator;
    seq16_indicator_dir: TKnobsIndicator;
    seq16_indicator_reset: TKnobsIndicator;
    seq16_indicator_step10: TKnobsIndicator;
    seq16_indicator_step11: TKnobsIndicator;
    seq16_indicator_step12: TKnobsIndicator;
    seq16_indicator_step13: TKnobsIndicator;
    seq16_indicator_step14: TKnobsIndicator;
    seq16_indicator_step15: TKnobsIndicator;
    seq16_indicator_step16: TKnobsIndicator;
    seq16_indicator_step1: TKnobsIndicator;
    seq16_indicator_step2: TKnobsIndicator;
    seq16_indicator_step3: TKnobsIndicator;
    seq16_indicator_step4: TKnobsIndicator;
    seq16_indicator_step5: TKnobsIndicator;
    seq16_indicator_step6: TKnobsIndicator;
    seq16_indicator_step7: TKnobsIndicator;
    seq16_indicator_step8: TKnobsIndicator;
    seq16_indicator_step9: TKnobsIndicator;
    seq16_indicator_trig: TKnobsIndicator;
    seq16_mode: TKnobsSelector;
    seq16_out: TKnobsOutput;
    seq16_outdir: TKnobsOutput;
    seq16_outres: TKnobsOutput;
    seq16_outtrig: TKnobsOutput;
    seq16_res: TKnobsInput;
    seq16_step10: TKnobsSlider;
    seq16_step11: TKnobsSlider;
    seq16_step12: TKnobsSlider;
    seq16_step13: TKnobsSlider;
    seq16_step14: TKnobsSlider;
    seq16_step15: TKnobsSlider;
    seq16_step16: TKnobsSlider;
    seq16_step1: TKnobsSlider;
    seq16_step2: TKnobsSlider;
    seq16_step3: TKnobsSlider;
    seq16_step4: TKnobsSlider;
    seq16_step5: TKnobsSlider;
    seq16_step6: TKnobsSlider;
    seq16_step7: TKnobsSlider;
    seq16_step8: TKnobsSlider;
    seq16_step9: TKnobsSlider;
    seq16_steps: TKnobsNoKnob;
    seq16_symbol_reset: TImage;
    seq16_symbol_trig: TImage;
    seq16_textlabel_active: TKnobsTextLabel;
    seq16_textlabel_chain: TKnobsTextLabel;
    seq16_textlabel_dir: TKnobsTextLabel;
    seq16_textlabel_out: TKnobsTextLabel;
    seq16_textlabel_reset: TKnobsTextLabel;
    seq16_textlabel_steps: TKnobsTextLabel;
    seq16_textlabel_trig: TKnobsTextLabel;
    seq16_textlabel_xfade: TKnobsTextLabel;
    seq16_trig: TKnobsInput;
    seq16_xfade: TKnobsSmallKnob;
    seqclockstep: TKnobsModule;
    seqclockstep_chain: TKnobsInput;
    seqclockstep_clock: TKnobsInput;
    seqclockstep_counts: TKnobsSmallKnob;
    seqclockstep_dir: TKnobsInput;
    seqclockstep_display_counts: TKnobsDisplay;
    seqclockstep_display_note: TKnobsDisplay;
    seqclockstep_editlabel: TKnobsEditLabel;
    seqclockstep_indicator_active: TKnobsIndicator;
    seqclockstep_indicator_clock: TKnobsIndicator;
    seqclockstep_indicator_count: TKnobsIndicatorText;
    seqclockstep_indicator_dir: TKnobsIndicator;
    seqclockstep_indicator_reset: TKnobsIndicator;
    seqclockstep_indicator_trigbwd: TKnobsIndicator;
    seqclockstep_indicator_trigfwd: TKnobsIndicator;
    seqclockstep_note: TKnobsSmallKnob;
    seqclockstep_out: TKnobsOutput;
    seqclockstep_reset: TKnobsInput;
    seqclockstep_symbol_clockedge: TImage;
    seqclockstep_symbol_sigflow: TImage;
    seqclockstep_symbol_trigbwd: TImage;
    seqclockstep_symbol_trigfwd: TImage;
    seqclockstep_textlabel_clock: TKnobsTextLabel;
    seqclockstep_textlabel_count: TKnobsTextLabel;
    seqclockstep_textlabel_dir: TKnobsTextLabel;
    seqclockstep_textlabel_note: TKnobsTextLabel;
    seqclockstep_textlabel_reset: TKnobsTextLabel;
    seqclockstep_textlabel_trig: TKnobsTextLabel;
    seqclockstep_triginbwd: TKnobsInput;
    seqclockstep_triginfwd: TKnobsInput;
    seqclockstep_trigoutbwd: TKnobsOutput;
    seqclockstep_trigoutfwd: TKnobsOutput;
    seqrandom: TKnobsModule;
    seqrandom_basenote: TKnobsSmallKnob;
    seqrandom_chain: TKnobsInput;
    seqrandom_changeone: TKnobsInput;
    seqrandom_count: TKnobsSmallKnob;
    seqrandom_display_basenote: TKnobsDisplay;
    seqrandom_display_count: TKnobsDisplay;
    seqrandom_display_highnote: TKnobsDisplay;
    seqrandom_display_lownote: TKnobsDisplay;
    seqrandom_dist: TKnobsSmallKnob;
    seqrandom_distmod: TKnobsInput;
    seqrandom_distmodamt: TKnobsSmallKnob;
    seqrandom_editlabel: TKnobsEditLabel;
    seqrandom_highnote: TKnobsSmallKnob;
    seqrandom_indicator_changeone: TKnobsIndicator;
    seqrandom_indicator_trig: TKnobsIndicator;
    seqrandom_lownote: TKnobsSmallKnob;
    seqrandom_out: TKnobsOutput;
    seqrandom_scale: TKnobsSelector;
    seqrandom_symbol_changeone: TImage;
    seqrandom_symbol_trig: TImage;
    seqrandom_textlabel_basenote: TKnobsTextLabel;
    seqrandom_textlabel_chain: TKnobsTextLabel;
    seqrandom_textlabel_change: TKnobsTextLabel;
    seqrandom_textlabel_count: TKnobsTextLabel;
    seqrandom_textlabel_highnote: TKnobsTextLabel;
    seqrandom_textlabel_lownote: TKnobsTextLabel;
    seqrandom_textlabel_out: TKnobsTextLabel;
    seqrandom_textlabel_rnddistribution: TKnobsTextLabel;
    seqrandom_textlabel_scale: TKnobsTextLabel;
    seqrandom_textlabel_step: TKnobsTextLabel;
    seqrandom_trig: TKnobsInput;
    seqseq: TKnobsModule;
    seqseq_dir: TKnobsInput;
    seqseq_display_steps: TKnobsDisplay;
    seqseq_editlabel: TKnobsEditLabel;
    seqseq_indicator_dir: TKnobsIndicator;
    seqseq_indicator_res: TKnobsIndicator;
    seqseq_indicator_step10: TKnobsIndicator;
    seqseq_indicator_step11: TKnobsIndicator;
    seqseq_indicator_step12: TKnobsIndicator;
    seqseq_indicator_step13: TKnobsIndicator;
    seqseq_indicator_step14: TKnobsIndicator;
    seqseq_indicator_step15: TKnobsIndicator;
    seqseq_indicator_step16: TKnobsIndicator;
    seqseq_indicator_step1: TKnobsIndicator;
    seqseq_indicator_step2: TKnobsIndicator;
    seqseq_indicator_step3: TKnobsIndicator;
    seqseq_indicator_step4: TKnobsIndicator;
    seqseq_indicator_step5: TKnobsIndicator;
    seqseq_indicator_step6: TKnobsIndicator;
    seqseq_indicator_step7: TKnobsIndicator;
    seqseq_indicator_step8: TKnobsIndicator;
    seqseq_indicator_step9: TKnobsIndicator;
    seqseq_indicator_trig: TKnobsIndicator;
    seqseq_out10: TKnobsOutput;
    seqseq_out11: TKnobsOutput;
    seqseq_out12: TKnobsOutput;
    seqseq_out13: TKnobsOutput;
    seqseq_out14: TKnobsOutput;
    seqseq_out15: TKnobsOutput;
    seqseq_out16: TKnobsOutput;
    seqseq_out1: TKnobsOutput;
    seqseq_out2: TKnobsOutput;
    seqseq_out3: TKnobsOutput;
    seqseq_out4: TKnobsOutput;
    seqseq_out5: TKnobsOutput;
    seqseq_out6: TKnobsOutput;
    seqseq_out7: TKnobsOutput;
    seqseq_out8: TKnobsOutput;
    seqseq_out9: TKnobsOutput;
    seqseq_outdir: TKnobsOutput;
    seqseq_outres: TKnobsOutput;
    seqseq_outtrig: TKnobsOutput;
    seqseq_res: TKnobsInput;
    seqseq_resmod: TKnobsSelector;
    seqseq_steps: TKnobsNoKnob;
    seqseq_symbol_res: TImage;
    seqseq_symbol_trig: TImage;
    seqseq_textlabel_dir: TKnobsTextLabel;
    seqseq_textlabel_res: TKnobsTextLabel;
    seqseq_textlabel_steps: TKnobsTextLabel;
    seqseq_textlabel_trig: TKnobsTextLabel;
    seqseq_trig: TKnobsInput;
    seqstep: TKnobsModule;
    seqstep_chain: TKnobsInput;
    seqstep_dir: TKnobsInput;
    seqstep_display_note: TKnobsDisplay;
    seqstep_display_time: TKnobsDisplay;
    seqstep_editlabel: TKnobsEditLabel;
    seqstep_indicator_active: TKnobsIndicator;
    seqstep_indicator_dir: TKnobsIndicator;
    seqstep_indicator_reset: TKnobsIndicator;
    seqstep_indicator_trigbwd: TKnobsIndicator;
    seqstep_indicator_trigfwd: TKnobsIndicator;
    seqstep_note: TKnobsSmallKnob;
    seqstep_out: TKnobsOutput;
    seqstep_reset: TKnobsInput;
    seqstep_symbol_sigflow: TImage;
    seqstep_symbol_trigbwd: TImage;
    seqstep_symbol_trigfwd: TImage;
    seqstep_textlabel_dir: TKnobsTextLabel;
    seqstep_textlabel_duration: TKnobsTextLabel;
    seqstep_textlabel_note: TKnobsTextLabel;
    seqstep_textlabel_res: TKnobsTextLabel;
    seqstep_textlabel_trig: TKnobsTextLabel;
    seqstep_time: TKnobsSmallKnob;
    seqstep_triginbwd: TKnobsInput;
    seqstep_triginfwd: TKnobsInput;
    seqstep_trigoutbwd: TKnobsOutput;
    seqstep_trigoutfwd: TKnobsOutput;
    sequencer: TKnobsModule;
    sequencer_active: TKnobsInput;
    sequencer_chain: TKnobsInput;
    sequencer_dir: TKnobsInput;
    sequencer_display_step10: TKnobsDisplay;
    sequencer_display_step11: TKnobsDisplay;
    sequencer_display_step1: TKnobsDisplay;
    sequencer_display_step2: TKnobsDisplay;
    sequencer_display_step3: TKnobsDisplay;
    sequencer_display_step4: TKnobsDisplay;
    sequencer_display_step5: TKnobsDisplay;
    sequencer_display_step6: TKnobsDisplay;
    sequencer_display_step7: TKnobsDisplay;
    sequencer_display_step8: TKnobsDisplay;
    sequencer_display_step9: TKnobsDisplay;
    sequencer_display_steps: TKnobsDisplay;
    sequencer_editlabel: TKnobsEditLabel;
    sequencer_indicator_active: TKnobsIndicator;
    sequencer_indicator_dir: TKnobsIndicator;
    sequencer_indicator_reset: TKnobsIndicator;
    sequencer_indicator_step10: TKnobsIndicator;
    sequencer_indicator_step11: TKnobsIndicator;
    sequencer_indicator_step1: TKnobsIndicator;
    sequencer_indicator_step2: TKnobsIndicator;
    sequencer_indicator_step3: TKnobsIndicator;
    sequencer_indicator_step4: TKnobsIndicator;
    sequencer_indicator_step5: TKnobsIndicator;
    sequencer_indicator_step6: TKnobsIndicator;
    sequencer_indicator_step7: TKnobsIndicator;
    sequencer_indicator_step8: TKnobsIndicator;
    sequencer_indicator_step9: TKnobsIndicator;
    sequencer_indicator_trig: TKnobsIndicator;
    sequencer_out: TKnobsOutput;
    sequencer_reset: TKnobsInput;
    sequencer_step10: TKnobsNoKnob;
    sequencer_step11: TKnobsNoKnob;
    sequencer_step1: TKnobsNoKnob;
    sequencer_step2: TKnobsNoKnob;
    sequencer_step3: TKnobsNoKnob;
    sequencer_step4: TKnobsNoKnob;
    sequencer_step5: TKnobsNoKnob;
    sequencer_step6: TKnobsNoKnob;
    sequencer_step7: TKnobsNoKnob;
    sequencer_step8: TKnobsNoKnob;
    sequencer_step9: TKnobsNoKnob;
    sequencer_steps: TKnobsNoKnob;
    sequencer_symbol_reset: TImage;
    sequencer_symbol_trig: TImage;
    sequencer_tabsheet: TTabSheet;
    sequencer_textlabel_chain: TKnobsTextLabel;
    sequencer_textlabel_dir: TKnobsTextLabel;
    sequencer_textlabel_out: TKnobsTextLabel;
    sequencer_textlabel_reset: TKnobsTextLabel;
    sequencer_textlabel_reset_active: TKnobsTextLabel;
    sequencer_textlabel_step10: TKnobsTextLabel;
    sequencer_textlabel_step11: TKnobsTextLabel;
    sequencer_textlabel_step1: TKnobsTextLabel;
    sequencer_textlabel_step2: TKnobsTextLabel;
    sequencer_textlabel_step3: TKnobsTextLabel;
    sequencer_textlabel_step4: TKnobsTextLabel;
    sequencer_textlabel_step5: TKnobsTextLabel;
    sequencer_textlabel_step6: TKnobsTextLabel;
    sequencer_textlabel_step7: TKnobsTextLabel;
    sequencer_textlabel_step8: TKnobsTextLabel;
    sequencer_textlabel_step9: TKnobsTextLabel;
    sequencer_textlabel_steps: TKnobsTextLabel;
    sequencer_textlabel_trig: TKnobsTextLabel;
    sequencer_trig10: TKnobsOutput;
    sequencer_trig11: TKnobsOutput;
    sequencer_trig1: TKnobsOutput;
    sequencer_trig2: TKnobsOutput;
    sequencer_trig3: TKnobsOutput;
    sequencer_trig4: TKnobsOutput;
    sequencer_trig5: TKnobsOutput;
    sequencer_trig6: TKnobsOutput;
    sequencer_trig7: TKnobsOutput;
    sequencer_trig8: TKnobsOutput;
    sequencer_trig9: TKnobsOutput;
    sequencer_trig: TKnobsInput;
    simplegranulator: TKnobsModule;
    simplegranulator_delay: TKnobsInput;
    simplegranulator_delaytime: TKnobsSmallKnob;
    simplegranulator_display_delaytime: TKnobsDisplay;
    simplegranulator_display_grainduration: TKnobsDisplay;
    simplegranulator_display_grains: TKnobsDisplay;
    simplegranulator_editlabel: TKnobsEditLabel;
    simplegranulator_envtype: TKnobsSelector;
    simplegranulator_graincount: TKnobsSmallKnob;
    simplegranulator_grainduration: TKnobsSmallKnob;
    simplegranulator_graindurationmod: TKnobsInput;
    simplegranulator_graindurationmodamt: TKnobsSmallKnob;
    simplegranulator_grainoffset: TKnobsInput;
    simplegranulator_in: TKnobsInput;
    simplegranulator_mute: TKnobsSelector;
    simplegranulator_out: TKnobsOutput;
    simplegranulator_range: TKnobsSelector;
    simplegranulator_rec: TKnobsInput;
    simplegranulator_record: TKnobsSelector;
    simplegranulator_symbol_trig: TImage;
    simplegranulator_textlabel_duration: TKnobsTextLabel;
    simplegranulator_textlabel_envtype: TKnobsTextLabel;
    simplegranulator_textlabel_grainoffset: TKnobsTextLabel;
    simplegranulator_textlabel_grains: TKnobsTextLabel;
    simplegranulator_textlabel_grainspeed: TKnobsTextLabel;
    simplegranulator_textlabel_in: TKnobsTextLabel;
    simplegranulator_textlabel_maxdelay: TKnobsTextLabel;
    simplegranulator_textlabel_out: TKnobsTextLabel;
    simplegranulator_textlabel_trig: TKnobsTextLabel;
    simplegranulator_trig: TKnobsInput;
    square: TKnobsModule;
    square_bandlimit: TKnobsSmallKnob;
    square_cents: TKnobsSmallKnob;
    square_display_cents: TKnobsDisplay;
    square_display_frequency: TKnobsDisplay;
    square_editlabel: TKnobsEditLabel;
    square_fm: TKnobsInput;
    square_fmlevel: TKnobsSmallKnob;
    square_freq: TKnobsInput;
    square_frequency: TKnobsSmallKnob;
    square_mute: TKnobsSelector;
    square_out: TKnobsOutput;
    square_phase: TKnobsInput;
    square_pmlevel: TKnobsSmallKnob;
    square_pwm: TKnobsInput;
    square_pwmlevel: TKnobsSmallKnob;
    square_symbol_sync: TImage;
    square_sync: TKnobsInput;
    square_textlabel_blimit: TKnobsTextLabel;
    square_textlabel_fm: TKnobsTextLabel;
    square_textlabel_freq: TKnobsTextLabel;
    square_textlabel_phase: TKnobsTextLabel;
    square_textlabel_pwm: TKnobsTextLabel;
    square_textlabel_sync: TKnobsTextLabel;
    squarelfo: TKnobsModule;
    squarelfo_display_frequency: TKnobsDisplay;
    squarelfo_editlabel: TKnobsEditLabel;
    squarelfo_fm: TKnobsInput;
    squarelfo_fmlevel: TKnobsSmallKnob;
    squarelfo_frequency: TKnobsSmallKnob;
    squarelfo_indicator_out: TKnobsIndicator;
    squarelfo_indicator_res: TKnobsIndicator;
    squarelfo_mute: TKnobsSelector;
    squarelfo_out: TKnobsOutput;
    squarelfo_outputtype: TKnobsSelector;
    squarelfo_phase: TKnobsInput;
    squarelfo_pmlevel: TKnobsSmallKnob;
    squarelfo_pwm: TKnobsInput;
    squarelfo_pwmlevel: TKnobsSmallKnob;
    squarelfo_range: TKnobsSelector;
    squarelfo_res: TKnobsInput;
    squarelfo_symbol_res: TImage;
    squarelfo_sync: TKnobsOutput;
    squarelfo_textlabel_fm: TKnobsTextLabel;
    squarelfo_textlabel_phase: TKnobsTextLabel;
    squarelfo_textlabel_pwm: TKnobsTextLabel;
    squarelfo_textlabel_res: TKnobsTextLabel;
    squarelfo_textlabel_sync: TKnobsTextLabel;
    squarelfo_textlabel_trig: TKnobsTextLabel;
    squarelfotrig: TKnobsModule;
    squarelfotrig_count: TKnobsNoKnob;
    squarelfotrig_display_count: TKnobsDisplay;
    squarelfotrig_display_frequency: TKnobsDisplay;
    squarelfotrig_editlabel: TKnobsEditLabel;
    squarelfotrig_fm: TKnobsInput;
    squarelfotrig_fmlevel: TKnobsSmallKnob;
    squarelfotrig_frequency: TKnobsSmallKnob;
    squarelfotrig_indicator_out: TKnobsIndicator;
    squarelfotrig_indicator_ready: TKnobsIndicator;
    squarelfotrig_indicator_trig: TKnobsIndicator;
    squarelfotrig_mute: TKnobsSelector;
    squarelfotrig_out: TKnobsOutput;
    squarelfotrig_outputtype: TKnobsSelector;
    squarelfotrig_pwm: TKnobsInput;
    squarelfotrig_pwmlevel: TKnobsSmallKnob;
    squarelfotrig_range: TKnobsSelector;
    squarelfotrig_ready: TKnobsOutput;
    squarelfotrig_symbol_trig: TImage;
    squarelfotrig_textlabel_count: TKnobsTextLabel;
    squarelfotrig_textlabel_fm: TKnobsTextLabel;
    squarelfotrig_textlabel_pwm: TKnobsTextLabel;
    squarelfotrig_textlabel_ready: TKnobsTextLabel;
    squarelfotrig_textlabel_trig: TKnobsTextLabel;
    squarelfotrig_trig: TKnobsInput;
    squaretrig: TKnobsModule;
    squaretrig_bandlimit: TKnobsSmallKnob;
    squaretrig_cents: TKnobsSmallKnob;
    squaretrig_count: TKnobsNoKnob;
    squaretrig_display_cents: TKnobsDisplay;
    squaretrig_display_count: TKnobsDisplay;
    squaretrig_display_frequency: TKnobsDisplay;
    squaretrig_editlabel: TKnobsEditLabel;
    squaretrig_fm: TKnobsInput;
    squaretrig_fmlevel: TKnobsSmallKnob;
    squaretrig_freq: TKnobsInput;
    squaretrig_frequency: TKnobsSmallKnob;
    squaretrig_mute: TKnobsSelector;
    squaretrig_out: TKnobsOutput;
    squaretrig_pwm: TKnobsInput;
    squaretrig_pwmlevel: TKnobsSmallKnob;
    squaretrig_symbol_trig: TImage;
    squaretrig_textlabel_blimit: TKnobsTextLabel;
    squaretrig_textlabel_count: TKnobsTextLabel;
    squaretrig_textlabel_fm: TKnobsTextLabel;
    squaretrig_textlabel_freq: TKnobsTextLabel;
    squaretrig_textlabel_pwm: TKnobsTextLabel;
    squaretrig_textlabel_trig: TKnobsTextLabel;
    squaretrig_trig: TKnobsInput;
    svf: TKnobsModule;
    svf_bp: TKnobsOutput;
    svf_br: TKnobsOutput;
    svf_display_frequency: TKnobsDisplay;
    svf_distortion: TKnobsSmallKnob;
    svf_editlabel: TKnobsEditLabel;
    svf_fm: TKnobsInput;
    svf_fmlevel: TKnobsSmallKnob;
    svf_freq: TKnobsInput;
    svf_frequency: TKnobsSmallKnob;
    svf_hp: TKnobsOutput;
    svf_in: TKnobsInput;
    svf_inlevel: TKnobsSmallKnob;
    svf_lp: TKnobsOutput;
    svf_q: TKnobsSmallKnob;
    svf_textlabel_bp: TKnobsTextLabel;
    svf_textlabel_br: TKnobsTextLabel;
    svf_textlabel_distortion: TKnobsTextLabel;
    svf_textlabel_freq: TKnobsTextLabel;
    svf_textlabel_frequency_in: TKnobsTextLabel;
    svf_textlabel_hp: TKnobsTextLabel;
    svf_textlabel_in: TKnobsTextLabel;
    svf_textlabel_lp: TKnobsTextLabel;
    svf_textlabel_q: TKnobsTextLabel;
    switch2to1: TKnobsModule;
    switch2to1_control: TKnobsInput;
    switch2to1_editlabel: TKnobsEditLabel;
    switch2to1_in1: TKnobsInput;
    switch2to1_in2: TKnobsInput;
    switch2to1_indicator_control: TKnobsIndicator;
    switch2to1_out2: TKnobsOutput;
    switch2to1_out: TKnobsOutput;
    switch2to1_textlabel_control: TKnobsTextLabel;
    switch2to1_textlabel_in1: TKnobsTextLabel;
    switch2to1_textlabel_out: TKnobsTextLabel;
    switch_tabsheet: TTabSheet;
    sync: TKnobsModule;
    sync_editlabel: TKnobsEditLabel;
    sync_indicator_syncin: TKnobsIndicator;
    sync_indicator_syncout: TKnobsIndicator;
    sync_symbol_sync: TImage;
    sync_syncin: TKnobsInput;
    sync_syncout: TKnobsOutput;
    sync_textlabel_syncin: TKnobsTextLabel;
    sync_textlabel_syncout: TKnobsTextLabel;
    talkie: TKnobsModule;
    talkie_bank: TKnobsSelector;
    talkie_banksel: TKnobsInput;
    talkie_editlabel: TKnobsEditLabel;
    talkie_fm: TKnobsInput;
    talkie_fr: TKnobsSmallKnob;
    talkie_frmod: TKnobsInput;
    talkie_frmodamt: TKnobsSmallKnob;
    talkie_indicator_rdy: TKnobsIndicator;
    talkie_indicator_runs: TKnobsIndicator;
    talkie_mute: TKnobsSelector;
    talkie_out: TKnobsOutput;
    talkie_phrase: TKnobsInput;
    talkie_rdy: TKnobsOutput;
    talkie_sr: TKnobsSmallKnob;
    talkie_srmod: TKnobsInput;
    talkie_srmodamt: TKnobsSmallKnob;
    talkie_start: TKnobsInput;
    talkie_symbol_start: TImage;
    talkie_textlabel_bank: TKnobsTextLabel;
    talkie_textlabel_banksel: TKnobsTextLabel;
    talkie_textlabel_fm: TKnobsTextLabel;
    talkie_textlabel_framerate: TKnobsTextLabel;
    talkie_textlabel_phrase: TKnobsTextLabel;
    talkie_textlabel_rdy: TKnobsTextLabel;
    talkie_textlabel_samplerate: TKnobsTextLabel;
    talkie_textlabel_speaking: TKnobsTextLabel;
    talkie_textlabel_start: TKnobsTextLabel;
    terragen: TKnobsModule;
    terragen_algo: TKnobsSelector;
    terragen_editlabel: TKnobsEditLabel;
    terragen_mute: TKnobsSelector;
    terragen_out: TKnobsOutput;
    terragen_textlabel_height: TKnobsTextLabel;
    terragen_textlabel_x: TKnobsTextLabel;
    terragen_textlabel_y: TKnobsTextLabel;
    terragen_x: TKnobsInput;
    terragen_y: TKnobsInput;
    textsequencer: TKnobsModule;
    textsequencer_chain: TKnobsInput;
    textsequencer_dir: TKnobsInput;
    textsequencer_editlabel: TKnobsEditLabel;
    textsequencer_gateout: TKnobsOutput;
    textsequencer_indicator_dir: TKnobsIndicator;
    textsequencer_indicator_gate: TKnobsIndicator;
    textsequencer_indicator_reset: TKnobsIndicator;
    textsequencer_indicator_step: TKnobsIndicatorText;
    textsequencer_indicator_steps: TKnobsIndicatorText;
    textsequencer_indicator_trig: TKnobsIndicator;
    textsequencer_label_slash: TLabel;
    textsequencer_mode: TKnobsSelector;
    textsequencer_out: TKnobsOutput;
    textsequencer_reset: TKnobsInput;
    textsequencer_symbol_back: TImage;
    textsequencer_symbol_trig: TImage;
    textsequencer_textlabel_dir: TKnobsTextLabel;
    textsequencer_textlabel_gate: TKnobsTextLabel;
    textsequencer_textlabel_reset: TKnobsTextLabel;
    textsequencer_textlabel_trig: TKnobsTextLabel;
    textsequencer_trig: TKnobsInput;
    textsequencer_values: TKnobsDisplay;
    thirdbank: TKnobsModule;
    thirdbank_display_steepness: TKnobsDisplay;
    thirdbank_editlabel: TKnobsEditLabel;
    thirdbank_fader10: TKnobsSlider;
    thirdbank_fader11: TKnobsSlider;
    thirdbank_fader12: TKnobsSlider;
    thirdbank_fader13: TKnobsSlider;
    thirdbank_fader14: TKnobsSlider;
    thirdbank_fader15: TKnobsSlider;
    thirdbank_fader16: TKnobsSlider;
    thirdbank_fader17: TKnobsSlider;
    thirdbank_fader1: TKnobsSlider;
    thirdbank_fader2: TKnobsSlider;
    thirdbank_fader3: TKnobsSlider;
    thirdbank_fader4: TKnobsSlider;
    thirdbank_fader5: TKnobsSlider;
    thirdbank_fader6: TKnobsSlider;
    thirdbank_fader7: TKnobsSlider;
    thirdbank_fader8: TKnobsSlider;
    thirdbank_fader9: TKnobsSlider;
    thirdbank_fdmod10: TKnobsInput;
    thirdbank_fdmod11: TKnobsInput;
    thirdbank_fdmod12: TKnobsInput;
    thirdbank_fdmod13: TKnobsInput;
    thirdbank_fdmod14: TKnobsInput;
    thirdbank_fdmod15: TKnobsInput;
    thirdbank_fdmod16: TKnobsInput;
    thirdbank_fdmod17: TKnobsInput;
    thirdbank_fdmod1: TKnobsInput;
    thirdbank_fdmod2: TKnobsInput;
    thirdbank_fdmod3: TKnobsInput;
    thirdbank_fdmod4: TKnobsInput;
    thirdbank_fdmod5: TKnobsInput;
    thirdbank_fdmod6: TKnobsInput;
    thirdbank_fdmod7: TKnobsInput;
    thirdbank_fdmod8: TKnobsInput;
    thirdbank_fdmod9: TKnobsInput;
    thirdbank_fm: TKnobsInput;
    thirdbank_fmamt: TKnobsSmallKnob;
    thirdbank_in: TKnobsInput;
    thirdbank_level: TKnobsSmallKnob;
    thirdbank_modehigh: TKnobsSelector;
    thirdbank_modelow: TKnobsSelector;
    thirdbank_out: TKnobsOutput;
    thirdbank_q: TKnobsSmallKnob;
    thirdbank_steepness: TKnobsNoKnob;
    thirdbank_textlabel_fm: TKnobsTextLabel;
    thirdbank_textlabel_frequencies1: TKnobsTextLabel;
    thirdbank_textlabel_frequencies2: TKnobsTextLabel;
    thirdbank_textlabel_in: TKnobsTextLabel;
    thirdbank_textlabel_lev: TKnobsTextLabel;
    thirdbank_textlabel_out: TKnobsTextLabel;
    thirdbank_textlabel_q: TKnobsTextLabel;
    thirdbank_textlabel_steepness: TKnobsTextLabel;
    thirdsplitter: TKnobsModule;
    thirdsplitter_display_steepness: TKnobsDisplay;
    thirdsplitter_editlabel: TKnobsEditLabel;
    thirdsplitter_fm: TKnobsInput;
    thirdsplitter_fmamt: TKnobsSmallKnob;
    thirdsplitter_in: TKnobsInput;
    thirdsplitter_indicator_clip10: TKnobsIndicator;
    thirdsplitter_indicator_clip11: TKnobsIndicator;
    thirdsplitter_indicator_clip12: TKnobsIndicator;
    thirdsplitter_indicator_clip13: TKnobsIndicator;
    thirdsplitter_indicator_clip14: TKnobsIndicator;
    thirdsplitter_indicator_clip15: TKnobsIndicator;
    thirdsplitter_indicator_clip16: TKnobsIndicator;
    thirdsplitter_indicator_clip17: TKnobsIndicator;
    thirdsplitter_indicator_clip1: TKnobsIndicator;
    thirdsplitter_indicator_clip2: TKnobsIndicator;
    thirdsplitter_indicator_clip3: TKnobsIndicator;
    thirdsplitter_indicator_clip4: TKnobsIndicator;
    thirdsplitter_indicator_clip5: TKnobsIndicator;
    thirdsplitter_indicator_clip6: TKnobsIndicator;
    thirdsplitter_indicator_clip7: TKnobsIndicator;
    thirdsplitter_indicator_clip8: TKnobsIndicator;
    thirdsplitter_indicator_clip9: TKnobsIndicator;
    thirdsplitter_level: TKnobsSmallKnob;
    thirdsplitter_modehigh: TKnobsSelector;
    thirdsplitter_modelow: TKnobsSelector;
    thirdsplitter_out10: TKnobsOutput;
    thirdsplitter_out11: TKnobsOutput;
    thirdsplitter_out12: TKnobsOutput;
    thirdsplitter_out13: TKnobsOutput;
    thirdsplitter_out14: TKnobsOutput;
    thirdsplitter_out15: TKnobsOutput;
    thirdsplitter_out16: TKnobsOutput;
    thirdsplitter_out17: TKnobsOutput;
    thirdsplitter_out1: TKnobsOutput;
    thirdsplitter_out2: TKnobsOutput;
    thirdsplitter_out3: TKnobsOutput;
    thirdsplitter_out4: TKnobsOutput;
    thirdsplitter_out5: TKnobsOutput;
    thirdsplitter_out6: TKnobsOutput;
    thirdsplitter_out7: TKnobsOutput;
    thirdsplitter_out8: TKnobsOutput;
    thirdsplitter_out9: TKnobsOutput;
    thirdsplitter_q: TKnobsSmallKnob;
    thirdsplitter_steepness: TKnobsNoKnob;
    thirdsplitter_textlabel_fm: TKnobsTextLabel;
    thirdsplitter_textlabel_frequencies1: TKnobsTextLabel;
    thirdsplitter_textlabel_frequencies2: TKnobsTextLabel;
    thirdsplitter_textlabel_in: TKnobsTextLabel;
    thirdsplitter_textlabel_lev: TKnobsTextLabel;
    thirdsplitter_textlabel_q: TKnobsTextLabel;
    thirdsplitter_textlabel_steepness: TKnobsTextLabel;
    trackandhold: TKnobsModule;
    trackandhold_editlabel: TKnobsEditLabel;
    trackandhold_in: TKnobsInput;
    trackandhold_indicator_trig: TKnobsIndicator;
    trackandhold_label_in: TKnobsTextLabel;
    trackandhold_label_trig: TKnobsTextLabel;
    trackandhold_out: TKnobsOutput;
    trackandhold_symbol_trig: TImage;
    trackandhold_trig: TKnobsInput;
    transinv: TKnobsModule;
    transinv_amtpivot: TKnobsSmallKnob;
    transinv_display_amtpivot: TKnobsDisplay;
    transinv_display_modulo: TKnobsDisplay;
    transinv_editlabel: TKnobsEditLabel;
    transinv_in1: TKnobsInput;
    transinv_in2: TKnobsInput;
    transinv_in3: TKnobsInput;
    transinv_in4: TKnobsInput;
    transinv_mode: TKnobsSelector;
    transinv_modulo: TKnobsSmallKnob;
    transinv_out1: TKnobsOutput;
    transinv_out2: TKnobsOutput;
    transinv_out3: TKnobsOutput;
    transinv_out4: TKnobsOutput;
    transinv_textlabel_amtpivot: TKnobsTextLabel;
    transinv_textlabel_modulo: TKnobsTextLabel;
    tritonebank: TKnobsModule;
    tritonebank_display_steepness: TKnobsDisplay;
    tritonebank_editlabel: TKnobsEditLabel;
    tritonebank_fader10: TKnobsSlider;
    tritonebank_fader11: TKnobsSlider;
    tritonebank_fader12: TKnobsSlider;
    tritonebank_fader13: TKnobsSlider;
    tritonebank_fader14: TKnobsSlider;
    tritonebank_fader15: TKnobsSlider;
    tritonebank_fader16: TKnobsSlider;
    tritonebank_fader17: TKnobsSlider;
    tritonebank_fader1: TKnobsSlider;
    tritonebank_fader2: TKnobsSlider;
    tritonebank_fader3: TKnobsSlider;
    tritonebank_fader4: TKnobsSlider;
    tritonebank_fader5: TKnobsSlider;
    tritonebank_fader6: TKnobsSlider;
    tritonebank_fader7: TKnobsSlider;
    tritonebank_fader8: TKnobsSlider;
    tritonebank_fader9: TKnobsSlider;
    tritonebank_fdmod10: TKnobsInput;
    tritonebank_fdmod11: TKnobsInput;
    tritonebank_fdmod12: TKnobsInput;
    tritonebank_fdmod13: TKnobsInput;
    tritonebank_fdmod14: TKnobsInput;
    tritonebank_fdmod15: TKnobsInput;
    tritonebank_fdmod16: TKnobsInput;
    tritonebank_fdmod17: TKnobsInput;
    tritonebank_fdmod1: TKnobsInput;
    tritonebank_fdmod2: TKnobsInput;
    tritonebank_fdmod3: TKnobsInput;
    tritonebank_fdmod4: TKnobsInput;
    tritonebank_fdmod5: TKnobsInput;
    tritonebank_fdmod6: TKnobsInput;
    tritonebank_fdmod7: TKnobsInput;
    tritonebank_fdmod8: TKnobsInput;
    tritonebank_fdmod9: TKnobsInput;
    tritonebank_fm: TKnobsInput;
    tritonebank_fmamt: TKnobsSmallKnob;
    tritonebank_in: TKnobsInput;
    tritonebank_level: TKnobsSmallKnob;
    tritonebank_modehigh: TKnobsSelector;
    tritonebank_modelow: TKnobsSelector;
    tritonebank_out: TKnobsOutput;
    tritonebank_q: TKnobsSmallKnob;
    tritonebank_steepness: TKnobsNoKnob;
    tritonebank_textlabel_fm: TKnobsTextLabel;
    tritonebank_textlabel_frequencies1: TKnobsTextLabel;
    tritonebank_textlabel_frequencies2: TKnobsTextLabel;
    tritonebank_textlabel_in: TKnobsTextLabel;
    tritonebank_textlabel_lev: TKnobsTextLabel;
    tritonebank_textlabel_out: TKnobsTextLabel;
    tritonebank_textlabel_q: TKnobsTextLabel;
    tritonebank_textlabel_steepness: TKnobsTextLabel;
    tritonesplitter: TKnobsModule;
    tritonesplitter_display_steepness: TKnobsDisplay;
    tritonesplitter_editlabel: TKnobsEditLabel;
    tritonesplitter_fm: TKnobsInput;
    tritonesplitter_fmamt: TKnobsSmallKnob;
    tritonesplitter_in: TKnobsInput;
    tritonesplitter_indicator_clip10: TKnobsIndicator;
    tritonesplitter_indicator_clip11: TKnobsIndicator;
    tritonesplitter_indicator_clip12: TKnobsIndicator;
    tritonesplitter_indicator_clip13: TKnobsIndicator;
    tritonesplitter_indicator_clip14: TKnobsIndicator;
    tritonesplitter_indicator_clip15: TKnobsIndicator;
    tritonesplitter_indicator_clip16: TKnobsIndicator;
    tritonesplitter_indicator_clip17: TKnobsIndicator;
    tritonesplitter_indicator_clip1: TKnobsIndicator;
    tritonesplitter_indicator_clip2: TKnobsIndicator;
    tritonesplitter_indicator_clip3: TKnobsIndicator;
    tritonesplitter_indicator_clip4: TKnobsIndicator;
    tritonesplitter_indicator_clip5: TKnobsIndicator;
    tritonesplitter_indicator_clip6: TKnobsIndicator;
    tritonesplitter_indicator_clip7: TKnobsIndicator;
    tritonesplitter_indicator_clip8: TKnobsIndicator;
    tritonesplitter_indicator_clip9: TKnobsIndicator;
    tritonesplitter_level: TKnobsSmallKnob;
    tritonesplitter_modehigh: TKnobsSelector;
    tritonesplitter_modelow: TKnobsSelector;
    tritonesplitter_out10: TKnobsOutput;
    tritonesplitter_out11: TKnobsOutput;
    tritonesplitter_out12: TKnobsOutput;
    tritonesplitter_out13: TKnobsOutput;
    tritonesplitter_out14: TKnobsOutput;
    tritonesplitter_out15: TKnobsOutput;
    tritonesplitter_out16: TKnobsOutput;
    tritonesplitter_out17: TKnobsOutput;
    tritonesplitter_out1: TKnobsOutput;
    tritonesplitter_out2: TKnobsOutput;
    tritonesplitter_out3: TKnobsOutput;
    tritonesplitter_out4: TKnobsOutput;
    tritonesplitter_out5: TKnobsOutput;
    tritonesplitter_out6: TKnobsOutput;
    tritonesplitter_out7: TKnobsOutput;
    tritonesplitter_out8: TKnobsOutput;
    tritonesplitter_out9: TKnobsOutput;
    tritonesplitter_q: TKnobsSmallKnob;
    tritonesplitter_steepness: TKnobsNoKnob;
    tritonesplitter_textlabel_fm: TKnobsTextLabel;
    tritonesplitter_textlabel_frequencies1: TKnobsTextLabel;
    tritonesplitter_textlabel_frequencies2: TKnobsTextLabel;
    tritonesplitter_textlabel_in: TKnobsTextLabel;
    tritonesplitter_textlabel_lev: TKnobsTextLabel;
    tritonesplitter_textlabel_q: TKnobsTextLabel;
    tritonesplitter_textlabel_steepness: TKnobsTextLabel;
    util_tabsheet: TTabSheet;
    v0coder_carrier: TKnobsInput;
    vocoder: TKnobsModule;
    vocoder_editlabel: TKnobsEditLabel;
    vocoder_modulator: TKnobsInput;
    vocoder_mute: TKnobsSelector;
    vocoder_out: TKnobsOutput;
    vocoder_textlabel_carrier: TKnobsTextLabel;
    vocoder_textlabel_modulator: TKnobsTextLabel;
    waveplayer: TKnobsModule;
    waveplayer_display_duration: TKnobsDisplay;
    waveplayer_display_mono: TKnobsDisplay;
    waveplayer_editlabel: TKnobsEditLabel;
    waveplayer_fileselector_filename: TKnobsFileSelector;
    waveplayer_fm: TKnobsInput;
    waveplayer_indicator_res: TKnobsIndicator;
    waveplayer_mode: TKnobsSelector;
    waveplayer_out: TKnobsOutput;
    waveplayer_outr: TKnobsOutput;
    waveplayer_position: TKnobsInput;
    waveplayer_res: TKnobsInput;
    waveplayer_speed: TKnobsInput;
    waveplayer_symbol_res: TImage;
    waveplayer_textlabel_duration: TKnobsTextLabel;
    waveplayer_textlabel_fm: TKnobsTextLabel;
    waveplayer_textlabel_l: TKnobsTextLabel;
    waveplayer_textlabel_position: TKnobsTextLabel;
    waveplayer_textlabel_r: TKnobsTextLabel;
    waveplayer_textlabel_res: TKnobsTextLabel;
    waveplayer_textlabel_speed: TKnobsTextLabel;
    wavewiper: TKnobsModule;
    wavewiper_break: TKnobsInput;
    wavewiper_editlabel: TKnobsEditLabel;
    wavewiper_in1: TKnobsInput;
    wavewiper_in2: TKnobsInput;
    wavewiper_mute: TKnobsSelector;
    wavewiper_out1: TKnobsOutput;
    wavewiper_out2: TKnobsOutput;
    wavewiper_textlabel_break: TKnobsTextLabel;
    wavewiper_textlabel_ins: TKnobsTextLabel;
    wavewiper_textlabel_out: TKnobsTextLabel;
    wavewrapper: TKnobsModule;
    wavewrapper_display_high: TKnobsDisplay;
    wavewrapper_display_low: TKnobsDisplay;
    wavewrapper_editlabel: TKnobsEditLabel;
    wavewrapper_highlevel: TKnobsSmallKnob;
    wavewrapper_in: TKnobsInput;
    wavewrapper_lowlevel: TKnobsSmallKnob;
    wavewrapper_mod: TKnobsInput;
    wavewrapper_modamt: TKnobsSmallKnob;
    wavewrapper_mute: TKnobsSelector;
    wavewrapper_out: TKnobsOutput;
    wavewrapper_textlabel_high: TKnobsTextLabel;
    wavewrapper_textlabel_in: TKnobsTextLabel;
    wavewrapper_textlabel_low: TKnobsTextLabel;
    wavewrapper_textlabel_mod: TKnobsTextLabel;
    wavewrapper_type: TKnobsSelector;
    xfade: TKnobsModule;
    xfade_control: TKnobsInput;
    xfade_editlabel: TKnobsEditLabel;
    xfade_in1: TKnobsInput;
    xfade_in2: TKnobsInput;
    xfade_intype: TKnobsSelector;
    xfade_out: TKnobsOutput;
    xfade_position: TKnobsSmallKnob;
    xfade_posmod: TKnobsSmallKnob;
    xfade_textlabel_control: TKnobsTextLabel;
    xfade_textlabel_in1: TKnobsTextLabel;
    xfade_textlabel_in2: TKnobsTextLabel;
    xfade_textlabel_out: TKnobsTextLabel;
    xyscope: TKnobsModule;
    xyscope_display_history: TKnobsDisplay;
    xyscope_editlabel: TKnobsEditLabel;
    xyscope_history: TKnobsSmallKnob;
    xyscope_inx: TKnobsInput;
    xyscope_iny: TKnobsInput;
    xyscope_levx: TKnobsSmallKnob;
    xyscope_levy: TKnobsSmallKnob;
    xyscope_lockxy: TKnobsSelector;
    xyscope_textlabel_history: TKnobsTextLabel;
    xyscope_textlabel_lockxy: TKnobsTextLabel;
    xyscope_textlabel_x: TKnobsTextLabel;
    xyscope_textlabel_y: TKnobsTextLabel;
    xyscope_viewer: TKnobsDataViewer;
    zerocounter: TKnobsModule;
    zerocounter_display_threshold: TKnobsDisplay;
    zerocounter_editlabel: TKnobsEditLabel;
    zerocounter_gate: TKnobsOutput;
    zerocounter_in: TKnobsInput;
    zerocounter_indicator_gate: TKnobsIndicator;
    zerocounter_note: TKnobsOutput;
    zerocounter_period: TKnobsOutput;
    zerocounter_textlabel_gate: TKnobsTextLabel;
    zerocounter_textlabel_in: TKnobsTextLabel;
    zerocounter_textlabel_note: TKnobsTextLabel;
    zerocounter_textlabel_period: TKnobsTextLabel;
    zerocounter_textlabel_threshold: TKnobsTextLabel;
    zerocounter_threshold: TKnobsSmallKnob;
    multicompare: TKnobsModule;
    multicompare_editlabel: TKnobsEditLabel;
    multicompare_indicator_pos1: TKnobsIndicator;
    multicompare_indicator_pos2: TKnobsIndicator;
    multicompare_indicator_pos3: TKnobsIndicator;
    multicompare_indicator_pos4: TKnobsIndicator;
    multicompare_indicator_pos5: TKnobsIndicator;
    multicompare_indicator_pos6: TKnobsIndicator;
    multicompare_indicator_pos7: TKnobsIndicator;
    multicompare_indicator_pos8: TKnobsIndicator;
    multicompare_textlabel_pos1: TKnobsTextLabel;
    multicompare_textlabel_pos2: TKnobsTextLabel;
    multicompare_textlabel_pos3: TKnobsTextLabel;
    multicompare_textlabel_pos4: TKnobsTextLabel;
    multicompare_textlabel_pos5: TKnobsTextLabel;
    multicompare_textlabel_pos6: TKnobsTextLabel;
    multicompare_textlabel_pos7: TKnobsTextLabel;
    multicompare_textlabel_pos8: TKnobsTextLabel;
    multicompare_out1: TKnobsOutput;
    multicompare_out2: TKnobsOutput;
    multicompare_out3: TKnobsOutput;
    multicompare_indicator_out1: TKnobsIndicator;
    multicompare_indicator_out2: TKnobsIndicator;
    multicompare_indicator_out3: TKnobsIndicator;
    multicompare_in: TKnobsInput;
    multicompare_textlabel_inlevel: TKnobsTextLabel;
    multicompare_inamtmod: TKnobsInput;
    multicompare_textlabel_out1: TKnobsTextLabel;
    multicompare_textlabel_out2: TKnobsTextLabel;
    multicompare_textlabel_out3: TKnobsTextLabel;
    multicompare_textlabel_in: TKnobsTextLabel;
    multicompare_pos1: TKnobsOutput;
    multicompare_pos2: TKnobsOutput;
    multicompare_pos3: TKnobsOutput;
    multicompare_pos4: TKnobsOutput;
    multicompare_pos5: TKnobsOutput;
    multicompare_pos6: TKnobsOutput;
    multicompare_pos7: TKnobsOutput;
    multicompare_pos8: TKnobsOutput;
    multicompare_level1: TKnobsSmallKnob;
    multicompare_level2: TKnobsSmallKnob;
    multicompare_level3: TKnobsSmallKnob;
    multicompare_level4: TKnobsSmallKnob;
    multicompare_level5: TKnobsSmallKnob;
    multicompare_level6: TKnobsSmallKnob;
    multicompare_level7: TKnobsSmallKnob;
    multicompare_level8: TKnobsSmallKnob;
    multicompare_bussel1: TKnobsSelector;
    multicompare_bussel2: TKnobsSelector;
    multicompare_bussel3: TKnobsSelector;
    multicompare_bussel4: TKnobsSelector;
    multicompare_bussel5: TKnobsSelector;
    multicompare_bussel6: TKnobsSelector;
    multicompare_bussel7: TKnobsSelector;
    multicompare_bussel8: TKnobsSelector;
    multicompare_inamt: TKnobsSmallKnob;
    convolver: TKnobsModule;
    convolver_editlabel: TKnobsEditLabel;
    convolver_textlabel_duration: TKnobsTextLabel;
    convolver_out: TKnobsOutput;
    convolver_textlabel_out: TKnobsTextLabel;
    convolver_display_duration: TKnobsDisplay;
    convolver_fileselector_ir: TKnobsFileSelector;
    convolver_in: TKnobsInput;
    convolver_textlabel_in: TKnobsTextLabel;
    convolver_textlabel_impulseresponse: TKnobsTextLabel;
    convolver_inlevel: TKnobsSmallKnob;
    convolver_textlabel_level: TKnobsTextLabel;
    convolver_bypass: TKnobsSelector;
    modal_freq: TKnobsSmallKnob;
    modal_textlable_freq: TKnobsTextLabel;
    pad: TKnobsModule;
    pad_editlabel: TKnobsEditLabel;
    pad_x: TKnobsOutput;
    pad_textlabel_x: TKnobsTextLabel;
    pad_y: TKnobsOutput;
    pad_textlabel_y: TKnobsTextLabel;
    pad_pad: TKnobsPad;
    pad_outputtype: TKnobsSelector;
    knobs4: TKnobsModule;
    knobs4_editlabel: TKnobsEditLabel;
    knobs4_value1: TKnobsKnob;
    knobs4_value2: TKnobsKnob;
    knobs4_value3: TKnobsKnob;
    knobs4_value4: TKnobsKnob;
    knobs4_out1: TKnobsOutput;
    knobs4_out2: TKnobsOutput;
    knobs4_out3: TKnobsOutput;
    knobs4_out4: TKnobsOutput;
    knobs4_display1: TKnobsDisplay;
    knobs4_mode1: TKnobsSelector;
    knobs4_display_value1: TKnobsDisplay;
    knobs4_display2: TKnobsDisplay;
    knobs4_mode2: TKnobsSelector;
    knobs4_display_value2: TKnobsDisplay;
    knobs4_display3: TKnobsDisplay;
    knobs4_mode3: TKnobsSelector;
    knobs4_display_value3: TKnobsDisplay;
    knobs4_display4: TKnobsDisplay;
    knobs4_mode4: TKnobsSelector;
    knobs4_display_value4: TKnobsDisplay;
    switches4: TKnobsModule;
    switches4_editlabel: TKnobsEditLabel;
    switches4_out1: TKnobsOutput;
    switches4_out2: TKnobsOutput;
    switches4_out3: TKnobsOutput;
    switches4_out4: TKnobsOutput;
    switches4_display1: TKnobsDisplay;
    switches4_display2: TKnobsDisplay;
    switches4_display3: TKnobsDisplay;
    switches4_display4: TKnobsDisplay;
    switches4_sw1: TKnobsSelector;
    switches4_sw2: TKnobsSelector;
    switches4_sw3: TKnobsSelector;
    switches4_sw4: TKnobsSelector;
    buttons4: TKnobsModule;
    buttons4_editlabel: TKnobsEditLabel;
    buttons4_out1: TKnobsOutput;
    buttons4_out2: TKnobsOutput;
    buttons4_out3: TKnobsOutput;
    buttons4_out4: TKnobsOutput;
    buttons4_display1: TKnobsDisplay;
    buttons4_display2: TKnobsDisplay;
    buttons4_display3: TKnobsDisplay;
    buttons4_display4: TKnobsDisplay;
    buttons4_sw1: TKnobsSelector;
    buttons4_sw2: TKnobsSelector;
    buttons4_sw3: TKnobsSelector;
    buttons4_sw4: TKnobsSelector;
    buttons4_indicator_1: TKnobsIndicator;
    buttons4_indicator_2: TKnobsIndicator;
    buttons4_indicator_3: TKnobsIndicator;
    buttons4_indicator_4: TKnobsIndicator;
    levelconverter: TKnobsModule;
    levelconverter_out1: TKnobsOutput;
    levelconverter_out2: TKnobsOutput;
    levelconverter_out3: TKnobsOutput;
    levelconverter_out4: TKnobsOutput;
    levelconverter_in1: TKnobsInput;
    levelconverter_in2: TKnobsInput;
    levelconverter_in3: TKnobsInput;
    levelconverter_in4: TKnobsInput;
    levelconverter_editlabel: TKnobsEditLabel;
    levelconverter_textlabel_in: TKnobsTextLabel;
    levelconverter_inmode: TKnobsSelector;
    levelconverter_textlabel_out: TKnobsTextLabel;
    levelconverter_outmode: TKnobsSelector;
    math_tabsheet: TTabSheet;
    inverter: TKnobsModule;
    inverter_editlabel: TKnobsEditLabel;
    inverter_out4: TKnobsOutput;
    inverter_out3: TKnobsOutput;
    inverter_out2: TKnobsOutput;
    inverter_out1: TKnobsOutput;
    inverter_in4: TKnobsInput;
    inverter_in3: TKnobsInput;
    inverter_in2: TKnobsInput;
    inverter_in1: TKnobsInput;
    adder: TKnobsModule;
    adder_editlabel: TKnobsEditLabel;
    adder_out: TKnobsOutput;
    adder_in4: TKnobsInput;
    adder_in3: TKnobsInput;
    adder_in2: TKnobsInput;
    adder_in1: TKnobsInput;
    adder_mute: TKnobsSelector;
    multiplier: TKnobsModule;
    multiplier_editlabel: TKnobsEditLabel;
    multiplier_out: TKnobsOutput;
    multiplier_in4: TKnobsInput;
    multiplier_in3: TKnobsInput;
    multiplier_in2: TKnobsInput;
    multiplier_in1: TKnobsInput;
    multiplier_mute: TKnobsSelector;
    minmax: TKnobsModule;
    minmax_editlabel: TKnobsEditLabel;
    minmax_min: TKnobsOutput;
    minmax_max: TKnobsOutput;
    minmax_in1: TKnobsInput;
    minmax_in2: TKnobsInput;
    minmax_textlabel_1in2: TKnobsTextLabel;
    minmax_textlabel_minmax: TKnobsTextLabel;
    multimult: TKnobsModule;
    multimult_editlabel: TKnobsEditLabel;
    multimult_out1: TKnobsOutput;
    multimult_in4: TKnobsInput;
    multimult_in3: TKnobsInput;
    multimult_in2: TKnobsInput;
    multimult_in1: TKnobsInput;
    multimult_out4: TKnobsOutput;
    multimult_out3: TKnobsOutput;
    multimult_out2: TKnobsOutput;
    multimult_mult: TKnobsInput;
    multimult_textlabel_mult: TKnobsTextLabel;
    multimult_out5: TKnobsOutput;
    multimult_in8: TKnobsInput;
    multimult_in7: TKnobsInput;
    multimult_in6: TKnobsInput;
    multimult_in5: TKnobsInput;
    multimult_out8: TKnobsOutput;
    multimult_out7: TKnobsOutput;
    multimult_out6: TKnobsOutput;
    median: TKnobsModule;
    median_editlabel: TKnobsEditLabel;
    median_symbol_trig: TImage;
    median_out: TKnobsOutput;
    median_in: TKnobsInput;
    median_trig: TKnobsInput;
    median_indicator_trig: TKnobsIndicator;
    median_textlabel_in: TKnobsTextLabel;
    median_textlabel_trig: TKnobsTextLabel;
    median_textlabel_binsize: TKnobsTextLabel;
    median_high: TKnobsOutput;
    median_low: TKnobsOutput;
    median_textlabel_median: TKnobsTextLabel;
    median_textlabel_hi: TKnobsTextLabel;
    median_textlabel_lo: TKnobsTextLabel;
    median_binsize: TKnobsSmallKnob;
    median_display_binsize: TKnobsDisplay;
    reciprocal: TKnobsModule;
    reciprocal_editlabel: TKnobsEditLabel;
    reciprocal_out: TKnobsOutput;
    reciprocal_x: TKnobsInput;
    divide: TKnobsModule;
    divide_editlabel: TKnobsEditLabel;
    divide_out: TKnobsOutput;
    divide_x: TKnobsInput;
    divide_y: TKnobsInput;
    reciprocal_textlabel_x: TKnobsTextLabel;
    divide_textlabel_x: TKnobsTextLabel;
    divide_textlabel_y: TKnobsTextLabel;
    monadic: TKnobsModule;
    monadic_editlabel: TKnobsEditLabel;
    monadic_out: TKnobsOutput;
    monadic_x: TKnobsInput;
    monadic_textlabel_x: TKnobsTextLabel;
    dyadic: TKnobsModule;
    dyadic_editlabel: TKnobsEditLabel;
    dyadic_out: TKnobsOutput;
    dyadic_x: TKnobsInput;
    dyadic_y: TKnobsInput;
    dyadic_textlabel_x: TKnobsTextLabel;
    dyadic_textlabel_y: TKnobsTextLabel;
    monadic_function: TKnobsSelector;
    dyadic_function: TKnobsSelector;
    modal_rndf: TKnobsSelector;
    modal_rndq: TKnobsSelector;
    modal_rnda: TKnobsSelector;
    sequencer_rnd: TKnobsSelector;
    sequencer_clr: TKnobsSelector;
    gateseq_rnd: TKnobsSelector;
    gateseq_clr: TKnobsSelector;
    seq16_rnd: TKnobsSelector;
    seq16_clr: TKnobsSelector;
    lut_rnd: TKnobsSelector;
    lut_clr: TKnobsSelector;
    multicompare_rnd: TKnobsSelector;
    multicompare_clr: TKnobsSelector;
    reciprocal_textlabel_f: TKnobsTextLabel;
    divide_textlabel_f: TKnobsTextLabel;
    monadic_textlabel_f: TKnobsTextLabel;
    dyadic_textlabel_f: TKnobsTextLabel;
    panel1_editlabel: TKnobsEditLabel;
    display_blackground: TKnobsLed;
    display_whiteground: TKnobsLed;
    friemels_display_genesize: TKnobsDisplay;
    friemels_textlabel_genesize: TKnobsTextLabel;
    friemels_symbol_step: TImage;
    friemels_step: TKnobsInput;
    friemels_indicator_step: TKnobsIndicator;
    friemels_textlabel_step: TKnobsTextLabel;
    friemels_display_mutprob: TKnobsDisplay;
    friemels_textlabel_mutprob: TKnobsTextLabel;
    friemels_display_mutrange: TKnobsDisplay;
    friemels_textlabel_murange: TKnobsTextLabel;
    friemels_genesize: TKnobsNoKnob;
    friemels_mutprob: TKnobsNoKnob;
    friemels_mutrange: TKnobsNoKnob;
    friemels_display_crossprob: TKnobsDisplay;
    friemels_textlabel_crossprob: TKnobsTextLabel;
    friemels_crossprob: TKnobsNoKnob;
    friemels_display_morphprob: TKnobsDisplay;
    friemels_textlabel_morphprob: TKnobsTextLabel;
    friemels_morphprob: TKnobsNoKnob;
    friemels_out: TKnobsOutput;
    friemels_textlabel_out: TKnobsTextLabel;
    multiplemult: TKnobsModule;
    MultipleMult_editlabel: TKnobsEditLabel;
    MultipleMult_in31: TKnobsInput;
    MultipleMult_in32: TKnobsInput;
    MultipleMult_in41: TKnobsInput;
    MultipleMult_in42: TKnobsInput;
    MultipleMult_out4: TKnobsOutput;
    MultipleMult_in11: TKnobsInput;
    MultipleMult_in12: TKnobsInput;
    MultipleMult_in21: TKnobsInput;
    MultipleMult_in22: TKnobsInput;
    MultipleMult_out1: TKnobsOutput;
    MultipleMult_out2: TKnobsOutput;
    MultipleMult_out3: TKnobsOutput;
    mixmm16to1: TKnobsModule;
    mixmm16to1_editlabel: TKnobsEditLabel;
    mixmm16to1_out: TKnobsOutput;
    mixmm16to1_textlabel_out: TKnobsTextLabel;
    mixmm16to1_in1: TKnobsInput;
    mixmm16to1_in2: TKnobsInput;
    mixmm16to1_in3: TKnobsInput;
    mixmm16to1_in4: TKnobsInput;
    mixmm16to1_in5: TKnobsInput;
    mixmm16to1_in6: TKnobsInput;
    mixmm16to1_in7: TKnobsInput;
    mixmm16to1_in8: TKnobsInput;
    mixmm16to1_in9: TKnobsInput;
    mixmm16to1_in10: TKnobsInput;
    mixmm16to1_in11: TKnobsInput;
    mixmm16to1_in12: TKnobsInput;
    mixmm16to1_in13: TKnobsInput;
    mixmm16to1_in14: TKnobsInput;
    mixmm16to1_in15: TKnobsInput;
    mixmm16to1_in16: TKnobsInput;
    mixmm16to1_in: TKnobsInput;
    mixmm16to1_lev1: TKnobsSlider;
    mixmm16to1_lev2: TKnobsSlider;
    mixmm16to1_lev3: TKnobsSlider;
    mixmm16to1_lev4: TKnobsSlider;
    mixmm16to1_lev5: TKnobsSlider;
    mixmm16to1_lev6: TKnobsSlider;
    mixmm16to1_lev7: TKnobsSlider;
    mixmm16to1_lev8: TKnobsSlider;
    mixmm16to1_lev9: TKnobsSlider;
    mixmm16to1_lev10: TKnobsSlider;
    mixmm16to1_lev11: TKnobsSlider;
    mixmm16to1_lev12: TKnobsSlider;
    mixmm16to1_lev13: TKnobsSlider;
    mixmm16to1_lev14: TKnobsSlider;
    mixmm16to1_lev15: TKnobsSlider;
    mixmm16to1_lev16: TKnobsSlider;
    mixmm16to1_mute: TKnobsSelector;
    mixmm16to1_mode: TKnobsSelector;
    mixmm16to1_levmod1: TKnobsInput;
    mixmm16to1_levmod2: TKnobsInput;
    mixmm16to1_levmod3: TKnobsInput;
    mixmm16to1_levmod4: TKnobsInput;
    mixmm16to1_levmod5: TKnobsInput;
    mixmm16to1_levmod6: TKnobsInput;
    mixmm16to1_levmod7: TKnobsInput;
    mixmm16to1_levmod8: TKnobsInput;
    mixmm16to1_levmod9: TKnobsInput;
    mixmm16to1_levmod10: TKnobsInput;
    mixmm16to1_levmod11: TKnobsInput;
    mixmm16to1_levmod12: TKnobsInput;
    mixmm16to1_levmod13: TKnobsInput;
    mixmm16to1_levmod14: TKnobsInput;
    mixmm16to1_levmod15: TKnobsInput;
    mixmm16to1_levmod16: TKnobsInput;
    scalequantizer: TKnobsModule;
    scalequantizer_editlabel: TKnobsEditLabel;
    scalequantizer_out: TKnobsOutput;
    scalequantizer_in: TKnobsInput;
    scalequantizer_textlabel_level: TKnobsTextLabel;
    scalequantizer_note0: TKnobsSelector;
    scalequantizer_note1: TKnobsSelector;
    scalequantizer_note2: TKnobsSelector;
    scalequantizer_note3: TKnobsSelector;
    scalequantizer_note4: TKnobsSelector;
    scalequantizer_note5: TKnobsSelector;
    scalequantizer_note6: TKnobsSelector;
    scalequantizer_note7: TKnobsSelector;
    scalequantizer_note8: TKnobsSelector;
    scalequantizer_note9: TKnobsSelector;
    scalequantizer_note10: TKnobsSelector;
    scalequantizer_note11: TKnobsSelector;
    scalequantizer_level: TKnobsSmallKnob;
    scalequantizer_textlabel_preset: TKnobsTextLabel;
    scalequantizer_scale: TKnobsSelector;
    scalequantizer_textlabel_transpose: TKnobsTextLabel;
    scalequantizer_basenote: TKnobsSmallKnob;
    scalequantizer_display_basenote: TKnobsDisplay;
    scalequantizer_chain: TKnobsInput;
    scalequantizer_textlabel_chain: TKnobsTextLabel;
    modquantizer: TKnobsModule;
    modquantizer_editlabel: TKnobsEditLabel;
    modquantizer_out: TKnobsOutput;
    modquantizer_in: TKnobsInput;
    modquantizer_textlabel_level: TKnobsTextLabel;
    modquantizer_note0: TKnobsSelector;
    modquantizer_note1: TKnobsSelector;
    modquantizer_note2: TKnobsSelector;
    modquantizer_note3: TKnobsSelector;
    modquantizer_note4: TKnobsSelector;
    modquantizer_note5: TKnobsSelector;
    modquantizer_note6: TKnobsSelector;
    modquantizer_note7: TKnobsSelector;
    modquantizer_note8: TKnobsSelector;
    modquantizer_note9: TKnobsSelector;
    modquantizer_note10: TKnobsSelector;
    modquantizer_note11: TKnobsSelector;
    modquantizer_level: TKnobsSmallKnob;
    modquantizer_ctrl1: TKnobsInput;
    modquantizer_ctrl3: TKnobsInput;
    modquantizer_ctrl6: TKnobsInput;
    modquantizer_ctrl8: TKnobsInput;
    modquantizer_ctrl10: TKnobsInput;
    modquantizer_ctrl0: TKnobsInput;
    modquantizer_ctrl2: TKnobsInput;
    modquantizer_ctrl4: TKnobsInput;
    modquantizer_ctrl5: TKnobsInput;
    modquantizer_ctrl7: TKnobsInput;
    modquantizer_ctrl9: TKnobsInput;
    modquantizer_ctrl11: TKnobsInput;
    modquantizer_chain: TKnobsInput;
    modquantizer_textlabel_chain: TKnobsTextLabel;
    modquantizer_textlabel_transpose: TKnobsTextLabel;
    modquantizer_basenote: TKnobsSmallKnob;
    modquantizer_display_basenote: TKnobsDisplay;
    modquantizer_indicator_note1: TKnobsIndicator;
    modquantizer_indicator_note3: TKnobsIndicator;
    modquantizer_indicator_note0: TKnobsIndicator;
    modquantizer_indicator_note2: TKnobsIndicator;
    modquantizer_indicator_note4: TKnobsIndicator;
    modquantizer_indicator_note5: TKnobsIndicator;
    modquantizer_indicator_note7: TKnobsIndicator;
    modquantizer_indicator_note9: TKnobsIndicator;
    modquantizer_indicator_note11: TKnobsIndicator;
    modquantizer_indicator_note6: TKnobsIndicator;
    modquantizer_indicator_note8: TKnobsIndicator;
    modquantizer_indicator_note10: TKnobsIndicator;
    seqchord: TKnobsModule;
    seqchord_editlabel: TKnobsEditLabel;
    seqchord_gateout0: TKnobsOutput;
    seqchord_active0: TKnobsInput;
    seqchord_gateout1: TKnobsOutput;
    seqchord_gateout2: TKnobsOutput;
    seqchord_gateout3: TKnobsOutput;
    seqchord_noteout0: TKnobsOutput;
    seqchord_noteout1: TKnobsOutput;
    seqchord_noteout2: TKnobsOutput;
    seqchord_noteout3: TKnobsOutput;
    seqchord_textlabel_active: TKnobsTextLabel;
    seqchord_indicator_active0: TKnobsIndicator;
    seqchord_indicator_gateout0: TKnobsIndicator;
    seqchord_indicator_gateout1: TKnobsIndicator;
    seqchord_indicator_gateout2: TKnobsIndicator;
    seqchord_indicator_gateout3: TKnobsIndicator;
    seqchord_notein0: TKnobsInput;
    seqchord_notein1: TKnobsInput;
    seqchord_notein2: TKnobsInput;
    seqchord_notein3: TKnobsInput;
    seqchord_textlabel_degree: TKnobsTextLabel;
    seqchord_textlabel_type: TKnobsTextLabel;
    seqchord_textlabel_inver: TKnobsTextLabel;
    seqchord_textlabel_octave: TKnobsTextLabel;
    seqchord_gatein0: TKnobsInput;
    seqchord_gatein1: TKnobsInput;
    seqchord_gatein2: TKnobsInput;
    seqchord_gatein3: TKnobsInput;
    seqchord_indicator_gatein0: TKnobsIndicator;
    seqchord_indicator_gatein1: TKnobsIndicator;
    seqchord_indicator_gatein2: TKnobsIndicator;
    seqchord_indicator_gatein3: TKnobsIndicator;
    seqchord_active1: TKnobsInput;
    seqchord_indicator_active1: TKnobsIndicator;
    seqchord_active2: TKnobsInput;
    seqchord_indicator_active2: TKnobsIndicator;
    seqchord_active3: TKnobsInput;
    seqchord_indicator_active3: TKnobsIndicator;
    seqchord_degree0: TKnobsSelector;
    seqchord_type0: TKnobsSelector;
    seqchord_inver0: TKnobsSelector;
    seqchord_octave0: TKnobsSelector;
    seqchord_degree1: TKnobsSelector;
    seqchord_type1: TKnobsSelector;
    seqchord_inver1: TKnobsSelector;
    seqchord_octave1: TKnobsSelector;
    seqchord_degree2: TKnobsSelector;
    seqchord_type2: TKnobsSelector;
    seqchord_inver2: TKnobsSelector;
    seqchord_octave2: TKnobsSelector;
    seqchord_degree3: TKnobsSelector;
    seqchord_type3: TKnobsSelector;
    seqchord_inver3: TKnobsSelector;
    seqchord_octave3: TKnobsSelector;
    seqchord_textlabel_transpose: TKnobsTextLabel;
    seqchord_transpose: TKnobsSmallKnob;
    seqchord_display_transpose: TKnobsDisplay;
    seqchord_textlable_gate: TKnobsTextLabel;
    seqchord_gate: TKnobsInput;
    seqchord_indicator_gate: TKnobsIndicator;
    seqchord_slew: TKnobsSmallKnob;
    seqchord_textlabel_slew: TKnobsTextLabel;
    seqchord_reduce: TKnobsSelector;
    seqchord_textlabel_mode: TKnobsTextLabel;
    slew: TKnobsModule;
    slew_out: TKnobsOutput;
    slew_in: TKnobsInput;
    slew_editlabel: TKnobsEditLabel;
    slew_textlabel_in: TKnobsTextLabel;
    slew_texrlabel_out: TKnobsTextLabel;
    slew_slew: TKnobsSmallKnob;
    interpreter_display_wordname: TKnobsDisplay;
    interpreter_indicator_active: TKnobsIndicator;
    interpreter_textlabel_active: TKnobsTextLabel;
    mixingscaler: TKnobsModule;
    mixingscaler_in1: TKnobsInput;
    mixingscaler_in2: TKnobsInput;
    mixingscaler_in3: TKnobsInput;
    mixingscaler_in4: TKnobsInput;
    mixingscaler_editlabel: TKnobsEditLabel;
    mixingscaler_textlabel_gain: TKnobsTextLabel;
    mixingscaler_textlabel_offset: TKnobsTextLabel;
    mixingscaler_sum: TKnobsOutput;
    mixingscaler_textlabel_sum: TKnobsTextLabel;
    mixingscaler_offset: TKnobsSmallKnob;
    mixingscaler_gain: TKnobsSmallKnob;
    mixingscaler_display_gain: TKnobsDisplay;
    mixingscaler_display_offset: TKnobsDisplay;
    mixingscaler_outmute: TKnobsSelector;
    mixingscaler_offset2: TKnobsSmallKnob;
    mixingscaler_gain2: TKnobsSmallKnob;
    mixingscaler_display_gain2: TKnobsDisplay;
    mixingscaler_display_offset2: TKnobsDisplay;
    mixingscaler_offset3: TKnobsSmallKnob;
    mixingscaler_gain3: TKnobsSmallKnob;
    mixingscaler_display_gain3: TKnobsDisplay;
    mixingscaler_display_offset3: TKnobsDisplay;
    mixingscaler_offset4: TKnobsSmallKnob;
    mixingscaler_gain4: TKnobsSmallKnob;
    mixingscaler_display_gain4: TKnobsDisplay;
    mixingscaler_display_offset4: TKnobsDisplay;
    mixingscaler_mute: TKnobsSelector;
    mixingscaler_mute2: TKnobsSelector;
    mixingscaler_mute3: TKnobsSelector;
    mixingscaler_mute4: TKnobsSelector;
    mixingscaler_mode: TKnobsSelector;
    mixingscaler_textlabel_lock: TKnobsTextLabel;
    mixingscaler_mode2: TKnobsSelector;
    mixingscaler_textlabel_mute: TKnobsTextLabel;
    mixingscaler_mode3: TKnobsSelector;
    mixingscaler_mode4: TKnobsSelector;
    mixingscaler_textlabel_in: TKnobsTextLabel;
    mixingscaler_outlevel: TKnobsSmallKnob;
    mixingscaler_textlabel_out: TKnobsTextLabel;
    mixingscaler_out1: TKnobsOutput;
    mixingscaler_out2: TKnobsOutput;
    mixingscaler_out3: TKnobsOutput;
    mixingscaler_out4: TKnobsOutput;
    mixingscaler_chain: TKnobsInput;
    mixingscaler_textlabel_chain: TKnobsTextLabel;
    stereowiden: TKnobsModule;
    stereowiden_editlabel: TKnobsEditLabel;
    stereowiden_inl: TKnobsInput;
    stereowiden_outl: TKnobsOutput;
    stereowiden_widenamtmod: TKnobsInput;
    stereowiden_textlabel_inversionamt: TKnobsTextLabel;
    stereowiden_textlabel_delay: TKnobsTextLabel;
    stereowiden_mute: TKnobsSelector;
    stereowiden_widenamt: TKnobsSmallKnob;
    stereowiden_length: TKnobsSmallKnob;
    stereowiden_display_length: TKnobsDisplay;
    stereowiden_outr: TKnobsOutput;
    stereowiden_inr: TKnobsInput;
    stereowiden_delayamtmod: TKnobsInput;
    stereowiden_textlabel_delayamt: TKnobsTextLabel;
    stereowiden_delayamt: TKnobsSmallKnob;
    stereowiden_textlabel_l: TKnobsTextLabel;
    stereowiden_textlabel_r: TKnobsTextLabel;
    stereowiden_delay: TKnobsInput;
    mixm3to1: TKnobsModule;
    mixm3to1_editlabel: TKnobsEditLabel;
    mixm3to1_out: TKnobsOutput;
    mixm3to1_in2: TKnobsInput;
    mixm3to1_in3: TKnobsInput;
    mixm3to1_in1: TKnobsInput;
    mixm3to1_in: TKnobsInput;
    mixm3to1_levmod2: TKnobsInput;
    mixm3to1_levmod3: TKnobsInput;
    mixm3to1_levmod1: TKnobsInput;
    mixm3to1_mode: TKnobsSelector;
    mixm3to1_level2: TKnobsSmallKnob;
    mixm3to1_level3: TKnobsSmallKnob;
    mixm3to1_level1: TKnobsSmallKnob;
    mixm3to1_mute1: TKnobsSelector;
    mixm3to1_mute2: TKnobsSelector;
    mixm3to1_mute3: TKnobsSelector;
    mixmm16to1_textlabel_inputs: TKnobsTextLabel;
    mixm3to1_textlabel_ins: TKnobsTextLabel;
    mixm3to1_textlabel_mods: TKnobsTextLabel;
    volume: TKnobsModule;
    volume_editlabel: TKnobsEditLabel;
    volume_outl: TKnobsOutput;
    volume_inl: TKnobsInput;
    volume_inr: TKnobsInput;
    volume_level2: TKnobsSmallKnob;
    volume_level1: TKnobsSmallKnob;
    volume_mute: TKnobsSelector;
    volume_outr: TKnobsOutput;
    volume_levelmod: TKnobsInput;
    midimultinotein: TKnobsModule;
    midimultinotein_editlabel: TKnobsEditLabel;
    midimultinotein_indicator_gate: TKnobsIndicator;
    midimultinotein_gate: TKnobsOutput;
    midimultinotein_note: TKnobsOutput;
    midimultinotein_velon: TKnobsOutput;
    midimultinotein_veloff: TKnobsOutput;
    midimultinotein_textlabel_gate: TKnobsTextLabel;
    midimultinotein_textlabel_off: TKnobsTextLabel;
    midimultinotein_textlabel_on: TKnobsTextLabel;
    midimultinotein_textlabel_note: TKnobsTextLabel;
    midimultinotein_ch: TKnobsNoKnob;
    midimultinotein_display_ch: TKnobsDisplay;
    midimultinotein_indicator_gate2: TKnobsIndicator;
    midimultinotein_gate2: TKnobsOutput;
    midimultinotein_note2: TKnobsOutput;
    midimultinotein_velon2: TKnobsOutput;
    midimultinotein_veloff2: TKnobsOutput;
    midimultinotein_indicator_gate3: TKnobsIndicator;
    midimultinotein_gate3: TKnobsOutput;
    midimultinotein_note3: TKnobsOutput;
    midimultinotein_velon3: TKnobsOutput;
    midimultinotein_veloff3: TKnobsOutput;
    midimultinotein_indicator_gate4: TKnobsIndicator;
    midimultinotein_gate4: TKnobsOutput;
    midimultinotein_note4: TKnobsOutput;
    midimultinotein_velon4: TKnobsOutput;
    midimultinotein_veloff4: TKnobsOutput;
    midimultinotein_after: TKnobsOutput;
    midimultinotein_textlabel_aft: TKnobsTextLabel;
    midimultinotein_after2: TKnobsOutput;
    midimultinotein_after3: TKnobsOutput;
    midimultinotein_after4: TKnobsOutput;
    midimultinotein_textlabel_bend: TKnobsTextLabel;
    midimultinotein_bend: TKnobsOutput;
    midimultinotein_level: TKnobsInput;
    midimultinotein_textlabel_level: TKnobsTextLabel;
    midimultinotein_level2: TKnobsInput;
    midimultinotein_level3: TKnobsInput;
    midimultinotein_level4: TKnobsInput;
    midimultinotein_mode: TKnobsSelector;
    midimultinotein_textlabel_stealing: TKnobsTextLabel;
    rms: TKnobsModule;
    rms_out: TKnobsOutput;
    rms_in: TKnobsInput;
    rms_editlabel: TKnobsEditLabel;
    rms_textlabel_in: TKnobsTextLabel;
    rms_textlabel_out: TKnobsTextLabel;
    rms_textlabel_time: TKnobsTextLabel;
    rms_time: TKnobsSmallKnob;
    rms_display_time: TKnobsDisplay;
    value: TKnobsModule;
    value_editlabel: TKnobsEditLabel;
    value_in: TKnobsInput;
    value_mode: TKnobsSelector;
    xfade_fadertype: TKnobsSelector;
    pan_fadertype: TKnobsSelector;
    compressor_mode: TKnobsSelector;
    median_avg: TKnobsOutput;
    median_textlabel_avg: TKnobsTextLabel;
    ks: TKnobsModule;
    ks_editlabel: TKnobsEditLabel;
    ks_out: TKnobsOutput;
    ks_fm: TKnobsInput;
    ks_pluck: TKnobsInput;
    ks_textlabel_fm: TKnobsTextLabel;
    ks_textlabel_feedb: TKnobsTextLabel;
    ks_textlabel_pluck: TKnobsTextLabel;
    ks_textlabel_brightness: TKnobsTextLabel;
    ks_freq: TKnobsInput;
    ks_textlabel_freq: TKnobsTextLabel;
    ks_frequency: TKnobsSmallKnob;
    ks_display_frequency: TKnobsDisplay;
    ks_mute: TKnobsSelector;
    ks_fmlevel: TKnobsSmallKnob;
    ks_feedback: TKnobsSmallKnob;
    ks_cents: TKnobsSmallKnob;
    ks_display_cents: TKnobsDisplay;
    ks_brightness: TKnobsSmallKnob;
    ks_plucklevel: TKnobsSmallKnob;
    formant2: TKnobsModule;
    formant2_out: TKnobsOutput;
    formant2_in: TKnobsInput;
    formant2_editlabel: TKnobsEditLabel;
    formant2_textlabel_in: TKnobsTextLabel;
    formant2_textlabel_control: TKnobsTextLabel;
    formant2_vowelin: TKnobsInput;
    formant2_textlabel_vowel: TKnobsTextLabel;
    formant2_vowel: TKnobsSmallKnob;
    formant2_controlmod: TKnobsSmallKnob;
    formant2_vowelset: TKnobsSelector;
    pulser: TKnobsModule;
    pulser_editlabel: TKnobsEditLabel;
    pulser_out: TKnobsOutput;
    pulser_shape: TKnobsInput;
    pulser_signal: TKnobsInput;
    pulser_textlabel_signal: TKnobsTextLabel;
    pulser_textlabel_out: TKnobsTextLabel;
    pulser_textlabel_cmplev: TKnobsTextLabel;
    pulser_inactive: TKnobsOutput;
    pulser_textlabel_inactive: TKnobsTextLabel;
    pulser_shapelevel: TKnobsSmallKnob;
    pulser_shapeoffset: TKnobsSmallKnob;
    pulser_signallevel: TKnobsSmallKnob;
    pulser_signaloffset: TKnobsSmallKnob;
    pulser_mute: TKnobsSelector;
    pulser_textlabel_shapeleveloffset: TKnobsTextLabel;
    pulser_textlabel_signalleveloffset: TKnobsTextLabel;
    ImageListPulseModes: TImageList;
    divider_mode: TKnobsSelector;
    progdivider_mode: TKnobsSelector;
    gate_outputtype: TKnobsSelector;
    dflipflop_outputtype: TKnobsSelector;
    rsflipflop_outputtype: TKnobsSelector;
    tapper: TKnobsModule;
    tapper_editlabel: TKnobsEditLabel;
    tapper_outpulse: TKnobsOutput;
    tapper_indicator_pulse: TKnobsIndicator;
    tapper_sw: TKnobsSelector;
    tapper_outspeed: TKnobsOutput;
    tapper_textlabel_speedout: TKnobsTextLabel;
    tapper_textlabel_taprate: TKnobsTextLabel;
    tapper_indicator_busy: TKnobsIndicator;
    tapper_display_bpm: TKnobsDisplay;
    tapper_bpm: TKnobsSmallKnob;
    tapper_sync: TKnobsSelector;
    tapper_mode: TKnobsSelector;
    tapper_textlabel_mode: TKnobsTextLabel;
    tapper_textlabel_tap: TKnobsTextLabel;
    tapper_rate: TKnobsSmallKnob;
    tapper_display_rate: TKnobsDisplay;
    tapper_textlabel_rate: TKnobsTextLabel;
    tapper_outslave: TKnobsOutput;
    tapper_inslave: TKnobsInput;
    tapper_textlabel_slave: TKnobsTextLabel;
    divider_outputtype: TKnobsSelector;
    progdivider_outputtype: TKnobsSelector;
    mixs5to1: TKnobsModule;
    mixs5to1_editlabel: TKnobsEditLabel;
    mixs5to1_outr: TKnobsOutput;
    mixs5to1_inr1: TKnobsInput;
    mixs5to1_inr2: TKnobsInput;
    mixs5to1_inr: TKnobsInput;
    mixs5to1_inl: TKnobsInput;
    mixs5to1_outl: TKnobsOutput;
    mixs5to1_inl2: TKnobsInput;
    mixs5to1_inl1: TKnobsInput;
    mixs5to1_levmod1: TKnobsInput;
    mixs5to1_levmod2: TKnobsInput;
    mixs5to1_level1: TKnobsSmallKnob;
    mixs5to1_level2: TKnobsSmallKnob;
    mixs5to1_mute1: TKnobsSelector;
    mixs5to1_mute2: TKnobsSelector;
    mixs5to1_mode: TKnobsSelector;
    mixs5to1_inr3: TKnobsInput;
    mixs5to1_inr4: TKnobsInput;
    mixs5to1_inl4: TKnobsInput;
    mixs5to1_inl3: TKnobsInput;
    mixs5to1_levmod3: TKnobsInput;
    mixs5to1_levmod4: TKnobsInput;
    mixs5to1_level3: TKnobsSmallKnob;
    mixs5to1_level4: TKnobsSmallKnob;
    mixs5to1_mute3: TKnobsSelector;
    mixs5to1_mute4: TKnobsSelector;
    mixs5to1_inr5: TKnobsInput;
    mixs5to1_inl5: TKnobsInput;
    mixs5to1_levmod5: TKnobsInput;
    mixs5to1_level5: TKnobsSmallKnob;
    mixs5to1_mute5: TKnobsSelector;
    phasedistort: TKnobsModule;
    phasedistort_editlabel: TKnobsEditLabel;
    phasedistort_inl: TKnobsInput;
    phasedistort_outl: TKnobsOutput;
    phasedistort_textlabel_delay: TKnobsTextLabel;
    phasedistort_outr: TKnobsOutput;
    phasedistort_inr: TKnobsInput;
    phasedistort_textlabel_l: TKnobsTextLabel;
    phasedistort_textlabel_r: TKnobsTextLabel;
    phasedistort_delay: TKnobsInput;
    phasedistort_mute: TKnobsSelector;
    phasedistort_length: TKnobsSmallKnob;
    phasedistort_display_length: TKnobsDisplay;
    phasedistort_fm: TKnobsInput;
    phasedistort_textlabel_fm: TKnobsTextLabel;
    phasedistort_textlabel_q: TKnobsTextLabel;
    phasedistort_freq: TKnobsInput;
    phasedistort_textlabel_frq: TKnobsTextLabel;
    phasedistort_display_freq: TKnobsDisplay;
    phasedistort_frequency: TKnobsSmallKnob;
    phasedistort_q: TKnobsSmallKnob;
    phasedistort_fmlevel: TKnobsSmallKnob;
    phasedistort_textlabel_drywet: TKnobsTextLabel;
    phasedistort_drywet: TKnobsSmallKnob;
    phasedistort_mode: TKnobsSelector;
    phasedistort_textlabel_filter: TKnobsTextLabel;
    phasedistort_intensity: TKnobsSmallKnob;
    phasedistort_textlabel_intensity: TKnobsTextLabel;
    phasedistort_intensitymod: TKnobsInput;
    phasedistort_intensitymodlev: TKnobsSmallKnob;
    phasedistort_textlabel_im: TKnobsTextLabel;
    cubicclip: TKnobsModule;
    cubicclip_out: TKnobsOutput;
    cubicclip_in: TKnobsInput;
    cubicclip_editlabel: TKnobsEditLabel;
    cubicclip_textlabel_alpha: TKnobsTextLabel;
    cubicclip_textlabel_hysteresis: TKnobsTextLabel;
    cubicclip_alpha: TKnobsSmallKnob;
    cubicclip_display_alpha: TKnobsDisplay;
    cubicclip_mute: TKnobsSelector;
    cubicclip_hysteresis: TKnobsSmallKnob;
    cubicclip_display_hysteresis: TKnobsDisplay;
    ks_mode: TKnobsSelector;
    ks_textlabel_interpolation: TKnobsTextLabel;
    allpass: TKnobsModule;
    allpass_editlabel: TKnobsEditLabel;
    allpass_out: TKnobsOutput;
    allpass_in: TKnobsInput;
    allpass_textlabel_length: TKnobsTextLabel;
    allpass_length: TKnobsSmallKnob;
    allpass_display_length: TKnobsDisplay;
    allpass_kmod: TKnobsInput;
    allpass_textlabel_kmod: TKnobsTextLabel;
    allpass_kmodamt: TKnobsSmallKnob;
    allpass_k: TKnobsSmallKnob;
    allpass_textlabel_k: TKnobsTextLabel;
    allpass_indicator_clip: TKnobsIndicator;
    allpass_textlabel_kclip: TKnobsTextLabel;
    value_display_value: TKnobsDisplay;
    pulsedelay: TKnobsModule;
    pulsedelay_editlabel: TKnobsEditLabel;
    pulsedelay_symbol_trig: TImage;
    pulsedelay_out: TKnobsOutput;
    pulsedelay_trig: TKnobsInput;
    pulsedelay_indicator_out: TKnobsIndicator;
    pulsedelay_textlabel_trig: TKnobsTextLabel;
    pulsedelay_symbol_reset: TImage;
    pulsedelay_reset: TKnobsInput;
    pulsedelay_textlabel_reset: TKnobsTextLabel;
    pulsedelay_outputtype: TKnobsSelector;
    pulsedelay_textlabel_delay: TKnobsTextLabel;
    pulsedelay_delay: TKnobsSmallKnob;
    pulsedelay_display_delay: TKnobsDisplay;
    pulsedelay_range: TKnobsSelector;
    ImageListPulseDelModes: TImageList;
    pulsedelay_delaymode: TKnobsSelector;
    pulsedelay_textlabel_mode: TKnobsTextLabel;
    pulsedelay_delaymod: TKnobsInput;
    pulsedelay_delaymodamt: TKnobsSmallKnob;
    pulsedelay_indicator_active: TKnobsIndicator;
    sawmill: TKnobsModule;
    sawmill_out: TKnobsOutput;
    sawmill_in: TKnobsInput;
    sawmill_editlabel: TKnobsEditLabel;
    sawmill_textlabel_in: TKnobsTextLabel;
    sawmill_textlabel_out: TKnobsTextLabel;
    sawmill_textlabel_mult: TKnobsTextLabel;
    sawmill_mult: TKnobsSmallKnob;
    sawmill_display_mult: TKnobsDisplay;
    sawmill_multmod: TKnobsInput;
    sawmill_textlabel_mmod: TKnobsTextLabel;
    sawmill_multmodamt: TKnobsSmallKnob;
    sawmill_inputtype: TKnobsSelector;
    sawmill_outputtype: TKnobsSelector;
    rungler: TKnobsModule;
    rungler_editlabel: TKnobsEditLabel;
    rungler_out: TKnobsOutput;
    rungler_clock: TKnobsInput;
    rungler_data: TKnobsInput;
    rungler_textlabel_clock: TKnobsTextLabel;
    rungler_textlabel_data: TKnobsTextLabel;
    rungler_textlabel_out: TKnobsTextLabel;
    rungler_indicator_led: TKnobsIndicator;
    rungler_textlabel_level: TKnobsTextLabel;
    rungler_level: TKnobsSmallKnob;
    rungler_length: TKnobsSmallKnob;
    rungler_display_length: TKnobsDisplay;
    rungler_textlabel_length: TKnobsTextLabel;
    rungler_textlabel_taps: TKnobsTextLabel;
    rungler_taps: TKnobsSmallKnob;
    rungler_display_taps: TKnobsDisplay;
    envelope_mode: TKnobsSelector;
    svf_textlabel_qm: TKnobsTextLabel;
    svf_qmamtp: TKnobsInput;
    svf_qm: TKnobsSmallKnob;
    svf_qmamtn: TKnobsInput;
    svf_textlabel_plus: TKnobsTextLabel;
    svf_textlabel_minus: TKnobsTextLabel;
    intdif_gain: TKnobsHSlider;
    intdif_textlabel_gain: TKnobsTextLabel;
    tss: TKnobsModule;
    tss_editlabel: TKnobsEditLabel;
    tss_speed: TKnobsInput;
    tss_textlabel_speed: TKnobsTextLabel;
    tss_textlabel_duration: TKnobsTextLabel;
    tss_textlabel_pos: TKnobsTextLabel;
    tss_pos: TKnobsInput;
    tss_symbol_res: TImage;
    tss_res: TKnobsInput;
    tss_indicator_res: TKnobsIndicator;
    tss_textlabel_res: TKnobsTextLabel;
    tss_out: TKnobsOutput;
    tss_fm: TKnobsInput;
    tss_textlabel_fm: TKnobsTextLabel;
    tss_display_duration: TKnobsDisplay;
    rungler_bit: TKnobsOutput;
    rungler_textlabel_bit: TKnobsTextLabel;
    mixms8to1: TKnobsModule;
    mixms8to1_editlabel: TKnobsEditLabel;
    mixms8to1_outr: TKnobsOutput;
    mixms8to1_textlabel_out: TKnobsTextLabel;
    mixms8to1_inl1: TKnobsInput;
    mixms8to1_inr1: TKnobsInput;
    mixms8to1_inl2: TKnobsInput;
    mixms8to1_inr2: TKnobsInput;
    mixms8to1_inl3: TKnobsInput;
    mixms8to1_inr3: TKnobsInput;
    mixms8to1_inl4: TKnobsInput;
    mixms8to1_inr4: TKnobsInput;
    mixms8to1_inl5: TKnobsInput;
    mixms8to1_inr5: TKnobsInput;
    mixms8to1_inl6: TKnobsInput;
    mixms8to1_inr6: TKnobsInput;
    mixms8to1_inl7: TKnobsInput;
    mixms8to1_inr7: TKnobsInput;
    mixms8to1_inl8: TKnobsInput;
    mixms8to1_inr8: TKnobsInput;
    mixms8to1_inl: TKnobsInput;
    mixms8to1_levmod1: TKnobsInput;
    mixms8to1_levmod2: TKnobsInput;
    mixms8to1_levmod3: TKnobsInput;
    mixms8to1_levmod4: TKnobsInput;
    mixms8to1_levmod5: TKnobsInput;
    mixms8to1_levmod6: TKnobsInput;
    mixms8to1_levmod7: TKnobsInput;
    mixms8to1_levmod8: TKnobsInput;
    mixms8to1_textlabel_inputs: TKnobsTextLabel;
    mixms8to1_lev1: TKnobsSlider;
    mixms8to1_lev2: TKnobsSlider;
    mixms8to1_lev3: TKnobsSlider;
    mixms8to1_lev4: TKnobsSlider;
    mixms8to1_lev5: TKnobsSlider;
    mixms8to1_lev6: TKnobsSlider;
    mixms8to1_lev7: TKnobsSlider;
    mixms8to1_lev8: TKnobsSlider;
    mixms8to1_mode: TKnobsSelector;
    mixms8to1_outl: TKnobsOutput;
    mixms8to1_inr: TKnobsInput;
    mixms8to1_mute1: TKnobsSelector;
    mixms8to1_mute2: TKnobsSelector;
    mixms8to1_mute3: TKnobsSelector;
    mixms8to1_mute4: TKnobsSelector;
    mixms8to1_mute7: TKnobsSelector;
    mixms8to1_mute8: TKnobsSelector;
    mixms8to1_mute6: TKnobsSelector;
    mixms8to1_mute5: TKnobsSelector;
    volume_textlabel_level: TKnobsTextLabel;
    volume_textlabel_mod: TKnobsTextLabel;
    tss_display_text: TKnobsDisplay;
    tss_mute: TKnobsSelector;
    clockgen: TKnobsModule;
    clockgen_editlabel: TKnobsEditLabel;
    clockgen_symbol_trig: TImage;
    clockgen_sync: TKnobsOutput;
    clockgen_res: TKnobsInput;
    clockgen_indicator_sync: TKnobsIndicator;
    clockgen_indicator_res: TKnobsIndicator;
    clockgen_textlabel_swing: TKnobsTextLabel;
    clockgen_textlabel_res: TKnobsTextLabel;
    clockgen_96: TKnobsOutput;
    clockgen_textlabel_sync: TKnobsTextLabel;
    clockgen_tempo: TKnobsSmallKnob;
    clockgen_display_tempo: TKnobsDisplay;
    clockgen_mute: TKnobsSelector;
    clockgen_swing: TKnobsSmallKnob;
    clockgen_16: TKnobsOutput;
    clockgen_textlabel_96: TKnobsTextLabel;
    clockgen_textlabel_16: TKnobsTextLabel;
    clockgen_textlabel_tempo: TKnobsTextLabel;
    clockgen_phase16: TKnobsOutput;
    clockgen_phase96: TKnobsOutput;
    clockgen_div: TKnobsSmallKnob;
    clockgen_display_div: TKnobsDisplay;
    clockgen_textlabel_syncdiv: TKnobsTextLabel;
    clockgen_textlabel_act: TKnobsTextLabel;
    song: TKnobsModule;
    song_editlabel: TKnobsEditLabel;
    song_symbol_res: TImage;
    song_res: TKnobsInput;
    song_indicator_res: TKnobsIndicator;
    song_textlabel_res: TKnobsTextLabel;
    song_out: TKnobsOutput;
    song_txtstart: TKnobsOutput;
    song_phstart: TKnobsOutput;
    song_textlabel_phstart: TKnobsTextLabel;
    song_textlabel_txtstart: TKnobsTextLabel;
    song_display_text: TKnobsDisplay;
    song_mute: TKnobsSelector;
    song_loop: TKnobsSelector;
    song_textlabel_loop: TKnobsTextLabel;
    song_textlabel_whisper: TKnobsTextLabel;
    song_whispermod: TKnobsInput;
    song_whisper: TKnobsSmallKnob;
    song_whispermodamt: TKnobsSmallKnob;
    song_textlabel_out: TKnobsTextLabel;
    song_textlabel_speed: TKnobsTextLabel;
    song_speedmod: TKnobsInput;
    song_speed: TKnobsSmallKnob;
    song_speedmodamt: TKnobsSmallKnob;
    song_textlabel_fm: TKnobsTextLabel;
    song_fmmod: TKnobsInput;
    song_freq: TKnobsSmallKnob;
    song_fmmodamt: TKnobsSmallKnob;
    count: TKnobsModule;
    count_editlabel: TKnobsEditLabel;
    count_reset: TKnobsSelector;
    count_display_value: TKnobsDisplay;
    count_symbol_count: TImage;
    count_count: TKnobsInput;
    count_textlabel_count: TKnobsTextLabel;
    count_symbol_res: TImage;
    count_res: TKnobsInput;
    count_textlabel_res: TKnobsTextLabel;
    song_display_frequency: TKnobsDisplay;
    song_filtinv: TKnobsSelector;
    song_silence: TKnobsOutput;
    song_vowel: TKnobsOutput;
    song_textlabel_vowel: TKnobsTextLabel;
    song_textlabel_silence: TKnobsTextLabel;
    song_shape: TKnobsSelector;
    song_pm: TKnobsInput;
    song_textlabel_pm: TKnobsTextLabel;
    song_pmamt: TKnobsSmallKnob;
    seqrandval: TKnobsModule;
    seqrandval_editlabel: TKnobsEditLabel;
    seqrandval_out: TKnobsOutput;
    seqrandval_textlabel_out: TKnobsTextLabel;
    seqrandval_symbol_trig: TImage;
    seqrandval_trig: TKnobsInput;
    seqrandval_indicator_trig: TKnobsIndicator;
    seqrandval_textlabel_step: TKnobsTextLabel;
    seqrandval_textlabel_lowvalue: TKnobsTextLabel;
    seqrandval_textlabel_highvalue: TKnobsTextLabel;
    seqrandval_textlabel_basevalue: TKnobsTextLabel;
    seqrandval_textlabel_count: TKnobsTextLabel;
    seqrandval_symbol_changeone: TImage;
    seqrandval_changeone: TKnobsInput;
    seqrandval_indicatorr_changeone: TKnobsIndicator;
    seqrandval_textlabel_change: TKnobsTextLabel;
    seqrandval_distmod: TKnobsInput;
    seqrandval_textlabel_dist: TKnobsTextLabel;
    seqrandval_chain: TKnobsInput;
    seqrandval_textlabel_chain: TKnobsTextLabel;
    seqrandval_lowvalue: TKnobsSmallKnob;
    seqrandval_display_lowvalue: TKnobsDisplay;
    seqrandval_display_highvalue: TKnobsDisplay;
    seqrandval_highvalue: TKnobsSmallKnob;
    seqrandval_basevalue: TKnobsSmallKnob;
    seqrandval_display_basevalye: TKnobsDisplay;
    seqrandval_count: TKnobsSmallKnob;
    seqrandval_display_count: TKnobsDisplay;
    seqrandval_distmodamt: TKnobsSmallKnob;
    seqrandval_dist: TKnobsSmallKnob;
    seqrandval_textlable_notes: TKnobsTextLabel;
    seqrandval_qsteps: TKnobsSmallKnob;
    seqrandval_display_qsteps: TKnobsDisplay;
    seqrandval_textlabel_qyantize: TKnobsTextLabel;
    seqrandval_quantize: TKnobsSelector;
    seqrandval_slew: TKnobsSmallKnob;
    seqrandval_textlabel_slew: TKnobsTextLabel;
    seqrandval_slewmode: TKnobsSelector;
    vosim: TKnobsModule;
    vosim_editlabel: TKnobsEditLabel;
    vosim_symbol_trig: TImage;
    vosim_out: TKnobsOutput;
    vosim_fm: TKnobsInput;
    vosim_trig: TKnobsInput;
    vosim_textlabel_fm: TKnobsTextLabel;
    vosim_textlabel_trig: TKnobsTextLabel;
    vosim_textlabel_count: TKnobsTextLabel;
    vosim_freq: TKnobsInput;
    vosim_frequency: TKnobsSmallKnob;
    vosim_display_freq: TKnobsDisplay;
    vosim_display_count: TKnobsDisplay;
    vosim_count: TKnobsNoKnob;
    vosim_mute: TKnobsSelector;
    vosim_fmamt: TKnobsSmallKnob;
    vosim_textlabel_decay: TKnobsTextLabel;
    vosim_decay: TKnobsSmallKnob;
    vosim_display_decay: TKnobsDisplay;
    vosim_textlabel_freq: TKnobsTextLabel;
    vosim_dm: TKnobsInput;
    vosim_textlabel_dm: TKnobsTextLabel;
    vosim_dmamt: TKnobsSmallKnob;
    vosim_amplitude: TKnobsSmallKnob;
    vosim_am: TKnobsInput;
    vosim_textlabel_am: TKnobsTextLabel;
    vosim_amamt: TKnobsSmallKnob;
    vosim_textlabel_amplitude: TKnobsTextLabel;
    vosim_cm: TKnobsInput;
    vosim_whisper: TKnobsSmallKnob;
    vosim_wm: TKnobsInput;
    vosim_textlabel_wm: TKnobsTextLabel;
    vosim_wmamt: TKnobsSmallKnob;
    vosim_textlabel_whisper: TKnobsTextLabel;
    vosim_textlabel_out: TKnobsTextLabel;
    datagraph: TKnobsModule;
    datagraph_editlabel: TKnobsEditLabel;
    datagraph_data: TKnobsDataMaker;
    datagraph_out: TKnobsOutput;
    datagraph_in: TKnobsInput;
    datagraph_textlabel_in: TKnobsTextLabel;
    datagraph_textlabel_out: TKnobsTextLabel;
    datagraph_inmode: TKnobsSelector;
    datagraph_outmode: TKnobsSelector;
    datagraph_splines: TKnobsSelector;
    typeflip: TKnobsModule;
    typeflip_outl: TKnobsOutput;
    typeflip_select: TKnobsInput;
    typeflip_editlabel: TKnobsEditLabel;
    typeflip_textlabel_intypes: TKnobsTextLabel;
    typeflip_textlabel_outtypes: TKnobsTextLabel;
    typeflip_inmode: TKnobsSelector;
    typeflip_outmodel: TKnobsSelector;
    typeflip_outmoder: TKnobsSelector;
    typeflip_textlabel_outsel: TKnobsTextLabel;
    typeflip_outr: TKnobsOutput;
    typeflip_in: TKnobsInput;
    typeflip_textlabel_slew: TKnobsTextLabel;
    typeflip_slew: TKnobsSmallKnob;
    song_frequency: TKnobsInput;
    typeflip_indicator_select: TKnobsIndicator;
    clockgen_tempoex: TKnobsInput;
    tritonebank_fi: TKnobsSelector;
    thirdbank_fi: TKnobsSelector;
    modal_fi: TKnobsSelector;
    tritonesplitter_fi: TKnobsSelector;
    thirdsplitter_fi: TKnobsSelector;
    freqcount: TKnobsModule;
    freqcount_editlabel: TKnobsEditLabel;
    freqcount_symbol_count: TImage;
    freqcount_count: TKnobsInput;
    freqcount_textlabel_count: TKnobsTextLabel;
    freqcount_symbol_res: TImage;
    freqcount_res: TKnobsInput;
    freqcount_textlabel_res: TKnobsTextLabel;
    freqcount_reset: TKnobsSelector;
    freqcount_display_value: TKnobsDisplay;
    freqcount_timebase: TKnobsSmallKnob;
    freqcount_display_timebase: TKnobsDisplay;
    looper: TKnobsModule;
    looper_editlabel: TKnobsEditLabel;
    looper_out: TKnobsOutput;
    looper_in: TKnobsInput;
    looper_speedmod: TKnobsInput;
    looper_textlabel_in: TKnobsTextLabel;
    looper_textlabel_speed: TKnobsTextLabel;
    looper_textlabel_maxlength: TKnobsTextLabel;
    looper_length: TKnobsSmallKnob;
    looper_display_maxtime: TKnobsDisplay;
    looper_range: TKnobsSelector;
    looper_rec: TKnobsInput;
    looper_record: TKnobsSelector;
    looper_speedmodamt: TKnobsSmallKnob;
    looper_speed: TKnobsSmallKnob;
    looper_startmod: TKnobsInput;
    looper_textlabel_start: TKnobsTextLabel;
    looper_start: TKnobsSmallKnob;
    looper_startmodamt: TKnobsSmallKnob;
    looper_durationmod: TKnobsInput;
    looper_textlabel_duration: TKnobsTextLabel;
    looper_duration: TKnobsSmallKnob;
    looper_durationmodamt: TKnobsSmallKnob;
    looper_textlabel_out: TKnobsTextLabel;
    looper_mode: TKnobsSelector;
    looper_textlabel_overlap: TKnobsTextLabel;
    looper_overlap: TKnobsSmallKnob;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FModules               : TKnobsModuleList;
    FOnDesignerLog         : TOnDesignerLog;
    FTitleFont             : TFont;
    FModuleFont            : TFont;
    FConnectorBorders      : Boolean;
    FConnectorTypedBorders : Boolean;
    FGroupIOColor          : TColor;
    FGroupOSCColor         : TColor;
    FGroupLFOColor         : TColor;
    FGroupEnvColor         : TColor;
    FGroupFilterColor      : TColor;
    FGroupSwitchColor      : TColor;
    FGroupMixColor         : TColor;
    FGroupControlColor     : TColor;
    FGroupNoteColor        : TColor;
    FGroupMathColor        : TColor;
    FGroupLogicColor       : TColor;
    FGroupSeqColor         : TColor;
    FGroupFXColor          : TColor;
    FGroupDelayColor       : TColor;
    FGroupUtilityColor     : TColor;
    FConnectorBorderColor  : TColor;
    FSelectorColor         : TColor;
    FSelectorBorderColor   : TColor;
    FSelectorBorderColorS  : TColor;
    FDisplayColor          : TColor;
    FDisplayBorderColor    : TColor;
    FKnobMIDIColor         : TColor;
    FKnobFocusColor        : TColor;
    FKnobMIDIFocusColor    : TColor;
    FViewerColor           : TColor;
    FViewerBorderColor     : TColor;
    FViewerLineColor       : TColor;
    FViewerFillColor       : TColor;
    FIndBarPeakColor       : TColor;
    FIndBarValeyColor      : TColor;
    FModuleOpacity         : Byte;
  private
    procedure   ChangeTabColor( const aTabSheet: TTabSheet; aColor: TColor);
    procedure   SetTitleFont            ( const aValue: TFont);
    procedure   SetModuleFont           ( const aValue: TFont);
    procedure   SetConnectorBorders     ( aValue: Boolean);
    procedure   SetConnectorTypedBorders( aValue: Boolean);
    procedure   SetGroupIOColor         ( aValue: TColor);
    procedure   SetGroupOSCColor        ( aValue: TColor);
    procedure   SetGroupLFOColor        ( aValue: TColor);
    procedure   SetGroupEnvColor        ( aValue: TColor);
    procedure   SetGroupFilterColor     ( aValue: TColor);
    procedure   SetGroupSwitchColor     ( aValue: TColor);
    procedure   SetGroupMixColor        ( aValue: TColor);
    procedure   SetGroupControlColor    ( aValue: TColor);
    procedure   SetGroupNoteColor       ( aValue: TColor);
    procedure   SetGroupMathColor       ( aValue: TColor);
    procedure   SetGroupLogicColor      ( aValue: TColor);
    procedure   SetGroupSeqColor        ( aValue: TColor);
    procedure   SetGroupFXColor         ( aValue: TColor);
    procedure   SetGroupDelayColor      ( aValue: TColor);
    procedure   SetGroupUtilityColor    ( aValue: TColor);
    procedure   SetConnectorBorderColor ( aValue: TColor);
    procedure   SetSelectorColor        ( aValue: TColor);
    procedure   SetSelectorBorderColor  ( aValue: TColor);
    procedure   SetSelectorBorderColorS ( aValue: TColor);
    procedure   SetDisplayColor         ( aValue: TColor);
    procedure   SetDisplayBorderColor   ( aValue: TColor);
    procedure   SetKnobMIDIColor        ( aValue: TColor);
    procedure   SetKnobFocusColor       ( aValue: TColor);
    procedure   SetKnobMIDIFocusColor   ( aValue: TColor);
    procedure   SetViewerColor          ( aValue: TColor);
    procedure   SetViewerBorderColor    ( aValue: TColor);
    procedure   SetViewerLineColor      ( aValue: TColor);
    procedure   SetViewerFillColor      ( aValue: TColor);
    procedure   SetIndBarPeakColor      ( aValue: TColor);
    procedure   SetIndBarValeyColor     ( aValue: TColor);
    procedure   SetModuleOpacity        ( aValue: Byte);
  private
    procedure   DoModuleListLog( const aSender: TObject; const aMsg: string);
    procedure   DoModuleLog    ( const aSender: TObject; const aMsg: string);
    procedure   RegisterModules;
    procedure   Log( const aMsg: string);
    procedure   LogFmt( const aFmt: string; const anArgs: array of const);
  public
    function    CreateModule(
      const aWirePanel  : TKnobsWirePanel;
      const aModuleType : TKnobsModuleType;
      MustDrag          : Boolean;
      StandardColor     : Boolean
    ): TKnobsCustomModule;
    function    ChangeModule(
      const aWirePanel  : TKnobsWirePanel;
      var   aTarget     : TKnobsCustomModule;
      const aWantedType : TKnobsModuleType;
      aCallBack         : TKnobsOnValuedCtrlRemoved
    ): TKnobsCustomModule;

    procedure   PopulateSelector  ( const aModuleSelector: TKnobsModuleSelector; const aBitmapsFolder: string);
    procedure   UnpopulateSelector( const aModuleSelector: TKnobsModuleSelector);
    procedure   PopulateMenu      ( const aRootMenu: TMenuItem; const aHandler: TNotifyEvent);
    procedure   ShowModule        ( const aModule: TKnobsCustomModule);
    function    BitmapName        ( const aModuleType: TKnobsModuleType): string;
    function    CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    function    ReadModuleComment ( const aModuleType: TKnobsModuleType): string;
    procedure   MakeImage         ( const aFolder: string; const aModule: TKnobsCustomModule);
    procedure   MakeImages        ( const aFolder: string);
    function    FindBitmap        ( const aModuleTitle: string): TBitmap;
    function    FindDocu          ( const aModuleTitle: string): TStrings;
    function    DocumentModule    ( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    function    MakeDocIndex      : string;
    function    MakeDocHeader     ( const aVersion: string): string;
    function    MakeDocFooter     : string;
    function    DoDocument        ( const aFolder, anImagesFolder, aVersion: string): string;
    procedure   Document          ( const aFolder, anImagesFolder, aVersion: string);
    function    GetTabColor       ( const aSender: TObject; const aTabName: string; aMixColor: TColor; aMix: Byte): TColor;
    function    DefaultModuleColor( const aModuleType: TKnobsModuleType; const aDefaultColor: TColor): TColor;
    procedure   LoadControlGlyph  ( const aFolder, aFile: string; aList: TImageList; anIndex: Integer);
    procedure   LoadControlGlyphs ( const aFolder: string);
    procedure   CollectForthInfo  ( const aStringList: TStringList; aDetailInfoCallback: TOnGetForthDetailInfo);
  public
    property    Modules               : TKnobsModuleList read FModules;
    property    OnDesignerLog         : TOnDesignerLog   read FOnDesignerLog         write FOnDesignerLog;
    property    TitleFont             : TFont            read FTitleFont             write SetTitleFont;
    property    ModuleFont            : TFont            read FModuleFont            write SetModuleFont;
    property    ConnectorBorders      : Boolean          read FConnectorBorders      write SetConnectorBorders;
    property    ConnectorTypedBorders : Boolean          read FConnectorTypedBorders write SetConnectorTypedBorders;
    property    GroupIOColor          : TColor           read FGroupIOColor          write SetGroupIOColor;
    property    GroupOSCColor         : TColor           read FGroupOSCColor         write SetGroupOSCColor;
    property    GroupLFOColor         : TColor           read FGroupLFOColor         write SetGroupLFOColor;
    property    GroupEnvColor         : TColor           read FGroupEnvColor         write SetGroupEnvColor;
    property    GroupFilterColor      : TColor           read FGroupFilterColor      write SetGroupFilterColor;
    property    GroupSwitchColor      : TColor           read FGroupSwitchColor      write SetGroupSwitchColor;
    property    GroupMixColor         : TColor           read FGroupMixColor         write SetGroupMixColor;
    property    GroupControlColor     : TColor           read FGroupControlColor     write SetGroupControlColor;
    property    GroupNoteColor        : TColor           read FGroupNoteColor        write SetGroupNoteColor;
    property    GroupMathColor        : TColor           read FGroupMathColor        write SetGroupMathColor;
    property    GroupLogicColor       : TColor           read FGroupLogicColor       write SetGroupLogicColor;
    property    GroupSeqColor         : TColor           read FGroupSeqColor         write SetGroupSeqColor;
    property    GroupFXColor          : TColor           read FGroupFXColor          write SetGroupFXColor;
    property    GroupDelayColor       : TColor           read FGroupDelayColor       write SetGroupDelayColor;
    property    GroupUtilityColor     : TColor           read FGroupUtilityColor     write SetGroupUtilityColor;
    property    ConnectorBorderColor  : TColor           read FConnectorBorderColor  write SetConnectorBorderColor;
    property    SelectorColor         : TColor           read FSelectorColor         write SetSelectorColor;
    property    SelectorBorderColor   : TColor           read FSelectorBorderColor   write SetSelectorBorderColor;
    property    SelectorBorderColorS  : TColor           read FSelectorBorderColorS  write SetSelectorBorderColorS;
    property    DisplayColor          : TColor           read FDisplayColor          write SetDisplayColor;
    property    DisplayBorderColor    : TColor           read FDisplayBorderColor    write SetDisplayBorderColor;
    property    KnobMIDIColor         : TColor           read FKnobMIDIColor         write SetKnobMIDIColor;
    property    KnobFocusColor        : TColor           read FKnobFocusColor        write SetKnobFocusColor;
    property    KnobMIDIFocusColor    : TColor           read FKnobMIDIFocusColor    write SetKnobMIDIFocusColor;
    property    ViewerColor           : TColor           read FViewerColor           write SetViewerColor;
    property    ViewerBorderColor     : TColor           read FViewerBorderColor     write SetViewerBorderColor;
    property    ViewerLineColor       : TColor           read FViewerLineColor       write SetViewerLineColor;
    property    ViewerFillColor       : TColor           read FViewerFillColor       write SetViewerFillColor;
    property    IndBarPeakColor       : TColor           read FIndBarPeakColor       write SetIndBarPeakColor;
    property    IndBarValeyColor      : TColor           read FIndBarValeyColor      write SetIndBarValeyColor;
    property    ModuleOpacity         : Byte             read FModuleOpacity         write SetModuleOpacity;
  end;


var

  FormStore: TFormStore;


implementation


{$R *.DFM}


// User area


//  private


    // -------------------------------------------------------------------------


    procedure   TFormStore.SetTitleFont( const aValue: TFont);
    begin
      if Assigned( FTitleFont) and Assigned( aValue)
      then begin
        FTitleFont.Assign( aValue);
        FreeAndNil( FModules);
        RegisterModules;
      end;
    end;


    procedure   TFormStore.SetModuleFont( const aValue: TFont);
    begin
      if Assigned( FModuleFont) and Assigned( aValue)
      then begin
        FModuleFont.Assign( aValue);
        FreeAndNil( FModules);
        RegisterModules;
      end;
    end;


    procedure   TFormStore.ChangeTabColor( const aTabSheet: TTabSheet; aColor: TColor);
    var
      i : Integer;
    begin
      if Assigned( aTabSheet)
      then begin
        for i := 0 to aTabSheet.ControlCount - 1
        do begin
          if aTabSheet.Controls[ i] is TKnobsCustomModule
          then TKnobsCustomModule( aTabSheet.Controls[ i]).Color := aColor;
        end;
      end;
    end;


    procedure   TFormStore.SetConnectorBorders( aValue: Boolean);
    var
      i : Integer;
    begin
      if aValue <> FConnectorBorders
      then begin
        FConnectorBorders := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).UseConnectorBorders := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetConnectorTypedBorders( aValue: Boolean);
    var
      i : Integer;
    begin
      if aValue <> FConnectorTypedBorders
      then begin
        FConnectorTypedBorders := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).UseTypedConnectorBorders := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetGroupIOColor( aValue: TColor);
    begin
      if aValue <> FGroupIOColor
      then begin
        FGroupIOColor := aValue;
        ChangeTabColor( inout_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupOSCColor( aValue: TColor);
    begin
      if aValue <> FGroupOSCColor
      then begin
        FGroupOSCColor := aValue;
        ChangeTabColor( osc_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupLFOColor( aValue: TColor);
    begin
      if aValue <> FGroupLFOColor
      then begin
        FGroupLFOColor := aValue;
        ChangeTabColor( lfo_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupEnvColor( aValue: TColor);
    begin
      if aValue <> FGroupEnvColor
      then begin
        FGroupEnvColor := aValue;
        ChangeTabColor( envelope_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupFilterColor( aValue: TColor);
    begin
      if aValue <> FGroupFilterColor
      then begin
        FGroupFilterColor := aValue;
        ChangeTabColor( filter_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupSwitchColor( aValue: TColor);
    begin
      if aValue <> FGroupSwitchColor
      then begin
        FGroupSwitchColor := aValue;
        ChangeTabColor( switch_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupMixColor( aValue: TColor);
    begin
      if aValue <> FGroupMixColor
      then begin
        FGroupMixColor := aValue;
        ChangeTabColor( mixer_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupControlColor( aValue: TColor);
    begin
      if aValue <> FGroupControlColor
      then begin
        FGroupControlColor := aValue;
        ChangeTabColor( control_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupNoteColor( aValue: TColor);
    begin
      if aValue <> FGroupNoteColor
      then begin
        FGroupNoteColor := aValue;
        ChangeTabColor( note_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupMathColor( aValue: TColor);
    begin
      if aValue <> FGroupMathColor
      then begin
        FGroupMathColor := aValue;
        ChangeTabColor( math_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupLogicColor( aValue: TColor);
    begin
      if aValue <> FGroupLogicColor
      then begin
        FGroupLogicColor := aValue;
        ChangeTabColor( logic_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupSeqColor( aValue: TColor);
    begin
      if aValue <> FGroupSeqColor
      then begin
        FGroupSeqColor := aValue;
        ChangeTabColor( sequencer_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupFXColor( aValue: TColor);
    begin
      if aValue <> FGroupFXColor
      then begin
        FGroupFXColor := aValue;
        ChangeTabColor( fx_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupDelayColor( aValue: TColor);
    begin
      if aValue <> FGroupDelayColor
      then begin
        FGroupDelayColor := aValue;
        ChangeTabColor( delay_tabseet, aValue);
      end;
    end;


    procedure   TFormStore.SetGroupUtilityColor( aValue: TColor);
    begin
      if aValue <> FGroupUtilityColor
      then begin
        FGroupUtilityColor := aValue;
        ChangeTabColor( util_tabsheet, aValue);
      end;
    end;


    procedure   TFormStore.SetConnectorBorderColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FConnectorBorderColor
      then begin
        FConnectorBorderColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).ConnectorBorderColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetSelectorColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FSelectorColor
      then begin
        FSelectorColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).SelectorColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetSelectorBorderColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FSelectorBorderColor
      then begin
        FSelectorBorderColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).SelectorBorderColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetSelectorBorderColorS( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FSelectorBorderColorS
      then begin
        FSelectorBorderColorS := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).SelectorBorderColorSingle := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetDisplayColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FDisplayColor
      then begin
        FDisplayColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).DisplayColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetDisplayBorderColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FDisplayBorderColor
      then begin
        FDisplayBorderColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).DisplayBorderColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetKnobMIDIColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FKnobMIDIColor
      then begin
        FKnobMIDIColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).KnobMIDIColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetKnobFocusColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FKnobFocusColor
      then begin
        FKnobFocusColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).KnobFocusColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetKnobMIDIFocusColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FKnobMIDIFocusColor
      then begin
        FKnobMIDIFocusColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).KnobMIDIFocusColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetViewerColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FViewerColor
      then begin
        FViewerColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).ViewerColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetViewerBorderColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FViewerBorderColor
      then begin
        FViewerBorderColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).ViewerBorderColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetViewerLineColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FViewerLineColor
      then begin
        FViewerLineColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).ViewerLineColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetViewerFillColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FViewerFillColor
      then begin
        FViewerFillColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).ViewerFillColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetIndBarPeakColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FIndBarPeakColor
      then begin
        FIndBarPeakColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).IndBarPeakColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetIndBarValeyColor( aValue: TColor);
    var
      i : Integer;
    begin
      if aValue <> FIndBarValeyColor
      then begin
        FIndBarValeyColor := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).IndBarValeyColor := aValue;
        end;
      end;
    end;


    procedure   TFormStore.SetModuleOpacity( aValue: Byte);
    var
      i : Integer;
    begin
      if aValue <> FModuleOpacity
      then begin
        FModuleOpacity := aValue;

        for i := 0 to ComponentCount - 1
        do begin
          if ( Components[ i] is TKnobsCustomModule)
          then TKnobsCustomModule( Components[ i]).Opacity := aValue;
        end;
      end;
    end;


//  private

    procedure   TFormStore.DoModuleListLog( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'ModuleList (%s)', [ aMsg]);
    end;


    procedure   TFormStore.DoModuleLog( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'Module (%s)', [ aMsg]);
    end;


    procedure   TFormStore.RegisterModules;
    var
      i : Integer;
    begin
      FModules := TKnobsModuleList.Create;
      FModules.OnLog := DoModuleListLog;

      for i := 0 to ComponentCount - 1
      do begin
        if ( Components[ i] is TKnobsCustomModule)
        then begin
          TKnobsCustomModule( Components[ i]).FixDisplays;
          TKnobsCustomModule( Components[ i]).OnLog := DoModuleLog;
          TKnobsCustomModule( Components[ i]).SetTitleFont ( FTitleFont );
          TKnobsCustomModule( Components[ i]).SetModuleFont( FModuleFont);
          TKnobsCustomModule( Components[ i]).UseConnectorBorders      := ConnectorBorders;
          TKnobsCustomModule( Components[ i]).UseTypedConnectorBorders := ConnectorTypedBorders;

          FModules.Add( Components[ i]);
        end;
      end;

      FModules.RegisterComponents( True);
    end;


    procedure   TFormStore.Log( const aMsg: string);
    begin
      if Assigned( FOnDesignerLog)
      then FOnDesignerLog( Self, Format( 'designer (%s)', [ aMsg], AppLocale));
    end;


    procedure   TFormStore.LogFmt( const aFmt: string; const anArgs: array of const);
    begin
      Log( Format( aFmt, anArgs, AppLocale));
    end;


//  public

    function    TFormStore.CreateModule(
      const aWirePanel  : TKnobsWirePanel;
      const aModuleType : TKnobsModuleType;
      MustDrag          : Boolean;
      StandardColor     : Boolean
    ): TKnobsCustomModule;
    begin
      Result := Modules.CreateModule( aWirePanel, aModuleType, MustDrag, StandardColor);
    end;


    function    TFormStore.ChangeModule(
      const aWirePanel  : TKnobsWirePanel;
      var   aTarget     : TKnobsCustomModule;
      const aWantedType : TKnobsModuleType;
      aCallBack         : TKnobsOnValuedCtrlRemoved
    ): TKnobsCustomModule;
    begin
      Result := Modules.ChangeModule( aWirePanel, aTarget, aWantedType, aCallBack);
    end;


    procedure   TFormStore.PopulateSelector( const aModuleSelector: TKnobsModuleSelector; const aBitmapsFolder: string);
    begin
      Modules.PopulateSelector( aModuleSelector, aBitmapsFolder);
    end;


    procedure   TFormStore.UnpopulateSelector( const aModuleSelector: TKnobsModuleSelector);
    begin
      Modules.UnPopulateSelector( aModuleSelector);
    end;


    procedure   TFormStore.PopulateMenu( const aRootMenu: TMenuItem; const aHandler: TNotifyEvent);
    type
      TModList = TList< TKnobsCustomModule>;
      TMap     = TDictionary< string, TModList>;
      TKV      = TPair< string, TModList>;
    var
      i         : Integer;
      aMap      : TMap;
      aKey      : string;
      aList     : TModList;
      aKV       : TKV;
      aSorter   : TStringList;
      bSorter   : TStringList;
      aModule   : TKnobsCustomModule;
      aMenuItem : TMenuItem;
      bMenuItem : TMenuItem;
      anIndex   : Integer;
      bIndex    : Integer;
      aHotKey   : Char;
    begin
      if Assigned( aRootMenu) and Assigned( Modules)
      then begin
        aMap := TMap.Create;

        try
          // Collect enabled modules into aMap
          for i := 0 to Modules.Count - 1
          do begin
            if Modules[ i].Enabled
            then begin
              aKey := Modules[ i].PageName;

              if not aMap.ContainsKey( aKey)
              then begin
                aList := TModList.Create;
                aMap.Add( aKey, aList);
              end
              else aList := aMap[ aKey];

              aList.Add( Modules[ i]);
            end;
          end;

          // Create menu items from aMap, sorted
          aSorter := TStringList.Create;

          try
            aSorter.CaseSensitive := False;
            aSorter.Sorted        := True;

            // Add keys to sorter
            for aKV in aMap
            do aSorter.Add( aKV.Key);

            // Iterate over the sorted keys
            anIndex := 0;
            for aKey in aSorter
            do begin
              if anIndex >= 10
              then aHotKey := Char( anIndex + Ord( 'A') - 10)
              else aHotKey := Char( anIndex + Ord( '0'));

              aMenuItem          := TMenuItem.Create( aRootMenu);
              aMenuItem.Caption  := Format( '&%s   %s', [ aHotKey, aKey], AppLocale);
              aList              := aMap[ aKey];
              bSorter            := TStringList.Create;

              try
                // Sort the sub menu items
                bSorter.CaseSensitive := False;
                bSorter.Sorted        := True;
                bSorter.OwnsObjects   := False;

                for aModule in aList
                do bSorter.AddObject( aModule.Title, aModule);

                // Create the sub menus
                bIndex := 0;
                for i := 0 to bSorter.Count - 1
                do begin
                  aModule := TKnobsCustomModule( bSorter.Objects[ i]);

                  if aModule.ModuleType >= 0
                  then begin
                    if bIndex >= 10
                    then aHotKey := Char( bIndex + Ord( 'A') - 10)
                    else aHotKey := Char( bIndex + Ord( '0'));

                    bMenuItem         := TMenuItem.Create( aMenuItem);
                    bMenuItem.Caption := Format( '&%s   %s', [ aHotKey, aModule.Title], AppLocale);
                    bMenuItem.Tag     := aModule.ModuleType;
                    bMenuItem.OnClick := aHandler;
                    aMenuItem.Add( bMenuItem);
                    Inc( bIndex);
                  end
                end;
              finally
                bSorter.DisposeOf;
              end;

              Inc( anIndex);
              aRootMenu.Add( aMenuItem);
            end;

            for aKV in aMap
            do aKV.Value.DisposeOf;
          finally
            aSorter.DisposeOf;
          end;
        finally
          aMap.DisposeOf;
        end;
      end;
    end;

    procedure   TFormStore.ShowModule( const aModule: TKnobsCustomModule);
    var
      aTabSheet: TTabSheet;
    begin
      aTabSheet := aModule.Parent as TTabSheet;
      savedstuff_pagecontrol.ActivePage := aTabSheet;
    end;


    function    TFormStore.BitmapName( const aModuleType: TKnobsModuleType): string;
    var
      i : Integer;
    begin
      Result := '';
      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if Modules[ i].ModuleType = aModuleType
          then begin
            Result := 'TMod' + Modules[ i].Title + '.jpg';
            Break;
          end;
        end;
      end;
    end;


    function    TFormStore.CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    var
      i : Integer;
    begin
      Result := nil;

      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if Modules[ i].ModuleType = aModuleType
          then begin
            Result := Modules[ i].AsBitmap;
            Break;
          end;
        end;
      end;
    end;


    function    TFormStore.ReadModuleComment( const aModuleType: TKnobsModuleType): string;
    var
      i : Integer;
    begin
      Result := '';

      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if Modules[ i].ModuleType = aModuleType
          then begin
            Result := Modules[ i].Comment;

            if Result = ''
            then Result := Modules[ i].Title;

            if Modules[ i].AllowSignalConversion
            then Result := Result + ' [RS]';

            Break;
          end;
        end;
      end;
    end;


    procedure   TFormStore.MakeImage( const aFolder: string; const aModule: TKnobsCustomModule);
    var
      aBitmap   : TBitmap;
      aFileName : string;
      aJPeg     : TJPEGImage;
    begin
      if Assigned( aModule)
      then begin
        aFileName := aFolder + '\TMod' + aModule.Title + '.jpg';
        aBitmap := aModule.AsBitmap;

        try
          aJpeg := TJPEGImage.Create;

          try
            aJpeg.CompressionQuality  := 90;
            aJpeg.ProgressiveEncoding := True;
            aJpeg.Assign( aBitmap);
            aJpeg.Compress;
            aJpeg.SaveToFile( aFileName);
          finally
            FreeAndNil( aJpeg);
          end;
        finally
          aBitmap.DisposeOf;
        end;
      end;
    end;


    procedure   TFormStore.MakeImages( const aFolder: string);
    var
      i : Integer;
    begin
      for i := 0 to Modules.Count - 1
      do begin
        ShowModule( Modules[ i]);
        MakeImage( aFolder, Modules[ i]);
      end;
    end;


    function    TFormStore.FindBitmap( const aModuleTitle: string): TBitmap;
    var
      i : Integer;
    begin
      Result := nil;

      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if SameText( Modules[ i].Title, aModuleTitle)
          then begin
            Result := Modules[ i].Picture.Bitmap;
            Break;
          end;
        end;
      end;
    end;



    function    TFormStore.FindDocu( const aModuleTitle: string): TStrings;
    var
      i : Integer;
    begin
      Result := nil;

      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if SameText( Modules[ i].Title, aModuleTitle)
          then begin
            Result := Modules[ i].Docs;
            Break;
          end;
        end;
      end;
    end;


    function    TFormStore.DocumentModule( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    var
      aDocu     : TStrings;
      aDoc      : string;
      i         : Integer;
      First     : Boolean;
      aType     : Integer;
      RateSmart : string;
    begin
      Result := '';

      if Assigned( aModule)
      then begin
        aDocu := FindDocu( aModule.Title);

        if Assigned( aDocu)
        then begin
          First := True;

          for i := 0 to aDocu.Count - 1
          do begin
            aDoc := aDocu[ i];

            if aDoc <> ''
            then begin
              if First
              then begin
                if aModule.AllowSignalConversion
                then RateSmart := ' [this module is RateSmart <sup><a href=''#ratesmart''>[1]</a></sup> ]'
                else RateSmart := '';

                First  := False;
                aType  := aModule.ModuleType;
                Result := Result + '<a href=''#index''>index</a>';
                Result := Result + Format( '<h2><a id=''%d''>%d %s</a></h2>'^M             , [ aType, anIndex, aDoc        ], AppLocale);
                Result := Result + Format( '<h3>Page: %s</h3>'^M                           , [ aModule.PageName            ], AppLocale);
                Result := Result + Format( '<img alt=''%s'' src=''./images/TMod%s.jpg''>'^M, [ aModule.Title, aModule.Title], AppLocale);
                Result := Result + Format( '<p>Type: %d%s'^M                               , [ aType, RateSmart            ], AppLocale);
              end
              else Result := Result + Format( '%s'^M  , [ aDoc], AppLocale);
            end
            else begin
              if not First
              then Result := Result + ^M + '<p>';
            end;
          end;

          Result := Result + ^M + '<hr>'^M;
        end;
      end;
    end;


    function    TFormStore.MakeDocIndex: string;
    const
      Header    = '<tr><th>#</th><th>Page</th><th>Module type</th><th>Looks</th></tr>'^M;
      Separator = '<tr><th colspan=''4''><hr></th></tr>'^M;
    var
      i         : Integer;
      anIndex   : Integer;
      aPage     : string;
      anOldPage : string;
      aModule   : string;
      aType     : Integer;
    begin
      anOldPage := '';
      Result    := '';
      Result    := Result + '<table>'^M'<tbody>'^M;
      Result    := Result + Header;
      anIndex   := 1;

      for i := 0 to Modules.Count - 1
      do begin
        with Modules[ i]
        do begin
          aType := ModuleType;

          if ( aType >= 0) and ( Enabled)
          then begin
            aPage   := PageName;
            aModule := Title;

            if not SameText( anOldPage, aPage)
            then Result := Result + Separator;

            Result :=
              Result +
              Format(
                '<tr><td>%d</td><td>%s</td><td><a href=''#%d''>%s</a></td><td><a href=''#%d''><img alt=''%s'' src=''./images/TMod%s.jpg''></a></td></tr>'^M,
                [ anIndex, aPage, aType, aModule, aType, aModule, aModule],
                AppLocale
              );
            anOldPage := aPage;
            Inc( anIndex);
          end;
        end;
      end;

      Result := Result + '</tbody>'^M'</table>'^M;
    end;


    function    TFormStore.MakeDocHeader( const aVersion: string): string;
    begin
      Result := '';
      Result := Result + '<!doctype html>'^M'<html>'^M;
      Result := Result + '<head>'^M;
      Result := Result + '<title>WREN module documentation</title>'^M;
      Result := Result + '</head>'^M'<body>'^M;
      Result := Result + '<h1><a id=''index''>WREN module documentation</a></h1>'^M;
      Result := Result + Format( '<h3>Version : %s</h3>'^M, [ aVersion], AppLocale);
      Result := Result + '<p> COPYRIGHT 1999 - 2016 Blue Hell</p>';
      Result := Result + '<p>Look <a href=''http://bluehell.electro-music.com/modules/''>here</a> for more information.</p>'^M;
      Result := Result + MakeDocIndex;
      Result := Result + '<hr>';
    end;


    function    TFormStore.MakeDocFooter: string;
    begin
      Result := '';
      Result := Result + '<a id=''ratesmart''></a>';
      Result := Result + '<br><br>';
      Result := Result + '<sup>[1]</sup> A RateSmart module will change it''s calculation rate from control rate to audio rate when it gets connected to an audio rate output.';
      Result := Result + 'This will be indicated on the module by the connector colors changing from the control rate colors to the audio rate colors.';
      Result := Result + '<br><br>';
      Result := Result + '<p> COPYRIGHT 1999 - 2016 Blue Hell</p>';
      Result := Result + '<p>See the <a href=''http://bluehell.electro-music.com/modules/''>web site</a> for more information.</p>'^M;
      Result := Result + '<p>~~ fin ~~</p>';
      Result := Result + '</body>'^M'</html>';
    end;


    function    TFormStore.DoDocument( const aFolder, anImagesFolder, aVersion: string): string; // overload;
    var
      i       : Integer;
      anIndex : Integer;
    begin
      Result  := MakeDocHeader( aVersion);
      anIndex := 1;

      for i := 0 to Modules.Count - 1
      do begin
        if ( Modules[ i].ModuleType >= 0) and ( Modules[ i].Enabled)
        then begin
          ShowModule( Modules[ i]);
          MakeImage( aFolder + anImagesFolder, Modules[ i]);
          Result := Result + DocumentModule( Modules[ i], anImagesFolder, anIndex);
          Inc( anIndex);
        end;
      end;

      Result := Result + MakeDocFooter;
    end;


    procedure   TFormStore.Document( const aFolder, anImagesFolder, aVersion: string); // overload;
    var
      aFileName : string;
      aFile     : TextFile;
      Data      : string;
    begin
      Data := '';
      aFileName := aFolder + '\modules.html';
      AssignFile( aFile, aFileName);

      try
        Rewrite( aFile);
        Write( aFile, DoDocument( aFolder, anImagesFolder, aVersion));
      finally
        CloseFile( aFile);
      end;
    end;


    function    TFormStore.GetTabColor( const aSender: TObject; const aTabName: string; aMixColor: TColor; aMix: Byte): TColor;
    var
      i : Integer;
    begin
      Result := aMixColor;

      for i := 0 to Modules.Count - 1
      do begin
        if SameText( Modules[ i].PageName, aTabName)
        then begin
          Result := InterpolateColors( Modules[ i].Color, aMixColor, aMix);
          Break;
        end;
      end;
    end;


    function    TFormStore.DefaultModuleColor( const aModuleType: TKnobsModuleType; const aDefaultColor: TColor): TColor;
    var
      i : Integer;
    begin
      Result := aDefaultColor;

      if Assigned( Modules)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          if Modules[ i].ModuleType = aModuleType
          then begin
            Result := Modules[ i].Color;
            Break;
          end;
        end;
      end;
    end;


    procedure   TFormStore.LoadControlGlyph( const aFolder, aFile: string; aList: TImageList; anIndex: Integer);
    var
      aFileName : string;
      aBitmap   : TBitmap;
    begin
      if Assigned( aList)
      then begin
        try
          aFileName := Format( '%s\%s.bmp', [ aFolder, aFile]);

          if FileExists( aFileName)
          then begin
            aBitmap := TBitmap.Create;

            try
              aBitmap.LoadFromFile( aFileName);
              aList.Replace( anIndex, aBitmap, nil);
            finally
              aBitmap.DisposeOf;
            end;
          end;
        except
          on E: Exception
          do KilledException( E);
        end;
      end;
    end;


    procedure   TFormStore.LoadControlGlyphs( const aFolder: string);
    begin
      LoadControlGlyph( aFolder , 'skin_signaltype_normal'            , ImageListLfoOutputType         , 0);
      LoadControlGlyph( aFolder , 'skin_signaltype_inverted'          , ImageListLfoOutputType         , 1);
      LoadControlGlyph( aFolder , 'skin_signaltype_positive'          , ImageListLfoOutputType         , 2);
      LoadControlGlyph( aFolder , 'skin_signaltype_positive_inverted' , ImageListLfoOutputType         , 3);
      LoadControlGlyph( aFolder , 'skin_signaltype_negative'          , ImageListLfoOutputType         , 4);
      LoadControlGlyph( aFolder , 'skin_signaltype_negative_inverted' , ImageListLfoOutputType         , 5);

      LoadControlGlyph( aFolder , 'skin_signaltype_positive'          , ImageListEnvOutputType         , 0);
      LoadControlGlyph( aFolder , 'skin_signaltype_positive_inverted' , ImageListEnvOutputType         , 1);
      LoadControlGlyph( aFolder , 'skin_signaltype_negative'          , ImageListEnvOutputType         , 2);
      LoadControlGlyph( aFolder , 'skin_signaltype_negative_inverted' , ImageListEnvOutputType         , 3);

      LoadControlGlyph( aFolder , 'skin_shape_sine'                   , ImageListStandardWaveShapes    , 0);
      LoadControlGlyph( aFolder , 'skin_shape_tri'                    , ImageListStandardWaveShapes    , 1);
      LoadControlGlyph( aFolder , 'skin_shape_saw'                    , ImageListStandardWaveShapes    , 2);
      LoadControlGlyph( aFolder , 'skin_shape_square'                 , ImageListStandardWaveShapes    , 3);

      LoadControlGlyph( aFolder , 'skin_mute_active'                  , ImageListMuteTypes             , 0);
      LoadControlGlyph( aFolder , 'skin_mute_muted'                   , ImageListMuteTypes             , 1);
      LoadControlGlyph( aFolder , 'skin_mute_passtrough'              , ImageListMuteTypes             , 2);

      LoadControlGlyph( aFolder , 'skin_solo_off'                     , ImageListSoloTypes             , 0);
      LoadControlGlyph( aFolder , 'skin_solo_on'                      , ImageListSoloTypes             , 1);

      LoadControlGlyph( aFolder , 'skin_gate_off'                     , ImageListGateTypes             , 0);
      LoadControlGlyph( aFolder , 'skin_gate_trig'                    , ImageListGateTypes             , 1);
      LoadControlGlyph( aFolder , 'skin_gate_gate'                    , ImageListGateTypes             , 2);

      LoadControlGlyph( aFolder , 'skin_env_attack_log'               , ImageListLogLinExpSTypeAttack  , 0);
      LoadControlGlyph( aFolder , 'skin_env_attack_lin'               , ImageListLogLinExpSTypeAttack  , 1);
      LoadControlGlyph( aFolder , 'skin_env_attack_exp'               , ImageListLogLinExpSTypeAttack  , 2);
      LoadControlGlyph( aFolder , 'skin_env_attack_s'                 , ImageListLogLinExpSTypeAttack  , 3);

      LoadControlGlyph( aFolder , 'skin_env_release_log'              , ImageListLogLinExpSTypeRelease , 0);
      LoadControlGlyph( aFolder , 'skin_env_release_lin'              , ImageListLogLinExpSTypeRelease , 1);
      LoadControlGlyph( aFolder , 'skin_env_release_exp'              , ImageListLogLinExpSTypeRelease , 2);
      LoadControlGlyph( aFolder , 'skin_env_release_s'                , ImageListLogLinExpSTypeRelease , 3);

      LoadControlGlyph( aFolder , 'skin_shape_sine'                   , ImageListStandardLFOWaveShapes , 0);
      LoadControlGlyph( aFolder , 'skin_shape_tri'                    , ImageListStandardLFOWaveShapes , 1);
      LoadControlGlyph( aFolder , 'skin_shape_saw'                    , ImageListStandardLFOWaveShapes , 2);
      LoadControlGlyph( aFolder , 'skin_shape_square'                 , ImageListStandardLFOWaveShapes , 3);
      LoadControlGlyph( aFolder , 'skin_shape_random_square'          , ImageListStandardLFOWaveShapes , 4);
      LoadControlGlyph( aFolder , 'skin_shape_random'                 , ImageListStandardLFOWaveShapes , 5);
    end;


    procedure   TFormStore.CollectForthInfo( const aStringList: TStringList; aDetailInfoCallback: TOnGetForthDetailInfo);
    var
      i : Integer;
      M : TKnobsCustomModule;
      S : string;
    begin
      if Assigned( aStringList)
      then begin
        for i := 0 to Modules.Count - 1
        do begin
          M := Modules.Module[ i];
          if ( M.ModuleType >= 0) and ( M.Enabled)
          then begin
            S := Format( '    &%.5d module-spec Mod%s', [ M.ModuleType, M.Title], AppLocale);
            aStringList.Add( S);

            try
              if Assigned( aDetailInfoCallback)
              then aDetailInfoCallback( Self, M.ModuleType, aStringList);
            except
            end;
          end;
        end;
      end;
    end;


// Delphi area



procedure TFormStore.FormCreate(Sender: TObject);
begin
  FModules    := nil;
  FTitleFont  := TFont.Create;
  FModuleFont := TFont.Create;

  FTitleFont.Charset := DEFAULT_CHARSET;
  FTitleFont.Color   := clWindowText;
  FTitleFont.Style   := [ fsBold];

  if Screen.Fonts.IndexOf( 'Corbel') >= 0
  then begin
    FTitleFont.Name := 'Corbel';
    FTitleFont.Size := 8;
  end
  else begin
    FTitleFont.Name := 'Small Fonts';
    FTitleFont.Size := 7;
  end;

  FModuleFont.Charset := DEFAULT_CHARSET;
  FModuleFont.Color   := clWindowText;
  FModuleFont.Style   := [];
  FModuleFont.Name    := 'Small Fonts';
  FModuleFont.Size    := 7;

  GroupIOColor        := clSilver;
  GroupOSCColor       := clRed;
  GroupLFOColor       := clLime;
  GroupEnvColor       := clYellow;
  GroupFilterColor    := clBlue;
  GroupSwitchColor    := clFuchsia;
  GroupMixColor       := clAqua;
  GroupControlColor   := clTeal;
  GroupNoteColor      := $000080FF;
  GroupMathColor      := clWhite;
  GroupLogicColor     := clGreen;
  GroupSeqColor       := clPurple;
  GroupFXColor        := clMaroon;
  GroupDelayColor     := clTeal;
  GroupUtilityColor   := clBlack;

  RegisterModules;
  savedstuff_pagecontrol.ActivePage := inout_tabsheet;
end;


procedure TFormStore.FormDestroy(Sender: TObject);
begin
  if Assigned( FModules)
  then begin
    FModules.RegisterComponents( False);
    FModules.DisposeOf;
  end;

  FreeAndNil( FTitleFont);
  FreeAndNil( FModuleFont);
end;


end.
